<?php

namespace App\Http\Controllers;

use App\Models\KategoriSoal;
use App\Models\Paket;
use App\Models\PembahasanTryout;
use App\Models\Soal;
use Illuminate\Database\QueryException;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class PaketController extends Controller
{
    public function index($tipe)
    {
        if ($tipe === 'tryout') {
            $pakets = Paket::where('tipe', 'tryout')->orderBy('nama', 'ASC')->withCount('soals')->get();

            foreach ($pakets as $paket) {
                $paket->pembahasan_tryout;
            }
        } else {
            $pakets = Paket::where('tipe', $tipe)->withCount('soals')->get();
        }

        return response([
            "message"   => "List paket $tipe",
            "data"      => $pakets
        ], Response::HTTP_OK);
    }


    // public function show(Request $req, $id_kategori, $id)
    // {
    //     try {
    //         $paket  = Paket::findOrFail($id)->with('soals:id,soal,a,b,c,d,e,kategori')->get();
    //         return response([
    //             "message"   => "Paket $tipe $id",
    //             "data"      => $paket
    //         ], Response::HTTP_OK);
    //     } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
    //         return response([
    //             "message"   => "Paket soal tidak ditemukan"
    //         ], Response::HTTP_NOT_FOUND);
    //     }
    // }

    public function create(Request $req, $tipe)
    {
        try {

            if ($tipe === 'tryout') {
                $kode = 'to-';
            } elseif ($tipe === 'latihan') {
                $kode = 'pl-';
            } else {
                return response([
                    "message"   => "Tipe paket salah"
                ], Response::HTTP_NOT_IMPLEMENTED);
            }

            $paket                      = new Paket;
            $paket->nama                = $req->paket['nama'];
            $paket->kode                = $kode . time();
            $paket->tipe                = $tipe;

            if (isset($req->paket['video_pembahasan'])) {
                $paket->video_pembahasan    = $req->paket['video_pembahasan'];
            }

            if ($req->paket['doc_pembahasan']) {

                $paket->doc_pembahasan      = $req->paket['doc_pembahasan'];
            }
            $paket->save();

            if ($tipe === 'tryout') {
                $pembahasan = new PembahasanTryout;
                $pembahasan->paket_id = $paket->id;

                if ($req->paket['video_kt']) {
                    $pembahasan->video_kt   = $req->paket['video_kt'];
                }

                if ($req->paket['video_km']) {
                    $pembahasan->video_km   = $req->paket['video_km'];
                }

                if ($req->paket['video_ksk']) {
                    $pembahasan->video_ksk   = $req->paket['video_ksk'];
                }

                if ($req->paket['video_tbs']) {
                    $pembahasan->video_tbs   = $req->paket['video_tbs'];
                }

                $pembahasan->save();
            }

            $soal_id = [];

            foreach ($req->soals as $soal) {
                $new_soal               = new Soal;
                $new_soal->pertanyaan   = $soal["soal"];
                $new_soal->pil_a        = $soal["a"];
                $new_soal->pil_b        = $soal["b"];
                $new_soal->pil_c        = $soal["c"];
                $new_soal->pil_d        = $soal["d"];
                $new_soal->pil_e        = $soal["e"];
                $new_soal->pembahasan   = $soal["pembahasan"];
                $new_soal->jawaban   = $soal["jawaban"];
                // $new_soal->jawaban      = $soal["jawaban"];

                $jawaban    = strtolower($soal["jawaban"]);

                $kategori = KategoriSoal::where('kode', strtolower($soal["kategori"]))->first();
                $nilai_benar    = $kategori->benar;

                if (strlen($jawaban) === 1) {
                    if ($jawaban === 'a') {
                        $new_soal->poin_a = $nilai_benar;
                    } elseif ($jawaban === 'b') {
                        $new_soal->poin_b = $nilai_benar;
                    } elseif ($jawaban === 'c') {
                        $new_soal->poin_c = $nilai_benar;
                    } elseif ($jawaban === 'd') {
                        $new_soal->poin_d = $nilai_benar;
                    } else if ($jawaban === 'e') {
                        $new_soal->poin_e = $nilai_benar;
                    }
                }

                if (strlen($jawaban) > 1) {
                    if ($jawaban[0] === 'a') {
                        $new_soal->poin_a = 5;
                    } elseif ($jawaban[0] === 'b') {
                        $new_soal->poin_b = 5;
                    } elseif ($jawaban[0] === 'c') {
                        $new_soal->poin_c = 5;
                    } elseif ($jawaban[0] === 'd') {
                        $new_soal->poin_d = 5;
                    } elseif ($jawaban[0] === 'e') {
                        $new_soal->poin_e = 5;
                    }

                    if ($jawaban[1] === 'a') {
                        $new_soal->poin_a = 4;
                    } elseif ($jawaban[1] === 'b') {
                        $new_soal->poin_b = 4;
                    } elseif ($jawaban[1] === 'c') {
                        $new_soal->poin_c = 4;
                    } elseif ($jawaban[1] === 'd') {
                        $new_soal->poin_d = 4;
                    } elseif ($jawaban[1] === 'e') {
                        $new_soal->poin_e = 4;
                    }

                    if ($jawaban[2] === 'a') {
                        $new_soal->poin_a = 3;
                    } elseif ($jawaban[2] === 'b') {
                        $new_soal->poin_b = 3;
                    } elseif ($jawaban[2] === 'c') {
                        $new_soal->poin_c = 3;
                    } elseif ($jawaban[2] === 'd') {
                        $new_soal->poin_d = 3;
                    } elseif ($jawaban[2] === 'e') {
                        $new_soal->poin_e = 3;
                    }

                    if ($jawaban[3] === 'a') {
                        $new_soal->poin_a = 2;
                    } elseif ($jawaban[3] === 'b') {
                        $new_soal->poin_b = 2;
                    } elseif ($jawaban[3] === 'c') {
                        $new_soal->poin_c = 2;
                    } elseif ($jawaban[3] === 'd') {
                        $new_soal->poin_d = 2;
                    } elseif ($jawaban[3] === 'e') {
                        $new_soal->poin_e = 2;
                    }

                    if ($jawaban[4] === 'a') {
                        $new_soal->poin_a = 1;
                    } elseif ($jawaban[4] === 'b') {
                        $new_soal->poin_b = 1;
                    } elseif ($jawaban[4] === 'c') {
                        $new_soal->poin_c = 1;
                    } elseif ($jawaban[4] === 'd') {
                        $new_soal->poin_d = 1;
                    } elseif ($jawaban[4] === 'e') {
                        $new_soal->poin_e = 1;
                    }
                }

                $new_soal->kategori_soal_id     = $kategori->id;
                $new_soal->save();

                array_push($soal_id,  $new_soal->id);
            }

            $paket->soals()->syncWithoutDetaching($soal_id);


            $data = $paket::withCount('soals')->find($paket->id);


            return response([
                "message"   => "Berhasil menambah paket",
                "data"      =>  $data
            ], Response::HTTP_OK);
        } catch (QueryException $th) {
            return response([
                "message"   => "gagal menambahkan soal paket"
            ], Response::HTTP_NOT_MODIFIED);
        }
    }

    public function update(Request $req, $tipe)
    {
        try {
            $paket          = Paket::findOrFail($req->id);
            $paket->nama    = $req->nama;

            if ($req->video_pembahasan) {
                $paket->video_pembahasan    = $req->video_pembahasan;
            } else {
                $paket->video_pembahasan    = null;
            }

            if ($req->doc_pembahasan) {

                $paket->doc_pembahasan      = $req->doc_pembahasan;
            } else {
                $paket->doc_pembahasan    = null;
            }

            if ($tipe === 'tryout') {
                $pembahasan = PembahasanTryout::where('paket_id', $paket->id)->first();

                if (!$pembahasan) {

                    $pembahasan = new PembahasanTryout;
                    $pembahasan->paket_id = $paket->id;
                }

                if (isset($req->video_kt)) {
                    $pembahasan->video_kt    = $req->video_kt;
                } else {
                    $pembahasan->video_kt    = null;
                }

                if (isset($req->video_km)) {
                    $pembahasan->video_km    = $req->video_km;
                } else {
                    $pembahasan->video_km    = null;
                }

                if (isset($req->video_ksk)) {
                    $pembahasan->video_ksk    = $req->video_ksk;
                } else {
                    $pembahasan->video_ksk    = null;
                }

                if (isset($req->video_tbs)) {
                    $pembahasan->video_tbs    = $req->video_tbs;
                } else {
                    $pembahasan->video_tbs    = null;
                }

                $pembahasan->save();
            }

            $paket->save();

            if ($tipe === 'tryout') {
                $data = $paket::withCount('soals')->find($paket->id);
                $data->pembahasan_tryout;
            } else {
                $data = $paket::withCount('soals')->find($paket->id);
            }

            return response([
                "message"   => "Paket $tipe $req->id berhasil diubah",
                "data"      => $data

            ], Response::HTTP_OK);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Paket soal tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }

    public function destroy(Request $req)
    {
        try {
            $paket  = Paket::findOrFail($req->id);

            if ($paket->tipe === 'tryout') {
                try {
                    $pembahasan = $paket->pembahasan_tryout;
                    $pembahasan->delete();
                } catch (QueryException $th) {
                    return response([
                        "message"   => "Gagal menghapus pembahasan",
                        "error"     => $th
                    ], Response::HTTP_NOT_IMPLEMENTED);
                }
            }

            try {
                $soals  = $paket->soals();
                $soals->delete();
                try {
                    $paket->delete();
                } catch (QueryException $th) {
                    return response([
                        "message"   => "Gagal menghapus paket",
                        "error"     => $th
                    ], Response::HTTP_NOT_IMPLEMENTED);
                }
            } catch (QueryException $th) {
                return response([
                    "message"   => "Gagal menghapus soal",
                    "error"     => $th
                ], Response::HTTP_NOT_IMPLEMENTED);
            }

            return response([
                "message"   => "Paket $req->id berhasil dihapus"
            ], Response::HTTP_OK);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Paket soal tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }

    public function getSoalByPaket(Request $req, $kode)
    {
        try {
            $paket  = Paket::where('kode', $kode)->firstOrFail();
            $soals  = $paket->soals;

            $formated_soal                      = array();
            $formated_soal["soal"]              = array();
            $formated_soal["paket"]             = [
                "id"            => $paket->id,
                "kode"          => $paket->kode,
                "nama"          => $paket->nama,
                "pembahasan"    => [
                    "video" => $paket->video_pembahasan,
                    "doc"   => $paket->doc_pembahasan
                ],
                "jumlah_soal"   => count($soals)
            ];

            foreach ($soals as $soal) {
                $data_soal = array();
                $data_soal['id'] = $soal->id;
                $kategori = KategoriSoal::find($soal->kategori_soal_id);
                $data_soal['kategori'] = $kategori->id;
                $data_soal['kategori_nama'] = ucfirst($kategori->nama);
                $data_soal['pertanyaan'] = $soal->pertanyaan;
                $data_soal['jawaban'] = $soal->jawaban;
                $data_soal['pembahasan'] = $soal->pembahasan;

                $data_soal['pilihan'] = array(
                    "a" => [
                        "text"  => $soal->pil_a,
                        "poin"  => $soal->poin_a,
                    ],
                    "b" => [
                        "text"  => $soal->pil_b,
                        "poin"  => $soal->poin_b,
                    ],
                    "c" => [
                        "text"  => $soal->pil_c,
                        "poin"  => $soal->poin_c,
                    ],
                    "d" => [
                        "text"  => $soal->pil_d,
                        "poin"  => $soal->poin_d,
                    ],
                    "e" => [
                        "text"  => $soal->pil_e,
                        "poin"  => $soal->poin_e,
                    ]
                );

                array_push($formated_soal["soal"], $data_soal);
            }

            return response([
                "message"   => 'List soal Paket Soal $tipe ' . strtoupper($kode),
                "data"      => $formated_soal
            ]);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Paket tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }

    public function addSoal(Request $req, $kode)
    {
        // return response(["a"=>$req->jawaban]);

        try {
            $paket  = Paket::where('kode', $kode)->firstOrFail();
            $kategori = KategoriSoal::find($req->kategori);

            $soal               = new Soal;
            $soal->pertanyaan   = $req->pertanyaan;
            $soal->pil_a        = $req->pil_a;
            $soal->pil_b        = $req->pil_b;
            $soal->pil_c        = $req->pil_c;
            $soal->pil_d        = $req->pil_d;
            $soal->pil_e        = $req->pil_e;
            $soal->pembahasan   = $req->pembahasan;

            $jawaban            = strtolower($req->jawaban);
            $soal->jawaban      = $jawaban;

            $nilai_benar    = $kategori->benar;

            if (strlen($jawaban) === 1) {
                if ($jawaban === 'a') {
                    $soal->poin_a = $nilai_benar;
                } elseif ($jawaban === 'b') {
                    $soal->poin_b = $nilai_benar;
                } elseif ($jawaban === 'c') {
                    $soal->poin_c = $nilai_benar;
                } elseif ($jawaban === 'd') {
                    $soal->poin_d = $nilai_benar;
                } else if ($jawaban === 'e') {
                    $soal->poin_e = $nilai_benar;
                }
            }

            if (strlen($jawaban) > 1) {
                if ($jawaban[0] === 'a') {
                    $soal->poin_a = 5;
                } elseif ($jawaban[0] === 'b') {
                    $soal->poin_b = 5;
                } elseif ($jawaban[0] === 'c') {
                    $soal->poin_c = 5;
                } elseif ($jawaban[0] === 'd') {
                    $soal->poin_d = 5;
                } elseif ($jawaban[0] === 'e') {
                    $soal->poin_e = 5;
                }

                if ($jawaban[1] === 'a') {
                    $soal->poin_a = 4;
                } elseif ($jawaban[1] === 'b') {
                    $soal->poin_b = 4;
                } elseif ($jawaban[1] === 'c') {
                    $soal->poin_c = 4;
                } elseif ($jawaban[1] === 'd') {
                    $soal->poin_d = 4;
                } elseif ($jawaban[1] === 'e') {
                    $soal->poin_e = 4;
                }

                if ($jawaban[2] === 'a') {
                    $soal->poin_a = 3;
                } elseif ($jawaban[2] === 'b') {
                    $soal->poin_b = 3;
                } elseif ($jawaban[2] === 'c') {
                    $soal->poin_c = 3;
                } elseif ($jawaban[2] === 'd') {
                    $soal->poin_d = 3;
                } elseif ($jawaban[2] === 'e') {
                    $soal->poin_e = 3;
                }

                if ($jawaban[3] === 'a') {
                    $soal->poin_a = 2;
                } elseif ($jawaban[3] === 'b') {
                    $soal->poin_b = 2;
                } elseif ($jawaban[3] === 'c') {
                    $soal->poin_c = 2;
                } elseif ($jawaban[3] === 'd') {
                    $soal->poin_d = 2;
                } elseif ($jawaban[3] === 'e') {
                    $soal->poin_e = 2;
                }

                if ($jawaban[4] === 'a') {
                    $soal->poin_a = 1;
                } elseif ($jawaban[4] === 'b') {
                    $soal->poin_b = 1;
                } elseif ($jawaban[4] === 'c') {
                    $soal->poin_c = 1;
                } elseif ($jawaban[4] === 'd') {
                    $soal->poin_d = 1;
                } elseif ($jawaban[4] === 'e') {
                    $soal->poin_e = 1;
                }
            }
            // $req->kategori

            $soal->kategori_soal_id     = $kategori->id;
            $soal->save();


            $paket->soals()->syncWithoutDetaching([$soal->id]);

            $soal_db = Soal::find($soal->id);

            $data_soal = array();
            $data_soal['id'] = $soal_db->id;

            $data_soal['kategori'] = $kategori->id;
            $data_soal['kategori_nama'] = ucfirst($kategori->nama);
            $data_soal['pertanyaan'] = $soal_db->pertanyaan;
            $data_soal['pembahasan'] = $soal_db->pembahasan;
            $data_soal['jawaban'] = $soal_db->jawaban;

            $data_soal['pilihan'] = array(
                "a" => [
                    "text"  => $soal_db->pil_a,
                    "poin"  => $soal_db->poin_a,
                ],
                "b" => [
                    "text"  => $soal_db->pil_b,
                    "poin"  => $soal_db->poin_b,
                ],
                "c" => [
                    "text"  => $soal_db->pil_c,
                    "poin"  => $soal_db->poin_c,
                ],
                "d" => [
                    "text"  => $soal_db->pil_d,
                    "poin"  => $soal_db->poin_d,
                ],
                "e" => [
                    "text"  => $soal_db->pil_e,
                    "poin"  => $soal_db->poin_e,
                ]
            );

            return response([
                "message"   => 'berhasil menambah soal Paket Soal $tipe ' . strtoupper($kode),
                "data"      => $data_soal
            ]);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Paket tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }

    public function updateSoal(Request $req, $kode)
    {
        try {
            $soal   = Soal::findOrFail($req->id);

            $soal->pertanyaan   = $req->pertanyaan;
            $soal->pil_a        = $req->pil_a;
            $soal->pil_b        = $req->pil_b;
            $soal->pil_c        = $req->pil_c;
            $soal->pil_d        = $req->pil_d;
            $soal->pil_e        = $req->pil_e;
            $soal->pembahasan   = $req->pembahasan;

            $jawaban    = strtolower($req->jawaban);

            $soal->poin_a = 0;
            $soal->poin_b = 0;
            $soal->poin_c = 0;
            $soal->poin_d = 0;
            $soal->poin_e = 0;

            if (strlen($jawaban) === 1) {
                if ($jawaban === 'a') {
                    $soal->poin_a = 5;
                } elseif ($jawaban === 'b') {
                    $soal->poin_b = 5;
                } elseif ($jawaban === 'c') {
                    $soal->poin_c = 5;
                } elseif ($jawaban === 'd') {
                    $soal->poin_d = 5;
                } else if ($jawaban === 'e') {
                    $soal->poin_e = 5;
                }
            }

            if (strlen($jawaban) > 1) {
                if ($jawaban[0] === 'a') {
                    $soal->poin_a = 5;
                } elseif ($jawaban[0] === 'b') {
                    $soal->poin_b = 5;
                } elseif ($jawaban[0] === 'c') {
                    $soal->poin_c = 5;
                } elseif ($jawaban[0] === 'd') {
                    $soal->poin_d = 5;
                } elseif ($jawaban[0] === 'e') {
                    $soal->poin_e = 5;
                }

                if ($jawaban[1] === 'a') {
                    $soal->poin_a = 4;
                } elseif ($jawaban[1] === 'b') {
                    $soal->poin_b = 4;
                } elseif ($jawaban[1] === 'c') {
                    $soal->poin_c = 4;
                } elseif ($jawaban[1] === 'd') {
                    $soal->poin_d = 4;
                } elseif ($jawaban[1] === 'e') {
                    $soal->poin_e = 4;
                }

                if ($jawaban[2] === 'a') {
                    $soal->poin_a = 3;
                } elseif ($jawaban[2] === 'b') {
                    $soal->poin_b = 3;
                } elseif ($jawaban[2] === 'c') {
                    $soal->poin_c = 3;
                } elseif ($jawaban[2] === 'd') {
                    $soal->poin_d = 3;
                } elseif ($jawaban[2] === 'e') {
                    $soal->poin_e = 3;
                }

                if ($jawaban[3] === 'a') {
                    $soal->poin_a = 2;
                } elseif ($jawaban[3] === 'b') {
                    $soal->poin_b = 2;
                } elseif ($jawaban[3] === 'c') {
                    $soal->poin_c = 2;
                } elseif ($jawaban[3] === 'd') {
                    $soal->poin_d = 2;
                } elseif ($jawaban[3] === 'e') {
                    $soal->poin_e = 2;
                }

                if ($jawaban[4] === 'a') {
                    $soal->poin_a = 1;
                } elseif ($jawaban[4] === 'b') {
                    $soal->poin_b = 1;
                } elseif ($jawaban[4] === 'c') {
                    $soal->poin_c = 1;
                } elseif ($jawaban[4] === 'd') {
                    $soal->poin_d = 1;
                } elseif ($jawaban[4] === 'e') {
                    $soal->poin_e = 1;
                }
            }
            // $req->kategori
            $soal->kategori_soal_id     = $req->kategori;
            $soal->save();

            $soal_db = Soal::find($soal->id);

            $data_soal = array();
            $data_soal['id'] = $soal_db->id;
            $kategori = KategoriSoal::find($req->kategori);
            $data_soal['kategori'] = $kategori->id;
            $data_soal['kategori_nama'] = ucfirst($kategori->nama);
            $data_soal['pertanyaan'] = $soal_db->pertanyaan;
            $data_soal['pembahasan'] = $soal_db->pembahasan;
            $data_soal['jawaban'] = $soal_db->jawaban;

            $data_soal['pilihan'] = array(
                "a" => [
                    "text"  => $soal_db->pil_a,
                    "poin"  => $soal_db->poin_a,
                ],
                "b" => [
                    "text"  => $soal_db->pil_b,
                    "poin"  => $soal_db->poin_b,
                ],
                "c" => [
                    "text"  => $soal_db->pil_c,
                    "poin"  => $soal_db->poin_c,
                ],
                "d" => [
                    "text"  => $soal_db->pil_d,
                    "poin"  => $soal_db->poin_d,
                ],
                "e" => [
                    "text"  => $soal_db->pil_e,
                    "poin"  => $soal_db->poin_e,
                ]
            );

            return response([
                "message"   => 'Berhasil upadate soal Paket Soal $tipe ' . strtoupper($kode),
                "data"      => $data_soal
            ]);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Soal tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }

    public function destroySoal(Request $req, $kode)
    {
        try {
            $soal  = Soal::findOrFail($req->id);
            $soal->delete();

            return response([
                "message"   => "Soal berhasil dihapus"
            ], Response::HTTP_OK);
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Soal tidak ditemukan"
            ], Response::HTTP_NOT_FOUND);
        }
    }
}
