<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Database\QueryException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Symfony\Component\HttpFoundation\Response;

class ProfileController extends Controller
{
    public function ubahPassword(Request $req)
    {
        $user           = User::findOrFail(Auth::user()->id);
        $user->password  = Hash::make($req->password);

        try {
            $user->save();

            return response([
                "message"   => "Berhasil ubah password"
            ], Response::HTTP_OK);
        } catch (QueryException $th) {
            return response([
                "message"   => "Gagal ubah password",
                "error"     => $th
            ], Response::HTTP_NOT_IMPLEMENTED);
        }
    }

    public function update(Request $req)
    {
        $user           = User::findOrFail(Auth::user()->id);
        $user->nama     = strtolower($req->nama);
        $user->email     = strtolower($req->email);


        if ($req->gender) {
            $user->gender   = strtolower($req->gender);
        }

        if ($req->tgl_lahir) {
            $user->tgl_lahir    = strtolower($req->tgl_lahir);
        }

        if ($req->no_wa) {
            $user->no_wa    = strtolower($req->no_wa);
        }

        if ($req->alamat) {
            $user->alamat   = strtolower($req->alamat);
        }
        if ($req->province_id) {
            $user->province_id   = strtolower($req->province_id);
        }
        if ($req->city_id) {
            $user->city_id   = strtolower($req->city_id);
        }

        try {
            $user->save();

            return response([
                "message"   => "Berhasil ubah profile"
            ], Response::HTTP_OK);
        } catch (QueryException $th) {
            return response([
                "message"   => "Gagal ubah profile"
            ], Response::HTTP_NOT_IMPLEMENTED);
        }
    }

    public function getUser()
    {
        $user = Auth::user();

        return response([
            "message"   => "User Profile",
            "data"      => $user
        ], Response::HTTP_OK);
    }
}
