<?php

namespace App\Http\Controllers;

use App\Models\SoalLatihan;
use App\Models\UjianLatihan;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class RangkingController extends Controller
{

    // public function to(Request $req, $tryout_kode)
    // {
    //     $data = array();
    //     $data["rangking"] = array();
    //     $tryout = Tryout::where('kode', $tryout_kode)->first();
    // $tryout->kelas;

    //     $data["tryout"] = $tryout;

    //     $query_ujian = UjianTryout::with('hasil')->has('hasil')->with('user')->where('tryout_id', $tryout->id)->where("finished", "!=", "null");

    //     if (isset($req->from) && isset($req->to)) {
    //         $dt_from    = $req->from;
    //         $dt_to      = $req->to;

    //         $query_ujian->whereBetween('finished', [$dt_from, $dt_to]);
    //     }

    //     $ujian  = $query_ujian->get();

    //     $koleksi_ujian = collect($ujian);
    //     $sort_ujian = $koleksi_ujian->sortBy("finished");
    //     $grouped = $sort_ujian->groupBy('user_id');

    //     $grouped_user = $grouped->all();

    //     foreach ($grouped_user as $user) {
    //         array_push($data["rangking"], $user[0]->toArray());
    //     }

    //     $sort_ujian = collect($data["rangking"])->sortBy([
    //         fn ($a, $b) => $b['hasil']['total_nilai'] <=> $a['hasil']['total_nilai'],
    //         fn ($a, $b) => $b['hasil']['tkp_nilai'] <=> $a['hasil']['tkp_nilai'],
    //         fn ($a, $b) => $b['hasil']['tiu_nilai'] <=> $a['hasil']['tiu_nilai'],
    //         fn ($a, $b) => $b['hasil']['twk_nilai'] <=> $a['hasil']['twk_nilai'],

    //     ]);
    //     $data["rangking"] =  $sort_ujian->values()->all();

    //     return response([
    //         "data"  => $data
    //     ]);
    // }

    public function latihan(Request $req, $kode_soal)
    {
        $data = array();
        $data["rangking"] = array();
        $latihan = SoalLatihan::where('kode', $kode_soal)->first();
        $data["latihan"] = $latihan;
        $latihan->kelas;
        $query_ujian = UjianLatihan::with('hasil')->has('hasil')->with('user')->where('soal_latihan_id', $latihan->id)->where("finished", "!=", "null");

        if (isset($req->from) && isset($req->to)) {
            $dt_from    = $req->from;
            $dt_to      = $req->to;

            $query_ujian->whereBetween('finished', [$dt_from, $dt_to]);
        }

        $ujian  = $query_ujian->get();

        $koleksi_ujian = collect($ujian);
        $sort_ujian = $koleksi_ujian->sortBy("finished");

        $grouped = $sort_ujian->groupBy('user_id');

        $grouped_user = $grouped->all();

        foreach ($grouped_user as $user) {
            array_push($data["rangking"],  $user[0]->toArray());
        }
        // dd($data["rangking"]);
        $sort_ujian = collect($data["rangking"])->sortBy([
            fn ($a, $b) => $b['hasil']['total_nilai'] <=> $a['hasil']['total_nilai'],
            fn ($a, $b) => $a['hasil']['total_waktu'] <=> $b['hasil']['total_waktu'],
        ]);
        $data["rangking"] =  $sort_ujian->values()->all();

        return response([
            "data"  => $data
        ]);
    }

    public function analisisLatihan(Request $req, $kode_soal)
    {
        $data       = array();
        $latihan    = SoalLatihan::where('kode', $kode_soal)->firstOrFail();
        $data["latihan"]   = [
            "id"    => $latihan->id,
            "nama"    => $latihan->nama,
            "kode"    => $latihan->kode,
            "kelas_id"    => $latihan->kelas_id,
            "kelas"     => array(),
            "paket_id"    => $latihan->paket_id,
            "tipe"    => $latihan->tipe,
            "kategori"    => $latihan->kategori,
        ];

        $kelas      = $latihan->kelas;
        $data["latihan"]["kelas"] =  [
            "nama"  => $kelas->nama,
            "kode"  => $kelas->kode,
            "tahun"  => $kelas->tahun,
        ];

        $paket      = $latihan->paket;
        $soals      = $paket->soals;

        $data["analisis"]  = array();

        foreach ($soals as $i => $value) {
            $soal  = [
                "id"        => $value->id,
                "nomor"     => ++$i,
                "soal"      => $value->pertanyaan,
                "kategori"  => $value->kategori,
                "info"      => [
                    "benar"     => [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "salah"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "poin5"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "poin4"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "poin3"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "poin2"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "poin1"     =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ],
                    "kosong"    =>  [
                        "jml"   => 0,
                        "user"  => array()
                    ]
                ]
            ];

            array_push($data["analisis"], $soal);
        }

        foreach ($kelas->users as $key => $user) {
            $ujian  = UjianLatihan::where("user_id", $user->id)->where("soal_latihan_id", $latihan->id)->where("finished", "!=", "null")->first();

            if ($ujian) {
                $jawabans = $ujian->jawabanUjianLatihans;

                foreach ($jawabans as $i => $jawaban) {
                    $user   = [
                        "id"    => $user["id"],
                        "nama"    => $user["nama"],
                        "email"    => $user["email"],
                        "time"  => $jawaban->time
                    ];

                    if (!$jawaban->jawaban) {
                        $data["analisis"][$i]["info"]["kosong"]["jml"]++;
                        array_push($data["analisis"][$i]["info"]["kosong"]["user"], $user);
                    } else {
                        if ($soals[$i]->kategori === "tkp") {
                            if ($jawaban->nilai === 5) {
                                $data["analisis"][$i]["info"]["poin5"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["poin5"]["user"], $user);
                            } elseif ($jawaban->nilai === 4) {
                                $data["analisis"][$i]["info"]["poin4"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["poin4"]["user"], $user);
                            } elseif ($jawaban->nilai === 3) {
                                $data["analisis"][$i]["info"]["poin3"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["poin3"]["user"], $user);
                            } elseif ($jawaban->nilai === 2) {
                                $data["analisis"][$i]["info"]["poin2"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["poin2"]["user"], $user);
                            } elseif ($jawaban->nilai === 1) {
                                $data["analisis"][$i]["info"]["poin1"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["poin1"]["user"], $user);
                            }
                        } else {
                            if (strtolower($soals[$i]->jawaban) === strtolower($jawaban->jawaban)) {
                                $data["analisis"][$i]["info"]["benar"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["benar"]["user"], $user);
                            } elseif (strtolower($soals[$i]->jawaban) !== strtolower($jawaban->jawaban) && $jawaban->jawaban) {
                                $data["analisis"][$i]["info"]["salah"]["jml"]++;
                                array_push($data["analisis"][$i]["info"]["salah"]["user"], $user);
                            }
                        }
                    }
                }
            }
        }

        return response([
            "message"   => "Analisis Soal Latihan $latihan->nama",
            "data" => $data
        ], Response::HTTP_OK);
    }
}
