<?php

namespace App\Http\Controllers;

use App\Models\SoalLatihan;
use App\Models\UjianLatihan;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class ReviewController extends Controller
{
    // public function to(Request $req, $tryout_kode, $sesi)
    // {
    //     try {
    //         $tryout    = Tryout::where('kode', $tryout_kode)->firstOrFail();
    //         $paket          = $tryout->paket;

    //         try {
    //             $sesi_to       = UjianTryout::where('sesi', $sesi)->where('tryout_id', $tryout->id)->where('user_id', Auth::user()->id)->firstOrFail();

    //             if (!$sesi_to->finished) {
    //                 return response([
    //                     "message"   => "Sesi tryout belum selesai deikerjakan"
    //                 ], Response::HTTP_FORBIDDEN);
    //             }


    //             if (time() > $sesi_to->end) {
    //                 $sesi_to->finished = date("Y-m-d H:i:s", $sesi_to->end);
    //                 $sesi_to->save();
    //             }

    //             $soals          = $sesi_to->jawabanUjianTryouts;

    //             $data           = array();
    //             $data["ujian"]  = [
    //                 "id"        => $sesi_to->id,
    //                 "sesi"      => $sesi_to->sesi,
    //                 "start"     => $sesi_to->start,
    //                 "end"       => $sesi_to->end,
    //                 "finished"  => $sesi_to->finished,
    //                 "hasil"     => $sesi_to->hasil
    //             ];

    //             $data["paket"]  = [
    //                 "id"            => $paket->id,
    //                 "kode"          => $paket->kode,
    //                 "nama"          => $paket->nama,
    //                 "tipe"          => $paket->tipe,
    //                 "jumlah_soal"   => 0,
    //                 "soal"          => []
    //             ];

    //             $data["tryout"] = [
    //                 "id"            => $tryout->id,
    //                 "nama"          => $tryout->nama,
    //                 "kode"          => $tryout->kode,
    //                 "durasi"        => $tryout->durasi,
    //                 "start"         => $tryout->start,
    //                 "end"           => $tryout->end,
    //                 "tipe"          => $tryout->tipe,
    //                 "passing_grade" => [
    //                     "tiu"   => $tryout->pg_tiu,
    //                     "tkp"   => $tryout->pg_tkp,
    //                     "twk"   => $tryout->pg_twk
    //                 ]
    //             ];


    //             foreach ($soals as $soal) {
    //                 array_push($data["paket"]["soal"], [
    //                     "id"            => $soal->id,
    //                     "soal_id"       => $soal->soal->id,
    //                     "kategori"      => $soal->soal->kategori,
    //                     "pertanyaan"    => $soal->soal->pertanyaan,
    //                     "pilihan"       => [
    //                         "a" => [
    //                             "text"  => $soal->soal->pil_a,
    //                             "poin"  => $soal->soal->poin_a
    //                         ],
    //                         "b" => [
    //                             "text"  => $soal->soal->pil_b,
    //                             "poin"  => $soal->soal->poin_b
    //                         ],
    //                         "c" => [
    //                             "text"  => $soal->soal->pil_c,
    //                             "poin"  => $soal->soal->poin_c
    //                         ],
    //                         "d" => [
    //                             "text"  => $soal->soal->pil_d,
    //                             "poin"  => $soal->soal->poin_d
    //                         ],
    //                         "e" => [
    //                             "text"  => $soal->soal->pil_e,
    //                             "poin"  => $soal->soal->poin_e
    //                         ],
    //                     ],
    //                     "pembahasan"    => $soal->soal->pembahasan,
    //                     "ragu"          => $soal->ragu,
    //                     "jawaban"       => $soal->jawaban,
    //                     "kunci"         => $soal->soal->jawaban,
    //                     "nilai"         => $soal->nilai,
    //                     "time"          => $soal->time
    //                 ]);

    //                 $data["paket"]["jumlah_soal"]++;
    //             }

    //             return response([
    //                 "message"   => "Data review",
    //                 "data"  => $data
    //             ], 200);
    //         } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
    //             return response([
    //                 "message"   => "Sesi tryout tidak ditemukan"
    //             ], Response::HTTP_OK);
    //         }
    //     } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
    //         return response([
    //             "message"   => "Soal tryout tidak ditemukan"
    //         ], Response::HTTP_OK);
    //     }
    // }

    public function latihan(Request $req, $kode, $sesi)
    {
        try {
            $latihan    = SoalLatihan::where('kode', $kode)->firstOrFail();
            $paket          = $latihan->paket;

            try {
                $sesi_to       = UjianLatihan::where('sesi', $sesi)->where('soal_latihan_id', $latihan->id)->where('user_id', Auth::user()->id)->firstOrFail();

                if (!$sesi_to->finished) {
                    return response([
                        "message"   => "Sesi latihan belum selesai deikerjakan"
                    ], Response::HTTP_FORBIDDEN);
                }


                if (time() > $sesi_to->end) {
                    $sesi_to->finished = date("Y-m-d H:i:s", $sesi_to->end);
                    $sesi_to->save();
                }

                $soals          = $sesi_to->jawabanUjianLatihans;

                $data           = array();
                $data["ujian"]  = [
                    "id"        => $sesi_to->id,
                    "sesi"      => $sesi_to->sesi,
                    "start"     => $sesi_to->start,
                    "end"       => $sesi_to->end,
                    "finished"  => $sesi_to->finished,
                    "hasil"     => $sesi_to->hasil
                ];

                $data["paket"]  = [
                    "id"            => $paket->id,
                    "kode"          => $paket->kode,
                    "nama"          => $paket->nama,
                    "tipe"          => $paket->tipe,
                    "jumlah_soal"   => 0,
                    "soal"          => []
                ];

                $data["latihan"] = [
                    "id"            => $latihan->id,
                    "nama"          => $latihan->nama,
                    "kode"          => $latihan->kode,
                    "durasi"        => $latihan->durasi,
                    "start"         => $latihan->start,
                    "end"           => $latihan->end,
                    "tipe"          => $latihan->tipe,
                    "kategori"          => $latihan->kategori
                ];

                foreach ($soals as $soal) {
                    array_push($data["paket"]["soal"], [
                        "id"            => $soal->id,
                        "soal_id"       => $soal->soal->id,
                        "kategori"      => $soal->soal->kategori,
                        "pertanyaan"    => $soal->soal->pertanyaan,
                        "pilihan"       => [
                            "a" => [
                                "text"  => $soal->soal->pil_a,
                                "poin"  => $soal->soal->poin_a
                            ],
                            "b" => [
                                "text"  => $soal->soal->pil_b,
                                "poin"  => $soal->soal->poin_b
                            ],
                            "c" => [
                                "text"  => $soal->soal->pil_c,
                                "poin"  => $soal->soal->poin_c
                            ],
                            "d" => [
                                "text"  => $soal->soal->pil_d,
                                "poin"  => $soal->soal->poin_d
                            ],
                            "e" => [
                                "text"  => $soal->soal->pil_e,
                                "poin"  => $soal->soal->poin_e
                            ],
                        ],
                        "pembahasan"    => $soal->soal->pembahasan,
                        "ragu"          => $soal->ragu,
                        "jawaban"       => $soal->jawaban,
                        "kunci"         => $soal->soal->jawaban,
                        "nilai"         => $soal->nilai,
                        "time"          => $soal->time
                    ]);

                    $data["paket"]["jumlah_soal"]++;
                }

                return response([
                    "message"   => "Data review",
                    "data"  => $data
                ], 200);
            } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
                return response([
                    "message"   => "Sesi latihan tidak ditemukan"
                ], Response::HTTP_OK);
            }
        } catch (\Illuminate\Database\Eloquent\ModelNotFoundException $th) {
            return response([
                "message"   => "Soal latihan tidak ditemukan"
            ], Response::HTTP_OK);
        }
    }
}
