<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class CekRole
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next, $route)
    {
        if ($route == 'web') {
            if (Auth::user()->role !== 'admin') {
                return redirect('/');
            }

            return $next($request);
        } else if ($route == 'api') {
            if (Auth::user()->role !== 'admin') {
                return response([
                    "message"   => "Anda tidak punya hak akses"
                ], Response::HTTP_UNAUTHORIZED);
            }

            return $next($request);
        }
    }
}
