<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class CekTrial
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next, $route)
    {
        $user   = Auth::user();
        $kelas  = $user->kelas;

        if ($user->role === 'user') {
            if (count($kelas) == 1 && $kelas[0]->kode === 'trial') {
                if ($route === 'web') {
                    return redirect('/');
                } elseif ($route === 'api') {
                    return response([
                        "message"   => "Anda tidak punya hak akses"
                    ], Response::HTTP_UNAUTHORIZED);
                }
            }
        }

        return $next($request);
    }
}
