<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class SoalLatihan extends Model
{
    use HasFactory;

    protected $casts = [
        'start'         => 'timestamp',
        'end'           => 'timestamp',
        'created_at'    => 'timestamp',
        'updated_at'    => 'timestamp'
    ];

    public function kelas()
    {
        return $this->belongsTo(Kelas::class);
    }

    public function paket()
    {
        return $this->belongsTo(Paket::class);
    }

    public function kategoriSoal()
    {
        return $this->belongsTo(KategoriSoal::class);
    }

    public function ujianLatihans()
    {
        return $this->hasMany(UjianLatihan::class);
    }
}
