<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable implements MustVerifyEmail
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'nama',
        'email',
        'password',
        'alamat',
        'gender',
        'no_wa',
        'tgl_lahir',
        'role',
        'active',
        'avatar',
        'province_id',
        'city_id',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'active'            => 'boolean'
    ];

    public function kelas()
    {
        return $this->belongsToMany(Kelas::class);
    }

    // public function ujianTryouts()
    // {
    //     return $this->hasMany(UjianTryout::class);
    // }

    public function ujianLatihans()
    {
        return $this->hasMany(UjianLatihan::class);
    }
}
