<?php

namespace App\Providers;

use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Gate;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * The policy mappings for the application.
     *
     * @var array
     */
    protected $policies = [
        // 'App\Models\Model' => 'App\Policies\ModelPolicy',
    ];

    /**
     * Register any authentication / authorization services.
     *
     * @return void
     */
    public function boot()
    {
        $this->registerPolicies();

        view()->composer('*', function ($view) {
            $user = Auth::user();
            if ($user) {
                $kelas = $user->kelas;

                if ($user->role === 'user') {
                    if (count($kelas) == 1 && $kelas[0]->kode === 'trial') {
                        $trial = true;
                    }else{
                        $trial = false;
                    }
                } else {
                    $trial = false;
                }

                $view->with([
                    "trial" => $trial
                ]);
            }
        });

        //
    }
}
