<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->string('nama', 100);
            $table->enum('gender', ['laki-laki', 'perempuan'])->nullable();
            $table->date('tgl_lahir')->nullable();
            $table->string('no_wa', 14)->nullable();
            $table->text('alamat')->nullable();

            $table->char('province_id', 2)->nullable();
            $table->char('city_id', 4)->nullable();

            $table->enum('role', ['super_admin', 'admin', 'user'])->default('user');
            $table->string('avatar')->nullable();
            $table->boolean('active')->default(0);

            $table->string('email')->unique();
            $table->timestamp('email_verified_at')->nullable();
            $table->string('password');
            $table->rememberToken();
            $table->timestamps();


            $table->index('province_id');
            $table->foreign('province_id')->references('id')->on('provinces');
            $table->index('city_id');
            $table->foreign('city_id')->references('id')->on('cities');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('users');
    }
}
