<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSoalsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('soals', function (Blueprint $table) {
            $table->id();
            $table->mediumText('pertanyaan');
            $table->text('pil_a');
            $table->text('pil_b');
            $table->text('pil_c');
            $table->text('pil_d');
            $table->text('pil_e');
            $table->unsignedTinyInteger('poin_a')->nullable()->default(0);
            $table->unsignedTinyInteger('poin_b')->nullable()->default(0);
            $table->unsignedTinyInteger('poin_c')->nullable()->default(0);
            $table->unsignedTinyInteger('poin_d')->nullable()->default(0);
            $table->unsignedTinyInteger('poin_e')->nullable()->default(0);
            $table->char('jawaban', 5);
            $table->mediumText('pembahasan')->nullable();
            $table->unsignedBigInteger('kategori_soal_id');
            $table->timestamps();

            $table->index('kategori_soal_id');
            $table->foreign('kategori_soal_id')->references('id')->on('kategori_soals');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('soals');
    }
}
