<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSoalLatihansTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('soal_latihans', function (Blueprint $table) {
            $table->id();
            $table->string('nama');
            $table->string('kode', 50)->unique();
            $table->unsignedBigInteger('kelas_id')->nullable();
            $table->unsignedBigInteger('paket_id');
            $table->unsignedBigInteger('kategori_soal_id');
            $table->unsignedSmallInteger('durasi')->default(90);
            $table->dateTime('start')->nullable();
            $table->dateTime('end')->nullable();
            $table->enum('tipe', ['reguler', 'bonus']);
            $table->timestamps();

            $table->index('kelas_id');
            $table->index('paket_id');
            $table->index('kategori_soal_id');
            $table->foreign('kelas_id')->references('id')->on('kelas');
            $table->foreign('paket_id')->references('id')->on('pakets');
            $table->foreign('kategori_soal_id')->references('id')->on('kategori_soals');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('soal_latihans');
    }
}
