<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateUjianLatihansTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('ujian_latihans', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('user_id');
            $table->unsignedBigInteger('soal_latihan_id');
            $table->string('sesi', 11)->unique()->default(time());
            $table->dateTime('start')->nullable();
            $table->dateTime('end')->nullable();
            $table->dateTime('finished')->nullable();
            $table->timestamps();

            $table->index('user_id');
            $table->index('soal_latihan_id');
            $table->foreign('user_id')->references('id')->on('users');
            $table->foreign('soal_latihan_id')->references('id')->on('soal_latihans');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('ujian_latihans');
    }
}
