<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateHasilLatihansTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('hasil_latihans', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('ujian_latihan_id');

            $table->unsignedSmallInteger('jml_soal')->default(0);
            $table->unsignedSmallInteger('total_nilai');
            $table->unsignedInteger('total_waktu');

            $table->unsignedTinyInteger('benar')->nullable();
            $table->unsignedTinyInteger('salah')->nullable();
            $table->unsignedTinyInteger('kosong')->nullable();

            // $table->unsignedTinyInteger('tkp_poin5')->nullable();
            // $table->unsignedTinyInteger('tkp_poin4')->nullable();
            // $table->unsignedTinyInteger('tkp_poin3')->nullable();
            // $table->unsignedTinyInteger('tkp_poin2')->nullable();
            // $table->unsignedTinyInteger('tkp_poin1')->nullable();

            $table->timestamps();

            $table->index('ujian_latihan_id');
            $table->foreign('ujian_latihan_id')->references('id')->on('ujian_latihans');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('hasil_latihans');
    }
}
