<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSoalTryoutsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('soal_tryouts', function (Blueprint $table) {
            $table->id();
            $table->string('nama');
            $table->string('kode', 50)->unique();

            $table->unsignedBigInteger('kelas_id')->nullable();
            $table->unsignedBigInteger('paket_id');

            $table->unsignedSmallInteger('durasi_kt')->default(60);
            $table->unsignedSmallInteger('durasi_tbs')->default(60);
            $table->unsignedSmallInteger('durasi_km')->default(25);
            $table->unsignedSmallInteger('durasi_ksk')->default(15);

            $table->dateTime('start')->nullable();
            $table->dateTime('end')->nullable();

            $table->enum('tipe', ['reguler', 'bonus']);

            $table->string('kode_akses', 50)->nullable();

            $table->timestamps();

            $table->index('kelas_id');
            $table->index('paket_id');
            $table->foreign('kelas_id')->references('id')->on('kelas');
            $table->foreign('paket_id')->references('id')->on('pakets');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('soal_tryouts');
    }
}
