<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateJawabanUjianTryoutsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('jawaban_ujian_tryouts', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('ujian_tryout_id');
            $table->unsignedBigInteger('soal_id');
            $table->unsignedInteger('time')->nullable()->default(0);
            $table->boolean('ragu')->default(false);
            $table->char('jawaban')->nullable();
            $table->unsignedTinyInteger('nilai')->nullable();
            $table->timestamps();

            $table->index('ujian_tryout_id');
            $table->index('soal_id');
            $table->foreign('ujian_tryout_id')->references('id')->on('ujian_tryouts');
            $table->foreign('soal_id')->references('id')->on('soals');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('jawaban_ujian_tryouts');
    }
}
