<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateHasilTryoutsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('hasil_tryouts', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('ujian_tryout_id');

            $table->unsignedSmallInteger('jml_soal')->default(0);
            $table->unsignedSmallInteger('jml_kt')->default(0);
            $table->unsignedSmallInteger('jml_km')->default(0);
            $table->unsignedSmallInteger('jml_ksk')->default(0);
            $table->unsignedSmallInteger('jml_tbs')->default(0);

            $table->unsignedInteger('total_waktu');

            $table->unsignedTinyInteger('kt_benar');
            $table->unsignedTinyInteger('kt_salah');
            $table->unsignedTinyInteger('kt_kosong');
            $table->unsignedInteger('kt_total_waktu');

            $table->unsignedTinyInteger('km_benar');
            $table->unsignedTinyInteger('km_salah');
            $table->unsignedTinyInteger('km_kosong');
            $table->unsignedInteger('km_total_waktu');

            $table->unsignedTinyInteger('ksk_benar');
            $table->unsignedTinyInteger('ksk_salah');
            $table->unsignedTinyInteger('ksk_kosong');
            $table->unsignedInteger('ksk_total_waktu');

            $table->unsignedTinyInteger('tbs_benar');
            $table->unsignedTinyInteger('tbs_salah');
            $table->unsignedTinyInteger('tbs_kosong');
            $table->unsignedInteger('tbs_total_waktu');

            $table->timestamps();

            $table->index('ujian_tryout_id');
            $table->foreign('ujian_tryout_id')->references('id')->on('ujian_tryouts');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('hasil_tryouts');
    }
}
