Vue.component("confirm-delete", {
    props: {
        showModal: {
            type: Boolean,
            required: true,
            default: false
        },
        isDeleting: {
            type: Boolean,
            required: true,
            default: false
        }
    },
    template: `
    <div :class="{'d-none':!showModal}">
    <div class="modal fade show modal-active" tabindex="-1" role="dialog">
    <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
        <div class="modal-content">

            <div class="text-center text-danger modal-body px-3 pt-3 pb-0 d-flex flex-column">

            <div v-if="isDeleting">
                <div class="spinner">
                    <div class="rect1 bg-danger"></div>
                    <div class="rect2 bg-danger"></div>
                    <div class="rect3 bg-danger"></div>
                    <div class="rect4 bg-danger"></div>
                    <div class="rect5 bg-danger"></div>
                </div>
                <h3 class="mb-5 mt-4 text-danger text-center">
                    Sedang menghapus data..
                </h3>
            </div>

            <div v-if="!isDeleting" class="text-center d-flex flex-column">
                <span>
                        <i class="fas fa-exclamation-triangle fa-4x"></i>
                </span>
                <span class="h3 text-danger mt-4">Apakah Anda yakin ingin menghapus?</span>
            </div>
                

            </div>
            <div v-if="!isDeleting" class="modal-footer p-3 d-flex justify-content-center">
                <button :disabled="isDeleting" @click="$emit('onclose')" type="button" class="btn btn-secondary">Batal</button>
                <button :disabled="isDeleting" @click="$emit('onconfirm')" type="button" class="btn btn-danger">Hapus</button>
            </div>
        </div>
    </div>
</div>
    </div>
  

            `
});