Vue.component("image-avatar", {
    props: {
        src: {
            type: String,
            required: false
        },
        name: {
            type: String,
            required: true
        },
        bgColor: {
            type: String,
            required: false,
            default: 'bg-warning'
        },
        size: {
            type: String,
            required: false
        }
    },
    created() {
        console.log(this.src)
    },
    computed: {
        initialName() {
            let name = this.name.split(' ')
            if (name.length > 1) {
                return `${name[0].charAt(0).toUpperCase()}${name[1].charAt(0).toUpperCase()}`
            } else {
                return `${name[0].charAt(0).toUpperCase()}${name[0].charAt(1).toUpperCase()}`
            }
        },
        imageSource() {
            return this.src
        }
    },
    template:
        `
    <a href="#" class="initial-avatar" :class="[bgColor, size]" @click="$emit('click')">
        <img v-if="src" :src="imageSource">
        <span v-else class="p-3 text-center text-secondary">{{initialName}}</span>
    </a> 
    `
});