Vue.component("modal-edit-materi", {
    props: {
        showModal: {
            type: Boolean,
            required: true,
            default: false
        },
        isSubmitting: {
            type: Boolean,
            required: true,
            default: false
        },
        materi: {
            required: true
        },
        tipe: {
            required: true
        },
    },
    methods: {
        reset: function () {
            this.$refs.judul.value = this.materi.judul
            this.$refs.konten_id.value = this.materi.konten_id
        },
        confirm: function () {
            this.$emit("confirm", {
                judul: this.$refs.judul.value,
                konten_id: this.$refs.konten_id.value,
                data: this.materi
            })
        }
    },
    template: `
    <div :class="{'d-none':!showModal}">
    <div class="modal fade show modal-active" tabindex="-1" role="dialog">
    <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header py-2 px-3 align-items-center" v-if="!isSubmitting">
                <h5 class="modal-title">
                <span class="text-primary align-middle"> Edit Materi </span>
                </h5>
                <button type="button" class="close" v-on:click="$emit('close')">
                    <i class="fas fa-times-circle text-primary"></i>
                </button>
            </div>
            <div class="modal-body px-3 pt-3 pb-0 d-flex flex-column">

                <div v-if="isSubmitting">
                    <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h3 class="mt-4 mb-5 text-primary text-center">
                    Sedang menyimpan data..
                </h3>
            </div>

            <div v-if="!isSubmitting">
                <div class="form-group">
                    <label for="edit-materi-judul">Judul</label>
                    <input ref="judul" :value="materi.judul" type="text" class="form-control"
                        id="edit-materi-judul" placeholder="Masukkan judul materi">

                </div>
                <div class="form-group">
                    <label for="edit-materi-konten">
                        {{(tipe=='video')?'Youtube ID':'Document ID'}}
                    </label>
                    <input ref="konten_id" :value="materi.konten_id" type="text" class="form-control"
                        id="edit-materi-konten" placeholder="Masukkan ID">
                </div>
            </div>


            </div>
            <div class="modal-footer p-3" v-if="!isSubmitting">
                <button @click="reset" type="button" class="btn btn-secondary">Reset</button>
                <button @click="confirm" type="button" class="btn btn-primary" :disabled="!materi.judul || !materi.konten_id">Update</button>
            </div>
        </div>
    </div>
</div>
    </div>
            `
});
