@extends('layouts.app')

@section('page-title')
Bimbel DnD - Reset Password
@endsection

@section('content')
<div class="main-content">
    <!-- Header -->
    <div class="header bg-gradient-primary py-5 py-lg-6 pt-lg-9">
        <div class="container">
            <div class="header-body text-center mb-6">
                <div class="row justify-content-center">
                    <div class="col-xl-5 col-lg-6 col-md-8 px-5">
                        <h1 class="text-white">Reset Password</h1>
                        <p class="text-lead text-white">Silahkan isi form berikut untuk melakukan reset password</p>
                    </div>
                </div>
            </div>
        </div>
        <div class="separator separator-bottom separator-skew zindex-100">
            <svg x="0" y="0" viewBox="0 0 2560 100" preserveAspectRatio="none" version="1.1"
                xmlns="http://www.w3.org/2000/svg">
                <polygon class="fill-default" points="2560 0 2560 100 0 100"></polygon>
            </svg>
        </div>
    </div>
    <!-- Page content -->
    <div class="container mt--8 pb-5">

        <div class="row justify-content-center">
            <div class="col-lg-5 col-md-7">
                <div>
				@if (Session::get('status'))
                    <div class="alert alert-success alert-dismissible fade show" role="alert">
                        <div class="d-flex flex-wrap">
                            <span class="mr-2">
                                <i class="fas fa-info-circle"></i>
                            </span>
                            <span>
                                <span>
                                    Link reset password sudah dkirimkan. Silahkan cek email Anda.
                                </span>
                            </span>
                        </div>
                    </div>
                    @endif
					
                    @foreach ($errors->all() as $error)
                    <div class="alert alert-danger alert-dismissible fade show" role="alert">
                        <span class="alert-icon">
                            <i class="fas fa-exclamation-triangle"></i>
                        </span>
                        <span class="alert-text">
                            {{$error}}
                        </span>
                    </div>
                    @endforeach
                </div>
                <div class="card bg-secondary border-0 mb-0">

                    <div class="card-body px-lg-3 py-lg-3">

                        <form role="form" method="POST" action="{{ route('password.update') }}">
                            @csrf
                            <input type="hidden" name="token" value="{{ $request->route('token') }}">

                            <div class="form-group mb-3">
                                <div class="input-group input-group-merge input-group-alternative">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><i class="ni ni-email-83"></i></span>
                                    </div>
                                    <input class="form-control" value="{{old('email', $request->email)}}"
                                        placeholder="Email" type="email" name="email">
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="input-group input-group-merge input-group-alternative">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><i class="ni ni-lock-circle-open"></i></span>
                                    </div>
                                    <input name="password" class="form-control" placeholder="Password" type="password">
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="input-group input-group-merge input-group-alternative">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><i class="ni ni-lock-circle-open"></i></span>
                                    </div>
                                    <input name="password_confirmation" class="form-control"
                                        placeholder="Konfirmasi password" type="password">
                                </div>
                            </div>

                            <div class="text-right">
                                <button type="submit" class="btn btn-primary mt-4">Reset Password</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
