@extends('dashboard.components.layout')

@section('title')
Dashboard
@endsection

@section('style')
<link rel="stylesheet" href="{{ asset('assets/css/custom.css') }}" type="text/css">
<link rel="stylesheet" href="{{asset('assets/css/theme-sugar.css')}}" type="text/css" type="text/css">


@endsection

@section('page-title')
<h6 class="h2 text-white d-inline-block mb-0">
    @{{ (hasil.tryout)?hasil.tryout.nama.toUpperCase():'' }}
</h6>
@endsection

@section('breadcrumb')
<li class="breadcrumb-item text-white">
    <i class="fas fa-chart-pie"></i>
</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(1)) }}</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(2)) }}</li>
<li class="breadcrumb-item text-white">Hasil</li>
@endsection

@section('action-bar')
<div class="mt-3 d-sm-none"></div>
<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end">
    @php
    $url=url('/ujian/tryout').'/'.Request::segment(3).'/'.Request::segment(4);
    $start=url('/ujian/tryout').'/'.Request::segment(3);
    @endphp

    <a v-if="hasil.tryout.end*1000 <= Date.now()" href="{{$url.'/review'}}">
        <button class="m-1 btn btn-sm btn-neutral">Review</button>
    </a>

    <a href="{{$start.'/start'}}">
        <button class="m-1 btn btn-sm btn-neutral">Kerjakan Lagi</button>
    </a>
</div>
@endsection

@section('content')
<div id="app">
    <div class="d-flex justify-content-center" v-if="!isLoaded && isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded && !isFailed">
        <div class="row">
            <div class="col">
                <div class="card mb-0">
                    <div class="card-body text-center h1">

                        <span v-if="!hasil.nilai.lulus">
                            Maaf, Anda <span class="text-danger">TIDAK LULUS</span>
                        </span>

                        <span v-else>
                            Selamat, Anda <span class="text-primary">LULUS</span>
                        </span>

                    </div>
                </div>
            </div>

        </div>

        <div class="row">
            <div class="col-md-3 mt-4">
                <div class="card  h-100">
                    <div class="card-header text-center h2 text-primary">
                        TOTAL
                    </div>

                    <div class="card-body text-center py-0">

                        <div id="chart-total">
                            <apexchart type="donut" :options="chartTotal" :series="chartTotal.series"></apexchart>
                        </div>


                        <div class="d-flex flex-column px-4 pt-4 pb-0 h2">
                            <div class="d-flex justify-content-between px-4">
                                <span>TIU</span>
                                <span>@{{hasil.nilai.tiu.nilai}}</span>
                            </div>

                            <div class="d-flex justify-content-between px-4">
                                <span>TKP</span>
                                <span>@{{hasil.nilai.tkp.nilai}}</span>
                            </div>

                            <div class="d-flex justify-content-between px-4">
                                <span>TWK</span>
                                <span>@{{hasil.nilai.twk.nilai}}</span>
                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="col-md-3 mt-4">
                <div class="card  h-100">
                    <div class="card-header text-center h2 text-primary">
                        TIU
                    </div>
                    <div class="card-body text-center py-0">
                        <div id="chart-tiu">
                            <apexchart type="donut" :options="chartTiu" :series="chartTiu.series"></apexchart>
                        </div>

                        <div class="d-flex flex-column px-4 pt-4 pb-0 h2">
                            <div class="d-flex justify-content-between">
                                <span>BENAR</span>
                                <span>@{{hasil.nilai.tiu.info.benar}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>SALAH</span>
                                <span>@{{hasil.nilai.tiu.info.salah}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>KOSONG</span>
                                <span>@{{hasil.nilai.tiu.info.kosong}}</span>
                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="col-md-3 mt-4">
                <div class="card  h-100">
                    <div class="card-header text-center h2 text-primary">
                        TWK
                    </div>
                    <div class="card-body text-center py-0">
                        <div id="chart">
                            <apexchart type="donut" :options="chartTwk" :series="chartTwk.series"></apexchart>
                        </div>

                        <div class="d-flex flex-column px-4 pt-4 pb-0 h2">
                            <div class="d-flex justify-content-between">
                                <span>BENAR</span>
                                <span>@{{hasil.nilai.twk.info.benar}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>SALAH</span>
                                <span>@{{hasil.nilai.twk.info.salah}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>KOSONG</span>
                                <span>@{{hasil.nilai.twk.info.kosong}}</span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-md-3 mt-4">
                <div class="card h-100">
                    <div class="card-header text-center h2 text-primary">
                        TKP
                    </div>
                    <div class="card-body text-center py-0">
                        <div id="chart">
                            <apexchart type="donut" :options="chartTkp" :series="chartTkp.series"></apexchart>
                        </div>

                        <div class="d-flex flex-column px-4 pt-4 pb-0 h4">
                            <div class="d-flex justify-content-between">
                                <span>POIN 5</span>
                                <span>@{{hasil.nilai.tkp.info.poin5}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>POIN 4</span>
                                <span>@{{hasil.nilai.tkp.info.poin4}}</span>
                            </div>
                            <div class="d-flex justify-content-between">
                                <span>POIN 3</span>
                                <span>@{{hasil.nilai.tkp.info.poin3}}</span>
                            </div>
                            <div class="d-flex justify-content-between">
                                <span>POIN 2</span>
                                <span>@{{hasil.nilai.tkp.info.poin2}}</span>
                            </div>
                            <div class="d-flex justify-content-between">
                                <span>POIN 1</span>
                                <span>@{{hasil.nilai.tkp.info.poin1}}</span>
                            </div>

                            <div class="d-flex justify-content-between">
                                <span>Kosong</span>
                                <span>@{{hasil.nilai.tkp.info.kosong}}</span>
                            </div>


                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-6">
                <div class="card mt-4 h-100">
                    <div class="card-header text-center h2 text-primary">
                        PASSING GRADE
                    </div>

                    <div class="card-body text-center pb-0 px-0">
                        <div class="table-responsive">
                            <table class="table align-items-center table-flush table-hover">
                                <thead class="thead-light">
                                    <tr>
                                        <th scope="col">
                                            <h5>Kategori</h5>
                                        </th>
                                        <th scope="col">
                                            <h5>
                                                Passing Grade
                                            </h5>
                                        </th>
                                        <th scope="col">
                                            <h5>
                                                Nilai
                                            </h5>
                                        </th>
                                        <th scope="col">
                                            <h5>
                                                Keterangan
                                            </h5>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody class="list">
                                    <tr>
                                        <td scope="row">
                                            <h5>TIU</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.tiu.pg}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.tiu.nilai}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{(hasil.nilai.tiu.lulus)?'LULUS':'GAGAL'}}
                                            </h5>
                                        </td>

                                    </tr>
                                    <tr>
                                        <td scope="row">
                                            <h5>TWK</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.twk.pg}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.twk.nilai}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{(hasil.nilai.twk.lulus)?'LULUS':'GAGAL'}}
                                            </h5>
                                        </td>

                                    </tr>
                                    <tr>
                                        <td scope="row">
                                            <h5>TKP</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.tkp.pg}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.nilai.tkp.nilai}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{(hasil.nilai.tkp.lulus)?'LULUS':'GAGAL'}}
                                            </h5>
                                        </td>

                                    </tr>
                                </tbody>
                            </table>
                        </div>

                    </div>
                </div>
            </div>

            <div class="col-md-6">
                <div class="card mt-4 h-100">
                    <div class="card-header text-center h2 text-primary">
                        Informasi Durasi Pengerjaan (detik)
                    </div>

                    <div class="card-body text-center pb-0 px-0">
                        <div class="table-responsive">
                            <table class="table align-items-center table-flush table-hover">
                                <thead class="thead-light">
                                    <tr>
                                        <th scope="col">
                                            <h5>Kategori</h5>
                                        </th>
                                        <th scope="col">
                                            <h5>Durasi</h5>
                                        </th>
                                        <th scope="col">
                                            <h5>
                                                Rata-rata
                                            </h5>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody class="list">
                                    <tr>
                                        <td scope="row">
                                            <h5>Semua Soal</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.total}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.rata}}
                                            </h5>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td scope="row">
                                            <h5>TIU</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.tiu.total}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.tiu.rata}}
                                            </h5>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td scope="row">
                                            <h5>TWK</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.twk.total}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.twk.rata}}
                                            </h5>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td scope="row">
                                            <h5>TKP</h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.tkp.total}}
                                            </h5>
                                        </td>
                                        <td scope="row">
                                            <h5>
                                                @{{hasil.waktu.tkp.rata}}
                                            </h5>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>

                    </div>
                </div>
            </div>
        </div>

    </div>

</div>


@endsection

@section('script')

<script src="{{ asset('assets/js/apexcharts.js') }}"></script>
<script src="{{ asset('assets/js/vue-apexcharts.min.js') }}"></script>
<script src="{{ asset('assets/js/axios.js') }}"></script>

<script>
    let base_url = "{{ env('APP_URL') }}/api/ujian/tryout"
    let kode_tryout = "/{{Request::segment(3)}}"
    let sesi = "/{{Request::segment(4)}}"
    let ujian_url = base_url + kode_tryout + sesi

    Vue.use(VueApexCharts)
    Vue.component('apexchart', VueApexCharts)

    var app = new Vue({
        el: '#panel',
        data: {
            isFailed: false,
            isLoaded: false,
            isTimeUp: false,
            hasil: {},
            series: [446, 64],
            chartOptions: {
                chart: {
                    type: 'donut',
                },
                plotOptions: {
                    pie: {
                        donut: {
                            labels: {
                                show: true,
                                name: {
                                    show: true,
                                    fontSize: "22px",
                                    fontFamily: "Rubik",
                                    color: "#dfsda",
                                    offsetY: -10
                                },
                                value: {
                                    show: true,
                                    fontSize: "16px",
                                    fontFamily: "Helvetica, Arial, sans-serif",
                                    color: undefined,
                                    offsetY: 16,
                                    formatter: function(val) {
                                        return val;
                                    }
                                },
                                total: {
                                    show: true,
                                    label: "Total",
                                    color: "#373d3f",

                                }
                            }
                        }
                    }
                },

                labels: ['Dijawab', 'Salah/ Kosong'],
                colors: ['#5e72e4', '#f5365c'],
                legend: false,
                dataLabels: {
                    enabled: false
                }
            },

        },
        methods: {
            async initialLoad() {
                await axios.get(ujian_url + "/hasil")
                    .then(
                        (resp) => {
                            Vue.set(this, 'hasil', resp.data.data)

                            this.isLoaded = true
                        },
                        (error) => {

                        }
                    );
            }
        },
        computed: {
            chartTotala() {
                const hasil = this.hasil
                const nilai = hasil.nilai
                const max_nilai = hasil.jumlah.soal * 5
                const warna = (nilai.lulus) ? "#5e72e4" : "#f5365c"

                let data = {
                    series: [Math.round(nilai.total / max_nilai * 100)],
                    chart: {
                        type: 'radialBar',
                        height: 350,
                    },
                    plotOptions: {
                        radialBar: {
                            dataLabels: {
                                name: {
                                    show: true,
                                    color: warna,
                                    offsetY: -15,
                                },
                                value: {
                                    show: true,
                                    fontSize: '2.2rem',
                                    offsetY: 5,
                                    color: warna,
                                    formatter: function(val) {
                                        return nilai.total
                                    }
                                },

                            }
                        }
                    },

                    labels: ['Total'],
                    colors: [warna],
                    legend: false,
                    dataLabels: {
                        enabled: false
                    }
                }
                return data
            },
            chartTotal() {
                const hasil = this.hasil
                const nilai = hasil.nilai
                const max_nilai = hasil.jumlah.soal * 5
                const warna = (nilai.lulus) ? "#5e72e4" : "#f5365c"

                let data = {
                    series: [nilai.total, max_nilai - nilai.total],
                    chart: {
                        type: 'donut',
                    },
                    plotOptions: {
                        pie: {
                            donut: {
                                size: '75%',
                                labels: {
                                    show: true,
                                    name: {
                                        show: true,
                                        color: warna,
                                        offsetY: -15
                                    },
                                    value: {
                                        show: true,
                                        color: warna,
                                        offsetY: 5,
                                        fontSize: '2.3rem',
                                        formatter: function(val) {
                                            return val;
                                        }
                                    },
                                    total: {
                                        show: true,
                                        label: "Total",
                                        color: warna,
                                        formatter: function() {
                                            return nilai.total
                                        }

                                    }
                                }
                            }
                        }
                    },
                    labels: ['Total', 'Kosong'],
                    colors: [warna, '#ced4da'],
                    legend: false,
                    dataLabels: {
                        enabled: false
                    }
                }

                return data
            },
            chartTiu() {
                const hasil = this.hasil
                const nilai = hasil.nilai.tiu.info

                let data = {
                    series: [nilai.benar, nilai.salah, nilai.kosong],
                    chart: {
                        type: 'donut',
                    },
                    plotOptions: {
                        pie: {
                            donut: {
                                size: '75%',
                                labels: {
                                    show: true,
                                    name: {
                                        show: true,
                                        offsetY: -15
                                    },
                                    value: {
                                        show: true,
                                        offsetY: 5,
                                        fontSize: '2.3rem',
                                        formatter: function(val) {
                                            return val;
                                        }
                                    },
                                    total: {
                                        show: true,
                                        label: "Total",
                                        color: null,
                                        formatter: function() {
                                            return hasil.nilai.tiu.nilai;
                                        }

                                    }
                                }
                            }
                        }
                    },
                    labels: ['Benar', 'Salah', 'Kosong'],
                    colors: ['#5e72e4', '#f5365c', '#fb6340'],
                    legend: false,
                    dataLabels: {
                        enabled: false
                    }
                }

                return data
            },
            chartTwk() {
                const hasil = this.hasil
                const nilai = hasil.nilai.twk.info

                let data = {
                    series: [nilai.benar, nilai.salah, nilai.kosong],
                    chart: {
                        type: 'donut',
                    },
                    plotOptions: {
                        pie: {
                            donut: {
                                size: '75%',
                                labels: {
                                    show: true,
                                    name: {
                                        show: true,
                                        offsetY: -15
                                    },
                                    value: {
                                        show: true,
                                        offsetY: 5,
                                        fontSize: '2.3rem',
                                        formatter: function(val) {
                                            return val;
                                        }
                                    },
                                    total: {
                                        show: true,
                                        label: "Total",
                                        color: null,
                                        formatter: function() {
                                            return hasil.nilai.twk.nilai;
                                        }

                                    }
                                }
                            }
                        }
                    },
                    labels: ['Benar', 'Salah', 'Kosong'],
                    colors: ['#5e72e4', '#f5365c', '#fb6340'],
                    legend: false,
                    dataLabels: {
                        enabled: false
                    }
                }

                return data
            },
            chartTkp() {
                const hasil = this.hasil
                const nilai = hasil.nilai.tkp.info

                let data = {
                    series: [nilai.poin5, nilai.poin4, nilai.poin3, nilai.poin2, nilai.poin1, nilai.kosong],
                    chart: {
                        type: 'donut',
                    },
                    plotOptions: {
                        pie: {
                            donut: {
                                size: '75%',
                                labels: {
                                    show: true,
                                    name: {
                                        show: true,
                                        offsetY: -15
                                    },
                                    value: {
                                        show: true,
                                        offsetY: 5,
                                        fontSize: '2.3rem',
                                        formatter: function(val) {
                                            return val;
                                        }
                                    },
                                    total: {
                                        show: true,
                                        label: "Total",
                                        color: null,
                                        formatter: function() {
                                            return hasil.nilai.tkp.nilai;
                                        }

                                    }
                                }
                            }
                        }
                    },
                    labels: ['Poin 5', 'Poin 4', 'Poin 3', 'Poin 2', 'Poin 1', 'Kosong'],
                    colors: ['#5e72e4', '#2dce89', '#11cdef', '#fb6340', '#f5365c', '#172b4d'],
                    legend: false,
                    dataLabels: {
                        enabled: false
                    }
                }

                return data
            }
        },
        created: function() {
            this.isLoaded = false
            this.initialLoad()

        }
    })
</script>
@endsection
