@extends('dashboard.components.layout')

@section('title')
Dashboard
@endsection

@section('style')
<link rel="stylesheet" href="../../assets/css/theme-sugar.css" type="text/css">
<link rel="stylesheet" href="../../assets/vendor/vue-select/vue-select.css" type="text/css">

{{-- <style>
        .overlay-container {
            position: relative;
        }

        .overlay-image {
            opacity: 1;
            display: block;

            transition: .5s ease;
            backface-visibility: hidden;
        }

        .overlay-middle {
            transition: .5s ease;
            opacity: 0;
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            -ms-transform: translate(-50%, -50%);
            text-align: center;
        }

        .overlay-container:hover .overlay-image {
            opacity: 0.3;
        }

        .overlay-container:hover .overlay-middle {
            opacity: 1;
        }

        .overlay-text {
            background-color: #4CAF50;
            color: white;
            font-size: 16px;
            padding: 16px 32px;
        }

    </style> --}}

@endsection

@section('search-box')
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':search.value||search.focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @@blur.self="search.focus = false" @@click="search.focus=true" v-model="search.value"
                class="form-control" placeholder="Cari materi" type="text">

            <div v-if="search.value" class="input-group-append mr-2 d-none d-md-flex" @@click="search.value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="search.value" @@click="search.value =  ''" class="input-group-text pr-0 pl-2"><i
                        class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
    {{-- <button class="close ml-0 px-0 mr-1" data-target="#navbar-search-main"
            aria-label="Close">
            <i class="fas fa-times text-default" data-action="search-close"></i>
        </button> --}}
</div>
@endsection

@section('page-title')
<h6 class="h2 text-white d-inline-block mb-0">{{ strtoupper(Request::segment(3)) }}</h6>
@endsection

@section('breadcrumb')
<li class="breadcrumb-item text-white">
    @if (strtolower(Request::segment(2)) == 'video')
    <i class="fas fa-play"></i>
    @endif

    @if (strtolower(Request::segment(2)) == 'text')
    <i class="fas fa-book"></i>
    @endif
</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(1)) }}</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(2)) }}</li>
<li class="breadcrumb-item text-white">{{ strtoupper(Request::segment(3)) }}</li>
@endsection

@section('action-bar')
<div v-if="isLoaded && !isFailed" class="d-none" :class="{'d-block':isLoaded && !isFailed}">
    @if (Auth::user()->role == 'admin')
    <a href="#" class="m-1 btn btn-sm btn-neutral" @@click="modal.tambah.show=true">Tambah</a>

    @if (strtolower(Request::segment(3) != 'fokus-tiu'))
    <a href="#" class="m-1 btn btn-sm btn-neutral" @@click="excel.modal=true">Import</a>

    <div class="dropdown">
        <button class="m-1 btn btn-sm btn-neutral dropdown-toggle" type="button" id="dropdownMenuButton"
            data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Export
        </button>
        <div class="dropdown-menu" style="min-width: 10rem" aria-labelledby="dropdownMenuButton">

            <download-excel :fetch="getAllMateri"
                :name="'Export Materi '+new Date().toLocaleString().replace(/\//g, '-')">
                <a class="dropdown-item" href="#">Semua Materi</a>
            </download-excel>

            <download-excel :data="materi.data"
                :name="'Export {{ ucfirst(Request::segment(1)) . ' ' . ucfirst(Request::segment(2)) . ' ' . strtoupper(Request::segment(3)) }} '+new Date().toLocaleString().replace(/\//g, '-')">
                <a class="dropdown-item" href="#">Materi ini
                    saja</a>
            </download-excel>

            <download-excel :data="excel.format" :name="'Template Materi'">
                <a class="dropdown-item" href="#">Template</a>
            </download-excel>
        </div>
    </div>
    @endif


    @endif

    <a href="#" class="m-1 btn btn-sm btn-neutral" @@click="sort.show=true">Urutkan</a>
</div>
@endsection

@section('content')
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed"
        :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div id="materi-area" class="card mb-0">
            @if (strtolower(Request::segment(2)) != 'text' && strtolower(Request::segment(2)) != 'video')
            <div class="card-body px-3 pb-0 pt-3">
                <div class="text-center text-danger m-4">
                    <i class="fas fa-exclamation-triangle fa-6x"> </i>
                    <h2 class="text-danger mt-4">Tipe materi '{{ strtolower(Request::segment(2)) }}' tidak
                        ditemukan.
                        Pastikan Anda memasukan URL yang benar.</h2>
                </div>
            </div>

            @else
            <div class="card-body px-3 pb-0 pt-3">
                <div v-if="!pagePaginated.total" class="row">
                    <div class="col align-self-center">
                        <div v-if="search.value"
                            class="h2 text-danger text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="far fa-sad-tear fa-4x mb-2"></i></span>
                            <p class="display-1 w-900 mb-0"></i> 404 - Not Found</p>

                            <span class="h3 text-default mb-4">Materi yang Anda cari tidak ditemukan</span>

                            <button @@click="search.value=''" class="btn btn-outline-primary">
                                Hapus Pencarian
                            </button>

                        </div>

                        <div v-if="!search.value"
                            class="h2 text-danger text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="far fa-sad-tear fa-4x mb-2"></i></span>
                            <p class="display-1 w-900 mb-0"></i> 404 - Not Found</p>

                            <span class="h3 text-default mb-4">Materi belum tersedia</span>

                        </div>
                    </div>
                </div>

                <div v-else class="row">
                    @if (strtolower(Request::segment(2)) == 'text')
                    <div class="col-sm-6 col-md-3" v-for="(pdf, index) in pagePaginated.data" :key="index">
                        <div class="card mb-3 div-hover">
                            <a :href="'https://drive.google.com/file/d/'+pdf.konten_id+'/view?usp=sharing'"
                                target="_blank" rel="noopener noreferrer">
                                <div class="overlay-container">
                                    <img onerror="this.src='{{ url('/assets/img/materi/default-document.png') }}';"
                                        class="overlay-image card-img-top img-fluid"
                                        :src="'https://lh3.google.com/u/0/d/'+pdf.konten_id+'=w240-h135-p-k-nu-iv1'"
                                        width="400" height="225">
                                    <div class="overlay-middle">
                                        <button type="button" class="btn btn-primary btn-icon">
                                            <span class="btn-inner--icon"><i class="fas fa-book"></i></span>
                                            <span class="btn-inner--text">Open</span>
                                        </button>
                                    </div>
                                </div>

                                <div class="card-body p-2">
                                    <h6 class="h4 card-title mb-0 text-primary text-truncate">
                                        @{{ pdf . judul }}
                                    </h6>
                                    <small class="text-muted h6">Uploaded at
                                        @{{ unixToDateTime(pdf . created_at) }}</small>
                                </div>
                            </a>
                            <!-- set a width on the image otherwise it will expand to full width       -->

                            @if (Auth::user()->role == 'admin')
                            <footer-materi @@delete="showDeleteConfirmation(pdf)" @@edit="showUpdateModal(pdf)">
                            </footer-materi>
                            @endif
                        </div>
                        <!-- /.card -->
                    </div>
                    @elseif (strtolower(Request::segment(2)) == 'video')
                    <modal-video v-if="modal.show" :judul="modal.video.judul" :youtube_id="modal.video.konten_id"
                        v-on:close="closeModal">
                    </modal-video>
                    <div class="col-sm-6 col-md-3" v-for="(video, index) in pagePaginated.data" :key="index">
                        <div class="card mb-3">

                            <div class="div-hover" v-on:click="showModal(index)">
                                <div class="img-embed-container overlay-container">
                                    <img class="overlay-image card-img-top img-fluid"
                                        :src="'https://img.youtube.com/vi/'+video.konten_id+'/sddefault.jpg'"
                                        width="400" height="300">
                                    <div class="overlay-middle">
                                        <button type="button" class="btn btn-youtube btn-icon">
                                            <span class="btn-inner--icon"><i class="fab fa-youtube"></i></span>
                                            <span class="btn-inner--text">Play</span>
                                        </button>
                                    </div>
                                </div>
                                <div class="card-body p-2">
                                    <h6 class="h4 card-title mb-0 text-primary text-truncate">
                                        @{{ video . judul . toUpperCase() }}
                                    </h6>
                                    <small class="text-muted h6">Uploaded at
                                        @{{ unixToDateTime(video . created_at) }}</small>
                                </div>
                            </div>
                            <!-- set a width on the image otherwise it will expand to full width       -->

                            @if (Auth::user()->role == 'admin')
                            <footer-materi @@delete="showDeleteConfirmation(video)" @@edit="showUpdateModal(video)">
                            </footer-materi>
                            @endif

                        </div>
                        <!-- /.card -->
                    </div>
                    @endif
                </div>
            </div>

            <div v-if="sortedMateri.length > pagination.perPage">
                <div id="pagination" class="card-footer">
                    <paginate :value="pagination.current" :page-count="pagination.numPages" :page-range="3"
                        :click-handler="onPageChange" :prev-text="''" :next-text="''"
                        :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'"
                        :page-link-class="'page-link btn-sm'" :prev-class="'page-item'"
                        :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'"
                        :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''"
                        :break-view-link-class="'fas fa-ellipsis-h'">
                    </paginate>
                </div>
            </div>
            @endif

        </div>

        <div v-if="sort.show" class="d-none" :class="{'d-block':sort.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Urutkan Materi </span>
                            </h5>
                            <button type="button" class="close" @@click="sort.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <select v-model="sort.by" class="custom-select mb-3">
                                <option disabled value="">Urutkan Bersarkan</option>
                                <option value="judul">Judul Materi</option>
                                <option value="created_at">Tanggal Upload</option>
                            </select>
                            <div class="custom-control custom-radio custom-control-inline">
                                <input v-model="sort.order" type="radio" id="ascending" name="order"
                                    class="custom-control-input" value="asc">
                                <label class="custom-control-label" for="ascending">Ascending</label>
                            </div>
                            <div class="custom-control custom-radio custom-control-inline">
                                <input v-model="sort.order" type="radio" id="descending" name="order"
                                    class="custom-control-input" value="desc">
                                <label class="custom-control-label" for="descending">Descending</label>
                            </div>
                        </div>
                        <div class="modal-footer p-3">
                            <button @@click="resetSort" type="button" class="btn btn-secondary"
                                data-dismiss="modal">Reset</button>
                            <button @@click="sort.show=false" type="button" class="btn btn-primary">Tutup</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="modal.tambah.show" class="d-none" :class="{'d-block':modal.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!modal.tambah.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Tambah Materi </span>
                            </h5>
                            <button type="button" class="close" @@click="modal.tambah.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <div v-if="modal.tambah.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>

                            <div v-if="!modal.tambah.isSubmitting">
                                <div class="form-group">
                                    <label for="add-materi-judul">Judul</label>
                                    <input v-model="modal.tambah.judul" type="text" class="form-control"
                                        id="add-materi-judul" placeholder="Masukkan judul materi">

                                </div>
                                <div class="form-group">
                                    <label for="add-materi-konten">
                                        @if (strtolower(Request::segment(2)) == 'video')
                                        Youtube ID
                                        @endif
                                        @if (strtolower(Request::segment(2)) == 'text')
                                        Document ID
                                        @endif
                                    </label>
                                    <input v-model="modal.tambah.konten_id" type="text" class="form-control"
                                        id="add-materi-konten" placeholder="Masukkan ID">
                                </div>

                                <div class="form-group">
                                    <label for="pilih-kelas">
                                        Pilih Kelas
                                    </label>
                                    <v-select id="pilih-kelas" label="nama" multiple
                                        v-model="modal.tambah.select.selected" :options="modal.tambah.select.kelas" />

                                </div>
                            </div>
                        </div>
                        <div v-if="!modal.tambah.isSubmitting" class="modal-footer p-3">
                            <button @@click="resetFormTambah" type="button" class="btn btn-secondary"
                                data-dismiss="modal"
                                :disabled="(!modal.tambah.judul && !modal.tambah.konten_id) || modal.tambah.isSubmitting">Reset</button>
                            <button @@click="submitMateri" type="button" class="btn btn-primary"
                                :disabled="(!modal.tambah.judul || !modal.tambah.konten_id) || modal.tambah.isSubmitting">Tambah</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="excel.modal" class="d-block" :class="{'d-block':excel.modal}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!modal.tambah.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">Import </span>
                            </h5>
                            <button type="button" class="close" @@click="excel.modal = false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <div v-if="!excel.isUploading">

                                <div @@click="openFile" class="d-flex justify-content-center div-hover p-3"
                                    style="cursor: pointer;">

                                    <input @@change="onFileChange" accept=".xls, .xlsx" type="file" ref="file"
                                        class="d-none">
                                    <span>
                                        <div class="d-flex flex-column">
                                            <div class="d-flex justify-content-center">
                                                <i v-if="excel . name" class="text-primary fas fa-file-excel fa-4x"></i>

                                                <i v-if="!excel . name" style="color: #ced4da ;"
                                                    class="fas fa-file-medical fa-4x"></i>

                                            </div>
                                            <div class="flex justify-content-around">
                                                <small class="h5 mt-2">
                                                    @{{ !excel . name ? 'Klik disini untuk memilih file' : excel . name }}
                                                </small>
                                            </div>
                                        </div>
                                    </span>
                                </div>

                            </div>

                            <div class="d-none" :class="{'d-block':excel.isUploading}" v-if="excel.isUploading">
                                <div class="card-body text-center pt-0">
                                    <div class="spinner my-2">
                                        <div class="rect1 bg-primary"></div>
                                        <div class="rect2 bg-primary"></div>
                                        <div class="rect3 bg-primary"></div>
                                        <div class="rect4 bg-primary"></div>
                                        <div class="rect5 bg-primary"></div>
                                    </div>
                                    <h4 class="mt-4 text-primary">
                                        Sedang menyimpan data..
                                    </h4>
                                </div>
                            </div>

                        </div>
                        <div v-if="!excel.isUploading" class="modal-footer p-3">
                            <button @@click="resetExcel" type="button" class="btn btn-secondary" data-dismiss="modal"
                                :disabled="(!excel.name && excel.data) || excel.isUploading">Reset</button>
                            <button @@click="uploadExcel" type="button" class="btn btn-primary"
                                :disabled="(!excel.name || !excel.data) || excel.isUploading">Upload</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <confirm-delete v-if="modal.delete.show" :show-modal="modal.delete.show" :is-deleting="modal.delete.isDeleting"
            @@onclose="closeDeleteConfirmation" @@onconfirm="deleteMateri">
        </confirm-delete>

        <modal-edit-materi v-if="modal.edit.show" :tipe="modal.edit.data.tipe" :show-modal="modal.edit.show"
            :is-submitting="modal.edit.isSubmitting" :materi="modal.edit.data" @@close="closeEditModal"
            @@confirm="updateMateri" />
    </div>
</div>

@endsection

@section('script')

<script src="../../assets/js/axios.js"></script>
<script src="../../assets/js/vue-toast-notification.js"></script>

<script src="../../assets/js/vue/modal-video.js"></script>
<script src="../../assets/js/vue/confirm-delete.js"></script>
<script src="../../assets/js/vue/footer-materi.js"></script>
<script src="../../assets/js/vue/modal-edit-materi.js"></script>

<script src="../../assets/js/vue-paginate.js"></script>
<script src="../../assets/vendor/vue-select/vue-select.js"></script>

<script src="../../assets/js/vue-json-excel.umd.js"></script>
<script src="../../assets/js/xlsx.core.min.js"></script>
<script src="../../assets/js/jszip.js"></script>

<script>
    let konten_url = "{{ env('APP_URL') }}/api/{{ Request::path() }}"
    let base_url = "{{ env('APP_URL') }}/api/materi"


    Vue.use(XLSX)
    Vue.use(VueToast);

    Vue.component('download-excel', JsonExcel)
    Vue.component('paginate', VuejsPaginate)
    Vue.component('v-select', VueSelect.VueSelect);


    var app = new Vue({
        el: '#panel'
        , data: {
            excel: {
                modal: false
                , name: ''
                , data: []
                , isUploading: false
                , format: [{
                    judul: 'Masukan judl materi. Maksimal 100 karakter.'
                    , tipe: 'Masukkan salah satu tipe berikut [video, text]'
                    , kategori: 'Masukkan salah satu kateghori berikut [twk, tiu, tkp]'
                    , konten_id: `Silahkan isi dengan YouTube ID (jika tipe materi adalah video) atau Google Drive File ID (jika tipe materi adalah text).
                                                                                                Contoh Youtube ID:
                                                                                                Link: https://www.youtube.com/watch?v=mc8wb4RVU1Y
                                                                                                ID: mc8wb4RVU1Y

                                                                                                Google Drive File ID:
                                                                                                Link: https://drive.google.com/file/d/1KD9jU6Nh187JLw5zjAVoTOUiP18lDkxT/view?usp=sharing
                                                                                                ID: 1KD9jU6Nh187JLw5zjAVoTOUiP18lDkxT
                                                                                                `
                , }]
                , all: []
            }
            , pagination: {
                current: 1
                , total: 0
                , perPage: 8
                , numPages: 0
            }
            , search: {
                value: ''
                , focus: false
            }
            , modal: {
                tambah: {
                    show: false
                    , judul: ''
                    , konten_id: ''
                    , isSubmitting: false
                    , select: {
                        kelas: [{
                            id: 1
                            , nama: "fokus tiu feb"
                            , kode: "2021-fokus-tiu-feb"
                            , tahun: 2021
                            , created_at: "2021-02-10T00:00:15.000000Z"
                            , updated_at: "2021-02-10T00:00:15.000000Z"
                            , users_count: 1
                        }]
                        , selected: []
                    }
                }
                , edit: {
                    show: false
                    , data: {}
                    , isSubmitting: false
                }
                , delete: {
                    show: false
                    , isDeleting: false
                    , data: {}
                },

                show: false
                , video: {}
            }
            , sort: {
                show: false
                , by: 'judul'
                , order: 'asc'
            }
            , isFailed: false
            , isLoaded: false
            , materi: {
                data: []
            }
        }
        , methods: {
            openFile() {
                this.$refs.file.click()
            }
            , onFileChange(e) {

                var files = e.target.files || e.dataTransfer.files;
                if (!files.length)
                    return;

                this.excel.tempName = files[0].name

                this.readExcel(files[0]);
            }
            , readExcel(file) {
                let reader = new FileReader();

                reader.onload = function(e) {

                    this.excelToJson(e.target.result)

                }.bind(this);

                reader.readAsBinaryString(file);
            }
            , excelToJson(file) {
                this.excel.name = this.excel.tempName;

                let workbook = XLSX.read(file, {
                    type: 'binary'
                });

                let firstSheet = workbook.SheetNames[0];

                let excelRows = XLSX.utils.sheet_to_row_object_array(workbook.Sheets[firstSheet]);

                if (!excelRows || excelRows.length == 0) {
                    this.resetExcel()
                    this.showToast('File excel tidak boleh kosong!', 'error')

                } else if (Object.keys(excelRows[0])[0] != 'judul' && Object.keys(excelRows[0])[1] != 'tipe' &&
                    Object.keys(excelRows[0])[2] != 'kategori' && Object.keys(excelRows[0])[3] != 'konten_id') {
                    this.resetExcel()
                    this.showToast('Format template salah!', 'error')
                } else {
                    this.excel.data = excelRows
                    this.showToast('File excel siap di-upload!', 'info')
                }

            }
            , resetExcel() {
                this.excel.data = []
                this.excel.name = ''
                this.tempName = ''
            }
            , uploadExcel() {
                this.excel.isUploading = true
                let excel = this.excel.data

                setTimeout(() => {
                    axios
                        .post(base_url + "/array", {
                            data: excel
                        })
                        .then((response) => {
                            let newMateri = response.data.data.filter(e => e.tipe ==
                                '{{ Request::segment(2) }}' && e.kategori ==
                                '{{ Request::segment(3) }}');

                            this.materi.data = this.materi.data.concat(newMateri)

                            this.showToast(
                                `Berhasil menambah ${response.data.data.length} data materi`
                                , 'info'
                            )
                            this.excel.isUploading = false
                            this.resetExcel()

                        }, (error) => {

                            this.showToast('Gagal menambah data materi', 'error')

                            this.resetExcel()
                            this.excel.isUploading = false
                        })
                }, 1000);
            }
            , async getAllMateri() {
                const resp = await axios.get(base_url)
                return resp.data.data
            }
            , onPageChange(page) {
                this.pagination.current = page;
            }
            , paginator(items, current_page, per_page_items) {
                let page = current_page || 1
                    , per_page = per_page_items || 8
                    , offset = (page - 1) * per_page,

                    paginatedItems = items.slice(offset).slice(0, per_page_items)
                    , total_pages = Math.ceil(items.length / per_page);

                this.pagination.numPages = total_pages
                // this.pagination.data = paginatedItems

                return {
                    total: items.length
                    , data: paginatedItems
                }
            }
            , showModal(index) {
                this.modal.show = true
                this.modal.video = this.sortedMateri[index]
            }
            , closeModal() {
                this.modal.show = false
                this.modal.video = {}
            }
            , sortMateri(data, properti, order) {
                if (order == 'asc' || order == '') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? 1 : -1)
                }
                if (order == 'desc') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? -1 : 1)
                }
            }
            , resetSort() {
                this.sort.by = 'judul'
                this.sort.order = 'asc'
            }
            , resetFormTambah() {
                this.modal.tambah.judul = ''
                this.modal.tambah.konten_id = ''
            }
            , showToast(msg, type) {
                Vue.$toast.open({
                    message: msg
                    , type: type,
                    // all of other options may go here
                });
            }
            ,async submitMateri() {
                this.modal.tambah.isSubmitting = true

                  await  axios
                        .post(konten_url, {
                            judul: this.modal.tambah.judul
                            , konten_id: this.modal.tambah.konten_id,
                            kelas:this.modal.tambah.select.kelas
                        })
                        .then((response) => {
                            this.materi.data.push(response.data.data)
                            this.showToast(
                                `Berhasil menambah materi.<br>Judul: ${response.data.data.judul}`
                                , 'info'
                            )
                            this.resetFormTambah()
                            this.modal.tambah.isSubmitting = false

                        }, (error) => {
                            this.showToast('Gagal menambah materi', 'error')
                            this.resetFormTambah()
                            this.modal.tambah.isSubmitting = false
                        })

            }
            , showUpdateModal(item) {
                this.modal.edit.show = true
                this.modal.edit.data = item
            }
            , closeEditModal() {
                this.modal.edit.show = false
                this.modal.edit.isSubmitting = false
                this.modal.edit.data = {}
            }
            , updateMateri(materi) {
                this.modal.edit.isSubmitting = true
                let id_materi = this.materi.data.indexOf(materi.data)

                setTimeout(() => {
                    axios
                        .put(base_url, {
                            id: materi.data.id
                            , judul: materi.judul
                            , konten_id: materi.konten_id
                        })
                        .then((response) => {
                            this.materi.data[id_materi].judul = response.data.data.judul
                            this.materi.data[id_materi].konten_id = response.data.data.konten_id
                            this.materi.data[id_materi].updated_at = response.data.data
                                .updated_at

                            this.showToast(
                                `Berhasil update materi.<br>Judul: ${response.data.data.judul}`
                                , 'info'
                            )

                            this.closeEditModal()

                        }, (error) => {
                            this.showToast('Gagal update materi', 'error')

                            this.closeEditModal()
                        })
                }, 1000);

            }
            , showDeleteConfirmation(item) {
                this.modal.delete.show = true
                this.modal.delete.data = item
            }
            , closeDeleteConfirmation() {
                this.modal.delete.show = false
                this.modal.delete.isDeleting = false
                this.modal.delete.data = {}
            }
            , deleteMateri() {
                this.modal.delete.isDeleting = true

                let item = this.modal.delete.data
                let id_materi = this.materi.data.indexOf(item)

                setTimeout(() => {
                    axios
                        .delete(base_url, {
                            data: {
                                id: item.id
                            }
                        })
                        .then((response) => {
                            this.materi.data.splice(id_materi, 1)

                            this.showToast(
                                `Berhasil menghapus materi.<br>Judul: ${response.data.data.judul}`
                                , 'info'
                            )

                            this.pagination.total = this.materi.data.length

                            this.closeDeleteConfirmation()

                        }, (error) => {
                            this.showToast('Gagal menghapus materi', 'error')

                            this.closeDeleteConfirmation()
                        })
                }, 1000);

            }
            , initialLoad() {
                axios
                    .get(konten_url)
                    .then((response) => {
                        this.materi.data = response.data.data
                        this.pagination.total = response.data.data.length
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
            , unixToDateTime(epoch) {
                let unix = epoch * 1000
                let dt = new Date(unix)

                return dt.toLocaleString('id-ID', {
                    dateStyle: 'short'
                    , timeStyle: 'short'
                })

            }
        }
        , computed: {
            sortedMateri() {
                let data = [...this.filteredMateri]
                let sorted = [...this.filteredMateri]

                if (this.sort.by) {
                    let data = this.sortMateri(sorted, this.sort.by, this.sort.order)
                    this.pagination.total = data.length

                    return data
                }
                return data
            }
            , filteredMateri() {
                let search = this.search.value.toLowerCase().trim()
                let filtered = [...this.materi.data]

                if (!search) return this.materi.data

                return filtered.filter(c => c.judul.toLowerCase().indexOf(search) > -1);
            }
            , pagePaginated() {
                let paginated = this.paginator(this.sortedMateri, this.pagination.current, this.pagination
                    .perPage)

                return paginated
            }
        }
        , watch: {
            'pagination.numPages'(newVal) {
                if (this.pagination.current > newVal) {
                    this.pagination.current = newVal
                }
            }
        }
        , mounted() {
            setTimeout(() => {
                this.initialLoad()
            }, 1000);

        }
    })

</script>
@endsection
