@extends('dashboard.components.layout')

@section('title')
Dashboard - Profile
@endsection

@section('style')
<link rel="stylesheet" href="../../assets/css/theme-sugar.css" type="text/css">
<link rel="stylesheet" href="../../assets/css/element-ui/index.css" type="text/css">

@endsection

@section('page-title')
<h6 class="h2 text-white d-inline-block mb-0">Profile</h6>
@endsection

@section('breadcrumb')
<li class="breadcrumb-item text-white">
    <i class="ni ni-single-02"></i>
</li>
<li class="breadcrumb-item text-white"><a href="{{url('/')}}">Dashboard</a></li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(1)) }}</li>
@endsection


@section('content')
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-md-8 col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">Profile</h3>
                    </div>

                    <div class="d-none" :class="{'d-block':isUpdating}" v-if="isUpdating">
                        <div class="card-body text-center pt-0">
                            <div class="spinner my-2">
                                <div class="rect1 bg-primary"></div>
                                <div class="rect2 bg-primary"></div>
                                <div class="rect3 bg-primary"></div>
                                <div class="rect4 bg-primary"></div>
                                <div class="rect5 bg-primary"></div>
                            </div>
                            <h4 class="mt-4 text-primary">
                                Sedang menyimpan data..
                            </h4>
                        </div>
                    </div>

                    <form @@submit.prevent="submitProfile" v=if="!isUpdating">
                        <div class="card-body pb-0">
                            <div class="row">
                                <div class="col-md-6 col-sm-12">
                                    <div class="form-group">
                                        <label for="nama">Nama Lengkap</label>
                                        <div class="input-group mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text">
                                                    <i class="fas fa-user"></i>
                                                </span>
                                            </div>
                                            <input v-model.trim="user.nama" required id="nama" type="text" class="form-control" placeholder="Masukkan nama lengkap" maxlength="40">
                                        </div>

                                    </div>
                                </div>

                                <div class="col-md-6 col-sm-12">
                                    <div class="form-group">
                                        <label for="email">Alamat Email</label>
                                        <div class="input-group mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text">
                                                    @
                                                </span>
                                            </div>
                                            <input v-model.trim="user.email" required id="email" type="email" class="form-control" placeholder="Masukkan email">
                                        </div>

                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-4 col-sm-12">
                                    <div class="form-group">
                                        <label for="wa">No WhatsApp</label>
                                        <div class="input-group mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text">
                                                    +62
                                                </span>
                                            </div>
                                            <input v-model.number="user.no_wa" id="wa" type="number" maxlength="14" class="form-control" placeholder="Masukkan nomor WA aktif">
                                        </div>

                                    </div>
                                </div>

                                <div class="col-md-4 col-sm-12">
                                    <div class="form-group">
                                        <label for="tgl_lahir">Tanggal Lahir</label>
                                        <div class="input-group mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text">
                                                    <i class="fas fa-calendar"></i>
                                                </span>
                                            </div>
                                            <input v-model="user.tgl_lahir" id="tgl_lahir" type="date" class="form-control">
                                        </div>

                                    </div>
                                </div>

                                <div class="col-md-4 col-sm-12">
                                    <div class="form-group">
                                        <label for="gender">Gender</label>
                                        <br>
                                        <div class="custom-control custom-radio custom-control-inline">
                                            <input v-model="user.gender" type="radio" id="laki" name="gender" class="custom-control-input" value="laki-laki">
                                            <label class="custom-control-label" for="laki">Laki-laki</label>
                                        </div>
                                        <div class="custom-control custom-radio custom-control-inline">
                                            <input v-model="user.gender" type="radio" id="perempuan" name="gender" class="custom-control-input" value="perempuan">
                                            <label class="custom-control-label" for="perempuan">Perempuan</label>
                                        </div>

                                    </div>
                                </div>

                            </div>

                            <div class="row">
                                <div class="col-md-6 col-sm-12">
                                    <div class="form-group mb-3">
                                        <div class="input-group">
                                            <el-select name="provinsi" class="w-100" v-model="form.provinsi" filterable clearable placeholder="Pilih Provinsi" @@clear="clearKota()" @@change="getKota()">
                                                <el-option v-for="item in provinsi" :key="item.id" :label="item.name" :value="item.id">
                                                </el-option>
                                            </el-select>
                                            <input type="hidden" name="id_provinsi" v-model="form.provinsi">
                                        </div>
                                    </div>
                                </div>

                                <div class="col-md-6 col-sm-12">
                                    <div class="form-group mb-3">
                                        <div class="input-group">
                                            <el-select name="kota" class="w-100" v-model="form.kota" filterable clearable placeholder="Pilih Kota" @@clear="clearKota()" :disabled="kota.length == 0">
                                                <el-option v-for="item in kota" :key="item.id" :label="item.name" :value="item.id">
                                                </el-option>
                                            </el-select>
                                            <input type="hidden" name="id_kota" v-model="form.kota">
                                        </div>
                                    </div>
                                </div>

                            </div>


                            <div class="row">
                                <div class="col-12">
                                    <div class="form-group">
                                        <label for="alamat">Alamat Lengkap</label>
                                        <textarea v-model.trim="user.alamat" class="form-control" id="alamat" rows="2"></textarea>
                                    </div>
                                </div>
                            </div>


                        </div>

                        <div class="card-footer  text-right">
                            <button type="submit" class="btn btn-primary" :disabled="!form.kota">
                                Update Profile
                            </button>
                        </div>
                    </form>
                </div>
            </div>

            <div class="col-md-4 col-sm-12">
                {{-- <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">Ubah Avatar</h3>
                    </div>
                    <form @@submit.prevent="submitUbahPassword">
                        <div class="d-none" :class="{'d-block':form.is_submitting}" v-if="form.is_submitting">
                            <div class="card-body text-center pt-0">
                                <div class="spinner my-2">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h4 class="mt-4 text-primary">
                                    Sedang menyimpan data..
                                </h4>
                            </div>
                        </div>

                        <div v-if="!form.is_submitting">
                            <div class="card-body pb-0">
                                <div class="row justify-content-center">
                                    <div class="col-lg-3 order-lg-2">
                                      <div class="card-profile-image">
                                        <a href="#">
                                          <img src="https://images.unsplash.com/photo-1529665253569-6d01c0eaf7b6?ixid=MXwxMjA3fDB8MHxzZWFyY2h8M3x8cHJvZmlsZXxlbnwwfHwwfA%3D%3D&ixlib=rb-1.2.1&w=1000&q=80" class="rounded-circle">
                                        </a>
                                      </div>
                                    </div>
                                  </div>

                            </div>

                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary btn-lg btn-block" >Ubah</button>
                            </div>
                        </div>
                    </form>
                </div> --}}

                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">Ubah Password</h3>
                    </div>
                    <form @@submit.prevent="submitUbahPassword">
                        <div class="d-none" :class="{'d-block':form.is_submitting}" v-if="form.is_submitting">
                            <div class="card-body text-center pt-0">
                                <div class="spinner my-2">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h4 class="mt-4 text-primary">
                                    Sedang menyimpan data..
                                </h4>
                            </div>
                        </div>

                        <div v-if="!form.is_submitting">
                            <div class="card-body pb-0">
                                <div class="form-group">
                                    <label for="password">Password Baru</label>
                                    <div class="input-group mb-3">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="fas fa-lock">
                                                </i>
                                            </span>
                                        </div>
                                        <input v-model.trim="form.password.new_pass.text" required id="password" type="password" class="form-control" placeholder="Masukkan Password baru" minlength="8">
                                        {{--
                                        <div style="cursor: pointer" class="input-group-append">
                                            <span class="input-group-text">
                                                <i class="fas fa-eye-slash" @@click="togglePassword('new_pass')">
                                                </i>
                                            </span>
                                        </div> --}}
                                    </div>

                                </div>

                                <div class="form-group">
                                    <label for="password-confirm">Konfirmasi Password</label>
                                    <div class="input-group mb-3">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="fas fa-lock">
                                                </i>
                                            </span>
                                        </div>
                                        <input v-model.trim="form.password.confirm.text" required id="password-confirm" type="password" class="form-control" placeholder="Masukkan lagi" minlength="8">

                                        {{-- <div style="cursor: pointer" class="input-group-append">
                                            <span class="input-group-text">
                                                <i class="fas fa-eye-slash" @@click="togglePassword('confirm')">
                                                </i>
                                            </span>
                                        </div> --}}

                                    </div>

                                </div>

                            </div>

                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary btn-block">Ubah Password</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>


        </div>

    </div>
</div>

@endsection

@section('script')

<script src="{{ asset('assets/js/axios.js') }}"></script>
<script src="{{ asset('assets/js/vue-toast-notification.js') }}"></script>
<script src="{{ asset('assets/js/element-ui/index.js') }}"></script>
<script src="{{ asset('assets/js/element-ui/locales/en.js') }}"></script>

<script>
    let base_url = "{{ url('/') }}/api/profile"
    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);

    var app = new Vue({
        el: '#panel',
        data: {
            isUpdating: false,
            form: {
                provinsi: null,
                kota: null,
                is_submitting: false,
                editing: false,
                password: {
                    new_pass: {
                        show: false,
                        text: ''
                    },
                    confirm: {
                        show: false,
                        text: ''
                    },
                }

            },

            isFailed: false,
            isLoaded: false,
            user: {},
            provinsi: [],
            kota: []
        },
        methods: {
            clearKota() {
                this.kota = []
                this.form.kota = null
            },
            async getProvinsi() {
                await axios
                    .get("{{url('/api/alamat')}}" + '/provinsi')
                    .then((response) => {
                        Vue.set(this, "provinsi", response.data.data);

                    }, (error) => {

                    })
            },
            async getKota() {
                await axios
                    .get("{{url('/api/alamat')}}" + '/kota/' + this.form.provinsi)
                    .then((response) => {
                        Vue.set(this, "kota", response.data.data.cities);

                    }, (error) => {

                    })
            },
            togglePassword(name) {
                let val = this.form.password[name].show
                Vue.set(this.form.password[name], 'show', !val)

            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            },
            async submitUbahPassword() {
                let form = this.form
                let pass = this.form.password
                if (pass.confirm.text !== pass.new_pass.text) {
                    this.showToast("Konfirmasi password berbeda", "error")
                } else {
                    form.is_submitting = true

                    await axios.post(base_url + '/password', {
                        password: pass.new_pass.text
                    }).then(
                        (resp) => {
                            this.showToast(resp.data.message, "info")
                            form.is_submitting = false

                        },
                        (error) => {
                            this.showToast("Gagal ubah password!", "error")
                            form.is_submitting = false

                        }
                    );

                }
            },
            async submitProfile() {
                this.isUpdating = true
                Vue.set(this.user, 'province_id', this.form.provinsi)
                Vue.set(this.user, 'city_id', this.form.kota)
                await axios.put(base_url + '/update', this.user).then(
                    (resp) => {
                        this.showToast(resp.data.message, "info")
                        this.isUpdating = false
                    },
                    (error) => {
                        this.showToast("Gagal ubah profile!", "error")
                        this.isUpdating = false

                    }
                );
            },
            async initialLoad() {
                await axios
                    .get(base_url + "/user")
                    .then((response) => {
                        this.user = response.data.data
                        this.isLoaded = true
                        this.getProvinsi();
                        Vue.set(this.form, 'provinsi', this.user.province_id)
                        Vue.set(this.form, 'kota', this.user.city_id)
                        this.getKota()

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        created() {
            this.initialLoad()


        }

    })
</script>
@endsection
