@extends('dashboard.components.layout')

@section('title')
    Dashboard
@endsection

@section('style')
    <link rel="stylesheet" href="../../assets/css/custom.css" type="text/css">

@endsection


@section('action-bar')
    {{-- <a href="#" class="btn btn-sm btn-neutrazl">Selesai</a>
    --}}
@endsection

@section('content')
    <div id="app">
        <div v-if="!isSubmitting">
            <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed">
                <div class="col-12 card">
                    <div class="card-body text-center">
                        <div class="spinner">
                            <div class="rect1 bg-primary"></div>
                            <div class="rect2 bg-primary"></div>
                            <div class="rect3 bg-primary"></div>
                            <div class="rect4 bg-primary"></div>
                            <div class="rect5 bg-primary"></div>
                        </div>
                        <h4 class="mt-4 text-primary">
                            Sedang memuat data..
                        </h4>
                    </div>
                </div>
            </div>

            <div class="d-flex justify-content-center" v-if="isFailed">
                <div class="col-12 card">
                    <div class="card-body text-center text-warning">
                        <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                        <h4 class="mt-4 text-warning">
                            Gagal memuat data. Silahkan refresh halaman.
                        </h4>
                    </div>
                </div>
            </div>

            <div class="justify-content-center" v-if="isLoaded && isDone">
                <div class="col-12 card">
                    <div class="card-body text-center text-primary">
                        <i class="mt-4 fas fa-check-circle fa-5x"></i>
                        <h4 class="mt-4 text-primary">
                            Anda sudah menyelesaikan sesi ini pada
                            @{{ getSubmitedTime }}
                        </h4>

                        <div class="mt-2 d-flex flex-wrap align-content-center justify-content-center">
                            <a href="#" class="mt-2 btn btn-icon btn-warning" type="button">
                                <span class="btn-inner--icon"><i class="fas fa-home"></i></span>
                                <span class="btn-inner--text">Kembali</span>
                            </a>

                            <a href="#" class="mt-2 btn btn-icon btn-primary" type="button">
                                <span class="btn-inner--icon"><i class="fas fa-eye"></i></span>
                                <span class="btn-inner--text">Review</span>
                            </a>

                            <a href="#" class="mt-2 btn btn-icon btn-success" type="button">
                                <span class="btn-inner--icon"><i class="fas fa-sync"></i></span>
                                <span class="btn-inner--text">Ulangi</span>
                            </a>
                        </div>


                    </div>
                </div>
            </div>

            <div class="justify-content-center" v-if="isLoaded && isTimeUp && !isDone">
                <div class="col-12 card">
                    <div class="card-body text-center text-danger">
                        <div class="spinner">
                            <div class="rect1 bg-danger"></div>
                            <div class="rect2 bg-danger"></div>
                            <div class="rect3 bg-danger"></div>
                            <div class="rect4 bg-danger"></div>
                            <div class="rect5 bg-danger"></div>
                        </div>
                        <h4 class="mt-4 text-danger">
                            Waktu mengerjakan sudah habis. Sedang menyimpan data...
                        </h4>


                    </div>
                </div>
            </div>

            <div v-if="isLoaded && !isDone && !isTimeUp">
                <div id="navigasi-soal-fixed" class="d-sm-none">
                    <div id="next-prev-fixed" class="fixed-bottom">
                        <div class="card card-stats mb-0 text-center">
                            <div class="card-body py-2">
                                <div class="row">
                                    <div class="col-6 col-xs-12">
                                        <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block"
                                            :disabled="currentIndex==0" v-on:click="prevQuestion">
                                            <span class="btn-inner--icon"><i class="fas fa-chevron-left"></i></span>
                                            <span class="btn-inner--text">Prev</span>
                                        </button>
                                    </div>
                                    <div class="col-6 col-xs-12">
                                        <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block"
                                            :disabled="currentIndex == soal.jumlah-1" v-on:click="nextQuestion">
                                            <span class="btn-inner--text">Next</span>
                                            <span class="btn-inner--icon"><i class="fas fa-chevron-right"></i></span>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>

                <div id="sisa-waktu-sticky" class="sticky-top d-sm-none">
                    <div class="card card-stats mb-2 text-center">

                        <div class="card-body py-2">
                            <div class="row align-items-center">
                                <div class="col">
                                    <h6 class="card-title text-uppercase text-muted mb-0">Sisa Waktu</h6>
                                    <span class="display-1 font-weight-bold mb-0"
                                        :class="(countDown.minute < 1)?'text-danger':'text-primary'">
                                        @{{ formatedCountDown . minute }} : @{{ formatedCountDown . second }}
                                    </span>
                                </div>
                                <div class="col">
                                    <div class="icon icon-shape text-white rounded-circle shadow align-middle"
                                        :class="(countDown.minute < 1)?'bg-danger':'bg-primary'">
                                        <i class="fas fa-clock"></i>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-9">
                        <div class="card">
                            <div class="card-header bg-transparent">
                                <h1 class="text-center my-0">
                                    @{{ soal . judul }}
                                </h1>
                            </div>
                            <div id="quiz-section" class="card-body">

                                <div id="pertanyaan" class="mb-4">
                                    <h3>
                                        <div class="d-flex flex-row">
                                            <div class="p-2">
                                                @{{ currentIndex + 1 }}.
                                            </div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pertanyaan }}
                                            </div>
                                        </div>
                                    </h3>

                                    <div id="pilihan">
                                        <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                            v-on:click="chooseAnswer(currentIndex, 'A')"
                                            :class="(soal.data[currentIndex].info.answer == 'A' && !soal.data[currentIndex].info.isRagu)?'table-primary':(soal.data[currentIndex].info.answer == 'A' && soal.data[currentIndex].info.isRagu)?'table-warning':''">
                                            <div class="p-2">A.</div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pilihan[0] }}
                                            </div>

                                            <div class="p-2 ml-auto">
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'A' && !soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-check text-primary"></i>
                                                </div>
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'A' && soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-flag text-warning"></i>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                            v-on:click="chooseAnswer(currentIndex, 'B')"
                                            :class="(soal.data[currentIndex].info.answer == 'B' && !soal.data[currentIndex].info.isRagu)?'table-primary':(soal.data[currentIndex].info.answer == 'B' && soal.data[currentIndex].info.isRagu)?'table-warning':''">
                                            <div class="p-2">B.</div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pilihan[1] }}
                                            </div>

                                            <div class="p-2 ml-auto">
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'B' && !soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-check text-primary"></i>
                                                </div>
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'B' && soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-flag text-warning"></i>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                            v-on:click="chooseAnswer(currentIndex, 'C')"
                                            :class="(soal.data[currentIndex].info.answer == 'C' && !soal.data[currentIndex].info.isRagu)?'table-primary':(soal.data[currentIndex].info.answer == 'C' && soal.data[currentIndex].info.isRagu)?'table-warning':''">
                                            <div class="p-2">C.</div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pilihan[2] }}
                                            </div>

                                            <div class="p-2 ml-auto">
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'C' && !soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-check text-primary"></i>
                                                </div>
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'C' && soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-flag text-warning"></i>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                            v-on:click="chooseAnswer(currentIndex, 'D')"
                                            :class="(soal.data[currentIndex].info.answer == 'D' && !soal.data[currentIndex].info.isRagu)?'table-primary':(soal.data[currentIndex].info.answer == 'D' && soal.data[currentIndex].info.isRagu)?'table-warning':''">
                                            <div class="p-2">D.</div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pilihan[3] }}
                                            </div>

                                            <div class="p-2 ml-auto">
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'D' && !soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-check text-primary"></i>
                                                </div>
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'D' && soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-flag text-warning"></i>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                            v-on:click="chooseAnswer(currentIndex, 'E')"
                                            :class="(soal.data[currentIndex].info.answer == 'E' && !soal.data[currentIndex].info.isRagu)?'table-primary':(soal.data[currentIndex].info.answer == 'E' && soal.data[currentIndex].info.isRagu)?'table-warning':''">
                                            <div class="p-2">E.</div>
                                            <div class="p-2">
                                                @{{ soal . data[currentIndex] . pilihan[4] }}
                                            </div>

                                            <div class="p-2 ml-auto">
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'E' && !soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-check text-primary"></i>
                                                </div>
                                                <div
                                                    v-if="(soal.data[currentIndex].info.answer == 'E' && soal.data[currentIndex].info.isRagu)">
                                                    <i class="fas fa-flag text-warning"></i>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>

                                {{-- Soal button --}}
                                <div class="row">
                                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-6 mb-2">
                                        <button type="button" class="btn btn-danger btn-icon btn-block"
                                            v-on:click="lepasAnswer(currentIndex)"
                                            :disabled="soal.data[currentIndex].info.answer == ''">
                                            <span class="btn-inner--icon"><i class="fas fa-times"></i></span>
                                            <span class="btn-inner--text">Lepas</span>
                                        </button>
                                    </div>
                                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-6 mb-2">
                                        <button type="button" class="btn btn-warning btn-icon btn-block"
                                            v-on:click="raguAnswer(currentIndex)"
                                            :disabled="soal.data[currentIndex].info.answer == '' || soal.data[currentIndex].info.isRagu">
                                            <span class="btn-inner--icon"><i class="fas fa-flag"></i></span>
                                            <span class="btn-inner--text">Ragu</span>
                                        </button>
                                    </div>
                                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">
                                        <button type="button" class="btn btn-primary btn-icon btn-block"
                                            v-on:click="kunciAnswer(currentIndex)"
                                            :disabled="soal.data[currentIndex].info.answer == '' || !soal.data[currentIndex].info.isRagu">
                                            <span class="btn-inner--icon"><i class="fas fa-lock"></i></span>
                                            <span class="btn-inner--text">Kunci</span>
                                        </button>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div id="right-sidebar" class="col-md-3">
                        <div id="sisa-waktu" class="card d-none d-sm-block">
                            <div class="card-header bg-transparent">
                                <div class="row align-items-center">
                                    <div class="col">
                                        <h5 class="h3 mb-0">Sisa Waktu</h5>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body overflow-auto text-center py-3"
                                :class="(countDown.minute < 1)?'text-danger':'text-primary'">
                                <span style="font-size:3rem; font-weight: 800; line-height: 0.5">
                                    @{{ formatedCountDown . minute }} : @{{ formatedCountDown . second }}
                                </span>
                            </div>
                        </div>

                        <div id="nomor-soal" class="card">
                            <div class="card-header bg-transparent">
                                <div class="row align-items-center">
                                    <div class="col">
                                        <h5 class="h3 mb-0">Nomor Soal</h5>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body ">
                                <div class="mb-3 d-none d-sm-block">
                                    <div class="row">
                                        <div class="col-6 col-xs-12">
                                            <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block"
                                                :disabled="currentIndex==0" v-on:click="prevQuestion">
                                                <span class="btn-inner--icon"><i class="fas fa-chevron-left"></i></span>
                                                <span class="btn-inner--text">Prev</span>
                                            </button>
                                        </div>
                                        <div class="col-6 col-xs-12">
                                            <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block"
                                                :disabled="currentIndex == soal.jumlah-1" v-on:click="nextQuestion">
                                                <span class="btn-inner--text">Next</span>
                                                <span class="btn-inner--icon"><i class="fas fa-chevron-right"></i></span>
                                            </button>
                                        </div>
                                    </div>
                                </div>

                                {{-- <div class="overflow-auto">
                                    <div class="d-flex flex-wrap" style="max-height: 11.2rem">
                                        <div class="w-100 text-center">
                                            @for ($i = 0; $i < 100; $i++)
                                                <button type="button"
                                                    class="mx-0 btn btn-sm btn-outline-primary btn-icon-only mb-1">
                                                    <span class="btn-inner--icon">{{ $i + 1 }}</span>
                                                </button>
                                            @endfor
                                        </div>
                                    </div>
                                </div> --}}

                                <div class="overflow-auto">
                                    <div class="d-flex flex-wrap justify-content-center" style="max-height: 11.2rem">
                                        <span v-for="index in soal.jumlah" :key="index"
                                            style="margin-right: 0.15rem !important; margin-left: 0.15rem !important">

                                            <div class="d-sm-none">
                                                <button type="button" class="btn btn-lg  btn-icon-only mb-1"
                                                    :class="(index-1 == currentIndex)?'btn-primary':(soal.data[index-1].info.answer != '' && !soal.data[index-1].info.isRagu)?'btn-success':(soal.data[index-1].info.isRagu)?'btn-warning':'btn-outline-primary'"
                                                    v-on:click="toQuestion(index-1)">
                                                    <span class="btn-inner--icon">@{{ index }}</span>
                                                </button>
                                            </div>

                                            <div class="d-none d-sm-block">
                                                <button type="button" class="btn btn-sm  btn-icon-only mb-1"
                                                    :class="(index-1 == currentIndex)?'btn-primary':(soal.data[index-1].info.answer != '' && !soal.data[index-1].info.isRagu)?'btn-success':(soal.data[index-1].info.isRagu)?'btn-warning':'btn-outline-primary'"
                                                    v-on:click="toQuestion(index-1)">
                                                    <span class="btn-inner--icon">@{{ index }}</span>
                                                </button>
                                            </div>
                                        </span>
                                    </div>
                                </div>

                                <div class="mt-3">
                                    <div class="row">
                                        <div class="col-12 col-md-12 col-sm-6 mb-2">
                                            <button type="button" class="btn btn-danger btn-icon btn-block"
                                                v-on:click="removeLocalStorage">
                                                <span class="btn-inner--icon"><i class="fas fa-times"></i></span>
                                                <span class="btn-inner--text">Batal</span>
                                            </button>
                                        </div>
                                        <div class="col-12 col-md-12 col-sm-6">
                                            <button type="button" class="btn btn-success  btn-icon  btn-block"
                                                :disabled="informasiJumlah.blank > 0" v-on:click="submit">
                                                <span class="btn-inner--icon"><i class="fas fa-check"></i></span>
                                                <span class="btn-inner--text">Selesai</span>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div id="informasi" class="card">
                            <div class="card-header bg-transparent">
                                <div class="row align-items-center">
                                    <div class="col">
                                        <h5 class="h3 mb-0">Informasi</h5>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body overflow-auto">
                                <div class="row">
                                    <div class="col-6">
                                        <div class="w-100 card bg-primary text-center">
                                            <div class="card-body px-2 py-2">
                                                <h5 class="card-title text-uppercase text-muted mb-0 text-white">Soal</h5>
                                                <span
                                                    class="h2 font-weight-bold mb-0 text-white">@{{ soal . jumlah }}</span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <div class="w-100 card bg-success text-center">
                                            <div class="card-body px-2 py-2">
                                                <h5 class="card-title text-uppercase text-muted mb-0 text-white">Dijawab
                                                </h5>
                                                <span
                                                    class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . answered }}</span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <div class="w-100 card bg-warning text-center">
                                            <div class="card-body px-2 py-2">
                                                <h5 class="card-title text-uppercase text-muted mb-0 text-white">Ragu</h5>
                                                <span
                                                    class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . ragu }}</span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <div class="w-100 card bg-danger text-center">
                                            <div class="card-body px-2 py-2">
                                                <h5 class="card-title text-uppercase text-muted mb-0 text-white">Kosong</h5>
                                                <span
                                                    class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . blank }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>

        <div v-if="isDone && isSubmitting">
            <div class="justify-content-center">
                <div class="col-12 card">
                    <div class="card-body text-center text-primary">
                        <div class="spinner">
                            <div class="rect1 bg-primary"></div>
                            <div class="rect2 bg-primary"></div>
                            <div class="rect3 bg-primary"></div>
                            <div class="rect4 bg-primary"></div>
                            <div class="rect5 bg-primary"></div>
                        </div>
                        <h4 class="mt-4 text-primary">
                            Sedang menyimpan data...
                        </h4>
                    </div>
                </div>
            </div>
        </div>
    </div>



@endsection

@section('script')

    <script src="../../assets/js/lorem-ipsum.js"></script>

    <script>
        var ipsum = new LoremIpsum();

        var app = new Vue({
            el: '#app',
            data: {
                currentIndex: 0,
                countDown: {
                    minute: 0,
                    second: 0
                },
                isFailed: false,
                isLoaded: false,
                isTimeUp: false,
                isDone: false,
                isSubmitting: false,
                soal: {}
            },
            methods: {
                chooseAnswer: function(index, answer) {
                    this.soal.data[index].info.answer = answer
                    this.soal.data[index].info.isRagu = false

                    this.saveLocalStorage()
                    // alert(answer)
                },
                nextQuestion: function() {
                    if (this.currentIndex + 1 < this.soal.jumlah) {
                        this.currentIndex++
                        this.saveCurrentIndex()
                    }
                },
                prevQuestion: function() {
                    if (this.currentIndex > 0) {
                        this.currentIndex--
                        this.saveCurrentIndex()
                    }
                },
                toQuestion: function(index) {
                    this.currentIndex = index
                    this.saveCurrentIndex()
                    // console.log(index)
                },
                raguAnswer: function(index) {
                    let answer = this.soal.data[index].info.answer

                    if (answer != '') {
                        this.soal.data[index].info.isRagu = true
                        this.saveLocalStorage()
                    } else {
                        alert('belum dijawab')
                    }
                },
                kunciAnswer: function(index) {
                    let answer = this.soal.data[index].info.answer

                    if (answer != '') {
                        this.soal.data[index].info.isRagu = false
                        this.saveLocalStorage()
                    } else {
                        alert('belum dijawab')
                    }

                },
                lepasAnswer: function(index) {
                    let answer = this.soal.data[index].info.answer

                    if (answer != '') {
                        this.soal.data[index].info.answer = ''
                        this.soal.data[index].info.isRagu = false

                        this.saveLocalStorage()

                    } else {
                        alert('belum dijawab')
                    }
                },
                saveLocalStorage: function() {
                    localStorage.setItem(this.soal.id, JSON.stringify(this.soal))
                },
                removeLocalStorage: function() {
                    localStorage.removeItem('index_of_' + this.soal.id)
                    localStorage.removeItem(this.soal.id)
                },
                saveCurrentIndex: function() {
                    localStorage.setItem("index_of_" + this.soal.id, this.currentIndex)
                },
                submit: function() {
                    let submit_pressed = Math.round(new Date() / 1000)
                    let confirm_submit = false
                    let confirm_ragu = false

                    if (this.informasiJumlah.ragu > 0) {
                        confirm_ragu = confirm(
                            `Terdapat ${this.informasiJumlah.ragu} jawaban ragu apakah Anda yakin untuk mengakhiri?`
                        )
                    } else {
                        confirm_submit = confirm(
                            `Apakah anda yakin untuk mengakhiri sesi dan menyimpan jawaban?`
                        )
                    }

                    if (confirm_submit || confirm_ragu) {
                        this.isDone = true
                        this.isSubmitting = true

                        setInterval(() => {
                            this.isSubmitting = false
                            this.soal.submited_at = submit_pressed

                            this.removeLocalStorage()
                        }, 3000);
                    }
                },
                dummySoal: function(n, durasi, judul, id) {

                    let mulai = 0
                    let end = 0

                    if (localStorage.getItem(id)) {
                        let storage = JSON.parse(localStorage.getItem(id))
                        mulai = storage.mulai
                        end = storage.end
                    } else {
                        mulai = Math.round(new Date() / 1000)
                        end = mulai + (durasi * 60)
                    }

                    let soal = {
                        judul: ipsum.sentence(3),
                        id: id,
                        durasi: durasi,
                        mulai: mulai,
                        end: end,
                        submited_at: 0,
                        jumlah: n,
                        data: []
                    }

                    for (let index = 0; index < n; index++) {
                        soal.data.push({
                                kategogi: 'TIU',
                                pertanyaan: ipsum.sentence(8, 12),
                                pilihan: [
                                    ipsum.sentence(5, 20),
                                    ipsum.sentence(5, 20),
                                    ipsum.sentence(5, 20),
                                    ipsum.sentence(5, 20),
                                    ipsum.sentence(5, 20)
                                ],
                                info: {
                                    isRagu: false,
                                    answer: ''
                                }
                            }

                        )
                    }

                    return soal

                }
            },
            computed: {
                informasiJumlah: function() {
                    let data = this.soal.data
                    let answered = data.filter(function(soal) {
                        return soal.info.answer != ''
                    })

                    let blank = this.soal.jumlah - answered.length
                    let ragu = data.filter(function(soal) {
                        return soal.info.isRagu == true
                    })

                    let informasi = {
                        answered: answered.length,
                        blank: blank,
                        ragu: ragu.length
                    }

                    return informasi
                },
                formatedCountDown: function() {
                    let minute = this.countDown.minute
                    let second = this.countDown.second

                    let formated = {
                        minute: (minute.toString().length == 1) ? `0${minute}` : minute,
                        second: (second.toString().length == 1) ? `0${second}` : second
                    }

                    return formated
                },
                getSubmitedTime: function() {
                    let epoch = parseInt(this.soal.submited_at)
                    return new Date(epoch * 1000).toLocaleString('id-ID', {
                        'dateStyle': 'full',
                        'timeStyle': 'full'
                    })
                }
            },
            created: function() {

                setTimeout(() => {

                    // load api

                    //API data
                    let response = {
                        message: 'ok',
                        data: this.dummySoal(20, 1, 'Latihan TIU 3', '21')
                    }

                    let soal = response.data

                    // cek apakah data soal di lokal
                    if (localStorage.getItem(soal.id)) {
                        this.soal = JSON.parse(localStorage.getItem(soal.id))

                        this.soal.mulai = soal.mulai
                        this.soal.durasi = soal.durasi
                        this.soal.end = soal.end
                        this.soal.submited_at = soal.submited_at

                        // cek index
                        if (localStorage.getItem("index_of_" + soal.id)) {
                            this.currentIndex = parseInt(localStorage.getItem("index_of_" + response
                                .data.id))
                        } else {
                            this.currentIndex = 0
                            localStorage.setItem("index_of_" + soal.id, 0)
                        }
                    } else {
                        this.soal = soal
                        localStorage.setItem(soal.id, JSON.stringify(soal))
                    }

                    // cek apakah sudah disubmit
                    if (soal.submited_at != 0) {
                        this.isDone = true
                    }

                    // api berhasil di load
                    this.isLoaded = true;

                    //start count down
                    if (this.soal.end >= Math.round(new Date() / 1000)) {
                        setInterval(() => {

                            let currentTime = Math.round(new Date() / 1000)

                            if (this.soal.end >= currentTime) {

                                let minuteDifference = Math.floor((this.soal.end -
                                    currentTime) / 60)
                                let secondDifference = (this.soal.end - currentTime) -
                                    minuteDifference *
                                    60

                                this.countDown.minute = minuteDifference
                                this.countDown.second = secondDifference
                            } else {
                                this.isTimeUp = true

                                setTimeout(() => {
                                    if (this.soal.submited_at == 0) {
                                        this.soal.submited_at = this.soal.end
                                        this.isDone = true

                                        this.removeLocalStorage()
                                    }

                                }, 3000);
                            }
                        }, 1000)
                    } else {
                        this.isTimeUp = true

                        setTimeout(() => {
                            if (this.soal.submited_at == 0) {
                                this.soal.submited_at = this.soal.end
                                this.isDone = true

                                this.removeLocalStorage()
                            }

                        }, 3000);
                    }

                }, 3000);
            }
        })

    </script>
@endsection
