@extends('dashboard.components.layout')

@section('title')
    Dashboard
@endsection

@section('style')
    <link rel="stylesheet" href="../../assets/css/custom.css" type="text/css">

@endsection


@section('action-bar')
    {{-- <a href="#" class="btn btn-sm btn-neutrazl">Selesai</a>
    --}}
@endsection

@section('content')
    <div id="app">

        <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed">
            <div class="col-12 card">
                <div class="card-body text-center">
                    <div class="spinner">
                        <div class="rect1 bg-primary"></div>
                        <div class="rect2 bg-primary"></div>
                        <div class="rect3 bg-primary"></div>
                        <div class="rect4 bg-primary"></div>
                        <div class="rect5 bg-primary"></div>
                    </div>
                    <h4 class="mt-4 text-primary">
                        Sedang memuat data..
                    </h4>
                </div>
            </div>
        </div>

        <div class="d-flex justify-content-center" v-if="isFailed">
            <div class="col-12 card">
                <div class="card-body text-center text-warning">
                    <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                    <h4 class="mt-4 text-warning">
                        Gagal memuat data. Silahkan refresh halaman.
                    </h4>
                </div>
            </div>
        </div>

        <div v-if="isLoaded">
            <div id="navigasi-soal-fixed" class="d-sm-none">
                <div id="next-prev-fixed" class="fixed-bottom">
                    <div class="card card-stats mb-0 text-center">
                        <div class="card-body py-2">
                            <div class="row">
                                <div class="col-6 col-xs-12">
                                    <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block"
                                        :disabled="currentIndex==0" v-on:click="prevQuestion">
                                        <span class="btn-inner--icon"><i class="fas fa-chevron-left"></i></span>
                                        <span class="btn-inner--text">Prev</span>
                                    </button>
                                </div>
                                <div class="col-6 col-xs-12">
                                    <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block"
                                        :disabled="currentIndex == soal.jumlah-1" v-on:click="nextQuestion">
                                        <span class="btn-inner--text">Next</span>
                                        <span class="btn-inner--icon"><i class="fas fa-chevron-right"></i></span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>

            <div class="row">
                <div class="col-md-9">
                    <div id="soal-section" class="card">
                        <div class="d-flex justify-content-between align-items-center div-hover card-header bg-secondary"
                            v-on:click="toogleSoal">
                            <h2 class="text-primary">
                                @{{ soal . judul }}
                            </h2>
                            <i class="fas text-primary"
                                :class="(control.soalIsCollapsed)?'fa-minus-circle':'fa-plus-circle'"></i>
                        </div>
                        <div id="quiz-section" class="card-body collapse" :class="{'show':!control.soalIsCollapsed}">
                            <div id="pertanyaan" class="mb-4">
                                <h3>
                                    <div class="d-flex flex-row">
                                        <div class="p-2">
                                            @{{ currentIndex + 1 }}.
                                        </div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pertanyaan }}
                                        </div>
                                    </div>
                                </h3>

                                <div id="pilihan">
                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                        :class="cekJawaban(currentIndex, 'A').row">
                                        <div class="p-2">A.</div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pilihan[0] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, 'A').icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                @{{ soal . data[currentIndex] . pilihan[0] . poin }}
                                            </span>
                                        </div>
                                    </div>

                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                        :class="cekJawaban(currentIndex, 'B').row">
                                        <div class="p-2">B.</div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pilihan[1] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, 'B').icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                @{{ soal . data[currentIndex] . pilihan[1] . poin }}
                                            </span>
                                        </div>
                                    </div>

                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                        :class="cekJawaban(currentIndex, 'C').row">
                                        <div class="p-2">C.</div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pilihan[2] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, 'C').icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                @{{ soal . data[currentIndex] . pilihan[2] . poin }}
                                            </span>
                                        </div>
                                    </div>

                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                        :class="cekJawaban(currentIndex, 'D').row">
                                        <div class="p-2">D.</div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pilihan[3] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, 'D').icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                @{{ soal . data[currentIndex] . pilihan[3] . poin }}
                                            </span>
                                        </div>
                                    </div>

                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover"
                                        :class="cekJawaban(currentIndex, 'E').row">
                                        <div class="p-2">E.</div>
                                        <div class="p-2">
                                            @{{ soal . data[currentIndex] . pilihan[4] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, 'E').icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                @{{ soal . data[currentIndex] . pilihan[4] . poin }}
                                            </span>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="pembahasan-section" class="card">
                        <div class="d-flex justify-content-between align-items-center div-hover card-header bg-secondary"
                            v-on:click="tooglePembahasan">
                            <h2 class="text-primary">
                                Pembahasan
                            </h2>
                            <i class="fas text-primary"
                                :class="(control.pembahasanIsCollapsed)?'fa-minus-circle':'fa-plus-circle'"></i>
                        </div>

                        <div class="card-body collapse" :class="{'show':!control.pembahasanIsCollapsed}">
                            <table>
                                <tbody>
                                    <tr>
                                        <td>
                                            <h4>Jawaban Anda</h4>
                                        </td>
                                        <td>
                                            <h4>: @{{ soal . data[currentIndex] . info . answer }}</h4>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            <h4>Kunci Jawaban</h4>
                                        </td>
                                        <td>
                                            <h4>: @{{ soal . data[currentIndex] . info . key }}</h4>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>

                            <p class="mb-0">
                                @{{ soal . data[currentIndex] . pembahasan }}
                            </p>


                        </div>


                    </div>
                </div>

                <div id="right-sidebar" class="col-md-3">

                    <div id="nomor-soal" class="card sticky-top">
                        <div class="card-header bg-transparent">
                            <div class="row align-items-center">
                                <div class="col">
                                    <h5 class="h3 mb-0">Nomor Soal</h5>
                                </div>
                            </div>
                        </div>
                        <div class="card-body ">
                            <div class="mb-3 d-none d-sm-block">
                                <div class="row">
                                    <div class="col-6 col-xs-12">
                                        <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block"
                                            :disabled="currentIndex==0" v-on:click="prevQuestion">
                                            <span class="btn-inner--icon"><i class="fas fa-chevron-left"></i></span>
                                            <span class="btn-inner--text">Prev</span>
                                        </button>
                                    </div>
                                    <div class="col-6 col-xs-12">
                                        <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block"
                                            :disabled="currentIndex == soal.jumlah-1" v-on:click="nextQuestion">
                                            <span class="btn-inner--text">Next</span>
                                            <span class="btn-inner--icon"><i class="fas fa-chevron-right"></i></span>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div class="overflow-auto">
                                <div class="d-flex flex-wrap justify-content-center" style="max-height: 11.2rem">
                                    <span v-for="index in soal.jumlah" :key="index"
                                        style="margin-right: 0.15rem !important; margin-left: 0.15rem !important">

                                        <div class="d-sm-none">
                                            <button type="button" class="btn btn-lg  btn-icon-only mb-1"
                                                :class="(index-1 == currentIndex)?'btn-primary':(soal.data[index-1].info.answer != '' && !soal.data[index-1].info.isRagu)?'btn-success':(soal.data[index-1].info.isRagu)?'btn-warning':'btn-outline-primary'"
                                                v-on:click="toQuestion(index-1)">
                                                <span class="btn-inner--icon">@{{ index }}</span>
                                            </button>
                                        </div>

                                        <div class="d-none d-sm-block">
                                            <button type="button" class="btn btn-sm  btn-icon-only mb-1"
                                                :class="(index-1 == currentIndex)?'btn-primary':(soal.data[index-1].info.answer != '' && !soal.data[index-1].info.isRagu)?'btn-success':(soal.data[index-1].info.isRagu)?'btn-warning':'btn-outline-primary'"
                                                v-on:click="toQuestion(index-1)">
                                                <span class="btn-inner--icon">@{{ index }}</span>
                                            </button>
                                        </div>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="informasi" class="card">
                        <div class="card-header bg-transparent">
                            <div class="row align-items-center">
                                <div class="col">
                                    <h5 class="h3 mb-0">Informasi</h5>
                                </div>
                            </div>
                        </div>
                        <div class="card-body overflow-auto">
                            <div class="row">
                                <div class="col-6">
                                    <div class="w-100 card bg-primary text-center">
                                        <div class="card-body px-2 py-2">
                                            <h5 class="card-title text-uppercase text-muted mb-0 text-white">Soal</h5>
                                            <span class="h2 font-weight-bold mb-0 text-white">@{{ soal . jumlah }}</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-6">
                                    <div class="w-100 card bg-success text-center">
                                        <div class="card-body px-2 py-2">
                                            <h5 class="card-title text-uppercase text-muted mb-0 text-white">Dijawab
                                            </h5>
                                            <span
                                                class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . answered }}</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-6">
                                    <div class="w-100 card bg-warning text-center">
                                        <div class="card-body px-2 py-2">
                                            <h5 class="card-title text-uppercase text-muted mb-0 text-white">Ragu</h5>
                                            <span
                                                class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . ragu }}</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-6">
                                    <div class="w-100 card bg-danger text-center">
                                        <div class="card-body px-2 py-2">
                                            <h5 class="card-title text-uppercase text-muted mb-0 text-white">Kosong</h5>
                                            <span
                                                class="h2 font-weight-bold mb-0 text-white">@{{ informasiJumlah . blank }}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>



@endsection

@section('script')

    <script src="../../assets/js/lorem-ipsum.js"></script>

    <script>
        var ipsum = new LoremIpsum();

        var app = new Vue({
            el: '#app',
            data: {
                control: {
                    pembahasanIsCollapsed: false,
                    soalIsCollapsed: false
                },
                currentIndex: 0,
                isFailed: false,
                isLoaded: false,
                soal: {}
            },
            methods: {
                chooseAnswer: function(index, answer) {},
                nextQuestion: function() {
                    if (this.currentIndex + 1 < this.soal.jumlah) {
                        this.currentIndex++
                        this.saveCurrentIndex()
                    }
                },
                prevQuestion: function() {
                    if (this.currentIndex > 0) {
                        this.currentIndex--
                        this.saveCurrentIndex()
                    }
                },
                toQuestion: function(index) {
                    this.currentIndex = index
                    this.saveCurrentIndex()
                    // console.log(index)
                },
                raguAnswer: function(index) {},
                kunciAnswer: function(index) {

                },
                lepasAnswer: function(index) {

                },
                dummySoal: function(n, durasi, judul, id) {

                    let mulai = 0
                    let end = 0

                    if (localStorage.getItem(id)) {
                        let storage = JSON.parse(localStorage.getItem(id))
                        mulai = storage.mulai
                        end = storage.end
                    } else {
                        mulai = Math.round(new Date() / 1000)
                        end = mulai + (durasi * 60)
                    }

                    let soal = {
                        judul: ipsum.sentence(3),
                        id: id,
                        durasi: durasi,
                        mulai: mulai,
                        end: end,
                        submited_at: 0,
                        jumlah: n,
                        data: []
                    }

                    for (let index = 0; index < n; index++) {
                        soal.data.push({
                                kategogi: 'TIU',
                                pertanyaan: ipsum.sentence(8, 12),
                                pilihan: [{
                                        text: ipsum.sentence(5, 20),
                                        poin: 5
                                    },
                                    {
                                        text: ipsum.sentence(5, 20),
                                        poin: 0
                                    },
                                    {
                                        text: ipsum.sentence(5, 20),
                                        poin: 0
                                    },
                                    {
                                        text: ipsum.sentence(5, 20),
                                        poin: 0
                                    },
                                    {
                                        text: ipsum.sentence(5, 20),
                                        poin: 0
                                    }
                                ],
                                pembahasan: ipsum.paragraph(),
                                info: {
                                    answer: 'C',
                                    key: 'A'
                                }
                            }

                        )
                    }

                    return soal

                },
                tooglePembahasan: function() {
                    this.control.pembahasanIsCollapsed = !this.control.pembahasanIsCollapsed
                },
                toogleSoal: function() {
                    this.control.soalIsCollapsed = !this.control.soalIsCollapsed
                },
                cekJawaban: function(index, pilihan) {
                    let jawabanCorrect =
                        this.soal.data[index].info.key == this.soal.data[index].info.answer && this.soal
                        .data[index].info.key == pilihan

                    let currentRowCorrect =
                        this.soal.data[index].info.key == pilihan

                    let currentRowAnswer =
                        this.soal.data[index].info.answer == pilihan

                    let answerIsCorrect = jawabanCorrect || currentRowCorrect
                    let answerIsWrong = !jawabanCorrect && currentRowAnswer

                    return {
                        row: {
                            'table-success': answerIsCorrect,
                            'table-danger': answerIsWrong
                        },
                        icon: {
                            'fas fa-check text-success': answerIsCorrect,
                            'fas fa-times text-danger': answerIsWrong
                        }
                    }
                }
            },
            computed: {
                informasiJumlah: function() {
                    let data = this.soal.data
                    let answered = data.filter(function(soal) {
                        return soal.info.answer != ''
                    })

                    let blank = this.soal.jumlah - answered.length
                    let ragu = data.filter(function(soal) {
                        return soal.info.isRagu == true
                    })

                    let informasi = {
                        answered: answered.length,
                        blank: blank,
                        ragu: ragu.length
                    }

                    return informasi
                }
            },
            created: function() {

                setTimeout(() => {

                    // load api

                    //API data
                    let response = {
                        message: 'ok',
                        data: this.dummySoal(2, 1, 'Latihan TIU 3', '21')
                    }

                    let soal = response.data

                    this.soal = soal
                    localStorage.setItem(soal.id, JSON.stringify(soal))

                    // api berhasil di load
                    this.isLoaded = true;


                }, 1000);
            }
        })

    </script>
@endsection
