@php
$judul = $kategori_paket_latihans->firstWhere('id', Request::segment(3))->nama;
@endphp

@extends('dashboard.components.layout')

@section('title')
Dashboard - Soal Latihan {{$judul}}
@endsection

@section('style')
<link rel="stylesheet" href="{{ asset('assets/css/theme-sugar.css') }}" type="text/css">
<link rel="stylesheet" href="{{ asset('assets/css/element-ui/index.css') }}" type="text/css">


<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;
    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

@endsection

@section('search-box')
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @@blur.self="table.filters[0].focus = false" @@click="table.filters[0].focus=true" v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari Soal" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex" @@click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @@click="table.filters[0].value =  ''" class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>

</div>
@endsection

@section('mobile-search')
@include('dashboard.components.mobile-search')

@endsection

@section('page-title')
<h6 class="h2 text-white d-inline-block mb-0">

    Soal Latihan {{ $judul}}
</h6>
@endsection

@section('breadcrumb')
{{-- <li class="breadcrumb-item text-white">
    <i class="ni ni-ungroup"></i>
</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(1)) }}</li>
<li class="breadcrumb-item text-white">{{ ucfirst(Request::segment(2)) }}</li>
<li class="breadcrumb-item text-white">{{ ucfirst($judul)}}</li> --}}

@endsection

@section('action-bar')

<div class="mt-3 d-sm-none"></div>

<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end d-none" :class="{'d-block':isLoaded && !isFailed}">

    <button @@click="showModalTambah" class="m-1 btn btn-sm btn-neutral">Tambah</button>

</div>
@endsection

@section('content')
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List Soal</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage" :current-page.sync="table.pagination.current" @@current-page-change="handleCurrentPageChange" :filters="table.filters" :table-props="table.props" :data="latihans" :pagination-props="table.pagination">


                            <el-table-column label="Nama" min-width="200%" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    @{{ scope . row . nama . toUpperCase() }}
                                </template>
                            </el-table-column>

                            <el-table-column label="Kelas" prop="kelas_nama" sortable="true">
                                <template slot-scope="scope">
                                    <a :href="'{{ url('/') }}/master/kelas/'+scope . row . kelas_kode">
                                        @{{ scope . row . kelas_nama . toUpperCase() }}
                                    </a>
                                </template>
                            </el-table-column>

                            <el-table-column label="Paket" prop="paket_kode" sortable="true">
                                <template slot-scope="scope">
                                    <a :href="'{{ url('/') }}/master/paket/latihan/'+scope . row . paket_kode">
                                        @{{ scope . row . paket_kode . toUpperCase() }}
                                    </a>
                                </template>
                            </el-table-column>

                            <el-table-column label="Jumlah Soal" min-width="120%" prop="jumlah_soal" sortable="true">
                                <template slot-scope="scope">

                                    @{{ scope . row . jumlah_soal}}

                                </template>
                            </el-table-column>

                            <el-table-column label="Durasi" prop="durasi" min-width="100%" sortable="true">
                                <template slot-scope="scope">
                                    <span class="h2">
                                        <span class="badge badge-pill badge-primary">
                                            <i class="fas fa-stopwatch">
                                            </i>
                                            <span>
                                                @{{ scope . row . durasi + ' menit' }}
                                            </span>
                                        </span>
                                    </span>

                                </template>
                            </el-table-column>

                            <el-table-column label="Mulai" min-width="100%" prop="start" sortable="true">
                                <template slot-scope="scope">
                                    <div class="d-flex flex-column h2">
                                        <span class="badge badge-pill badge-primary">
                                            <i class="fas fa-calendar-check">
                                            </i>
                                            <span>
                                                @{{ new Date(scope . row . start).toLocaleDateString('id-ID')}}
                                            </span>
                                        </span>

                                        <span class="mt-1 badge badge-pill badge-primary">
                                            <i class="fas fa-clock">
                                            </i>
                                            <span>
                                                @{{ new Date(scope . row . start).toLocaleTimeString('id-ID')}}
                                            </span>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Berakhir" min-width="100%" prop="end" sortable="true">
                                <template slot-scope="scope">
                                    <div class="d-flex flex-column h2">
                                        <span class="badge badge-pill badge-warning">
                                            <i class="fas fa-calendar-check">
                                            </i>
                                            <span>
                                                @{{ new Date(scope . row . end).toLocaleDateString('id-ID')}}
                                            </span>
                                        </span>

                                        <span class="mt-1 badge badge-pill badge-warning">
                                            <i class="fas fa-clock">
                                            </i>
                                            <span>
                                                @{{ new Date(scope . row . end).toLocaleTimeString('id-ID')}}
                                            </span>
                                        </span>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Actions" min-width="100%">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Hapus Soal" placement="top">
                                        <button @@click="confirmDelete(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-danger btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Edit Soal" placement="top">
                                        <button @@click="editSoal(scope.row)" type="button" class="mr-0 mt-1 btn btn-outline-primary btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                        </button>
                                    </el-tooltip>


                                    <el-tooltip class="item" effect="dark" content="Lihat Rangking" placement="top">
                                        <a :href="'{{url('/soal/'.Request::segment(2).'/')}}/'+scope.row.kode+'/rangking'">
                                            <button type="button" class="mr-0 mt-1 btn btn-outline-success btn-sm btn-icon-only">
                                                <span class="btn-inner--icon"><i class="fas fa-chart-line"></i></span>
                                            </button>
                                        </a>

                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Analisis" placement="top">
                                        <a :href="'{{url('/soal/latihan/')}}/'+scope.row.kode+'/analisis'">
                                            <button type="button" class="mr-0 mt-1 btn btn-outline-info btn-sm btn-icon-only">
                                                <span class="btn-inner--icon"><i class="fas fa-chart-pie"></i></span>
                                            </button></a>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Riwayat Pengerjaan Pengguna" placement="top">
                                        @php
                                        $url_users = url('soal/latihan/')
                                        @endphp
                                        <a :href="'{{$url_users}}'+'/'+scope . row . kode+'/users'">
                                            <button type="button" class="mr-0 mt-1 btn btn-outline-info btn-sm btn-icon-only">
                                                <span class="btn-inner--icon">
                                                    <i class="fas fa-users"></i>
                                                </span>
                                            </button></a>
                                    </el-tooltip>
                                </template>
                            </el-table-column> --}}

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm" id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    @{{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: @{{ latihans . length }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3" :click-handler="clickCallback" :prev-text="''" :next-text="''" :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'" :page-link-class="'page-link btn-sm'" :prev-class="'page-item'" :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'" :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current" id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

        </div>

        <confirm-delete v-if="form.delete.confirm" :show-modal="form.delete.confirm" :is-deleting="form.delete.isDeleting" @@onclose="closeConfirmDelete" @@onconfirm="hapusSoal">
        </confirm-delete>

        <div v-if="form.tambah.show" class="d-none" :class="{'d-block':form.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!form.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">
                                    @{{(!form.isEditing)?'Tambah Soal Latihan':'Edit Soal Latihan'}}

                                </span>
                            </h5>
                            <button type="button" class="close" @@click="closeModalTambah">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <div v-if="form.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>
                            <div v-if="!form.isSubmitting">

                                <div class="row">
                                    <div class="col-md-9">
                                        <div class="form-group">
                                            <div class="form-group">
                                                <label for="nama">Nama soal</label>
                                                <input id="nama" v-model.trim="form.data.nama" class="form-control" placeholder="Nama soal" type="text" required>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label for="durasi">Durasi</label>
                                            <input type="number" maxlength="4" min="0" minlength="2" id="durasi" v-model.number="form.data.durasi" class="form-control" placeholder="Durasi" type="text" required>
                                        </div>
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-md-6">
                                        <label>Mulai</label>
                                        <el-date-picker v-model="form.data.start" type="datetime" value-format="timestamp" placeholder="Batas mulai">
                                        </el-date-picker>
                                    </div>

                                    <div class="col-md-6">
                                        <label>Berakhir</label>
                                        <el-date-picker v-model="form.data.end" type="datetime" value-format="timestamp" placeholder="Batas terakhir">
                                        </el-date-picker>

                                    </div>
                                    <small class="form-text text-muted mx-3 mt-2">
                                        <b>Mulai</b> adalah tanggal/ waktu soal dibuka.
                                        <br>
                                        <b>Berakhir</b> adalah batas tanggal/ waktu perangkingan pertama.
                                    </small>
                                </div>

                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="pilih-kelas">Kelas</label>
                                            <!-- <v-select id="pilih-kelas" label="nama" v-model="form.data.kelas" :options="form.kelas" /> -->


                                            <el-select id="pilih-kelas" v-model="form.data.kelas" filterable clearable placeholder="Pilih Kelas">
                                                <el-option v-for="item in form.kelas" :key="item.id" :label="item.nama.toUpperCase()" :value="item.id">
                                                    <span style="float: left">@{{ item.nama.toUpperCase() }}</span>
                                                    <span style="float: right; color: #8492a6; font-size: 13px">@{{ item.tahun }}</span>
                                                </el-option>
                                            </el-select>


                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="pilih-paket">Paket</label>
                                            <!-- <v-select id="pilih-kelas" label="nama" v-model="form.data.paket" :options="form.pakets">
                                            </v-select> -->

                                            <el-select class="w-100" id="pilih-paket" v-model="form.data.paket" filterable clearable placeholder="Pilih Paket Soal">
                                                <el-option v-for="item in form.pakets" :key="item.nama" :label="item.nama.toUpperCase()" :value="item.id">
                                                    <span style="float: left">@{{ item.nama.toUpperCase() }}</span>
                                                    <span style="float: right; color: #8492a6; font-size: 13px">@{{ item.kode }}</span>
                                                </el-option>
                                            </el-select>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                        <div v-if="!form.isSubmitting" class="modal-footer p-3">
                            <button @@click="handleReset(form.isEditing)" class="btn btn-secondary">Reset</button>

                            <button @@click="handleSubmit(form.isEditing)" class="btn btn-primary" :disabled="!cekFormTambah">
                                @{{(form.isEditing)?'Update':'Tambah'}}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

@section('script')
<script src="{{ asset('assets/js/element-ui/index.js') }}"></script>
<script src="{{ asset('assets/js/element-ui/locales/en.js') }}"></script>
<script src="{{ asset('assets/js/element-ui/data-tables.js') }}"></script>

<script src="{{ asset('assets/js/vue-paginate.js') }}"></script>

<script src="{{ asset('assets/js/vue-toast-notification.js') }}"></script>

<script src="{{ asset('assets/js/vue/confirm-delete.js') }}"></script>

<script>
    const base = "{{ url('/') }}/api"

    const tryout_url = base + "/soal/latihan/{{strtolower(Request::segment(3))}}"
    const kelas_url = base + "/kelas"
    const paket_url = base + "/paket/latihan"

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);
    Vue.use(DataTables.DataTables)

    Vue.component('paginate', VuejsPaginate)

    var app = new Vue({
        el: '#panel',
        data: {
            table: {
                header: [],
                props: {

                },
                filters: [{
                    prop: ['nama', 'kelas_nama', 'paket_kode', 'start', 'end', 'jumlah_soal'],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            form: {
                data: {
                    nama: '',
                    durasi: 0,
                    start: '',
                    end: '',
                    kelas: null,
                    paket: null,
                },
                pakets: [],
                kelas: [],
                tambah: {
                    show: false
                },
                isSubmitting: false,
                isEditing: false,
                update: {
                    show: false,
                    index: '',
                    old: {}
                },
                delete: {
                    confirm: false,
                    isDeleting: false,
                    data: {}
                }
            },
            isFailed: false,
            isLoaded: false,
            latihans: []
        },
        methods: {
            timeStamp(time) {
                return Math.ceil(time / 1000)
            },
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            showModalTambah() {
                this.getKelas()
                this.getPakets()
                this.form.tambah.show = true
            },
            closeModalTambah() {
                this.resetFormTambah()
                this.form.isSubmitting = false
                this.form.isEditing = false
                this.form.isDeleting = false
                this.form.tambah.show = false
            },
            handleReset(isEditing) {
                if (isEditing) {
                    this.resetFormUpdate()
                } else {
                    this.resetFormTambah()
                }
            },
            handleSubmit(isEditing) {
                if (!isEditing) {
                    this.insertSoal()
                } else {
                    this.updateSoal()
                }
            },
            resetFormTambah() {
                const data = {
                    nama: '',
                    durasi: 0,
                    start: '',
                    end: '',
                    kelas: null,
                    paket: null
                }

                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            resetFormUpdate() {
                const old = this.form.update.old

                const data = {
                    nama: old.nama,
                    durasi: old.durasi,
                    start: old.start,
                    end: old.end,
                    kelas: old.kelas,
                    paket: old.paket
                }

                Vue.set(this.form, 'data', data)
                this.form.isSubmitting = false
            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                });
            },
            async insertSoal() {
                this.form.isSubmitting = true
                let form = this.form.data

                let data = {
                    nama: form.nama,
                    durasi: form.durasi,
                    start: this.timeStamp(form.start),
                    end: this.timeStamp(form.end),
                    kelas_id: form.kelas,
                    paket_id: form.paket
                }

                await axios
                    .post(tryout_url, data)
                    .then((response) => {
                        const to = response.data.data

                        let dt = {
                            id: to.id,
                            kode: to.kode,
                            nama: to.nama,
                            durasi: to.durasi,
                            kelas_id: to.kelas_id,
                            paket_id: to.paket_id,
                            start: to.start * 1000,
                            end: to.end * 1000,
                            kelas: to.kelas,
                            paket: to.paket,
                            kelas_nama: to.kelas.nama,
                            kelas_kode: to.kelas.kode,
                            paket_nama: to.paket.nama,
                            paket_kode: to.paket.kode,
                            jumlah_soal: to.paket.jumlah_soal,
                        }

                        this.latihans.push(dt)

                        this.showToast(
                            "Berhasil disimpan.", 'info'
                        )
                        this.resetFormTambah()

                    }, (error) => {
                        this.showToast('Gagal disimpan.', 'error')
                    })

            },
            editSoal(row) {
                this.form.isEditing = true
                const update = this.form.update
                let index = this.latihans.indexOf(row)

                this.getKelas()
                this.getPakets()

                update.index = index
                Vue.set(update, 'old', JSON.parse(JSON.stringify(this.latihans[index])))
                Vue.set(this.form, 'data', JSON.parse(JSON.stringify(this.latihans[index])))
                Vue.set(this.form.data, 'kelas', this.latihans[index].kelas.id)
                Vue.set(this.form.data, 'paket', this.latihans[index].paket.id)
                this.form.tambah.show = true
            },
            async updateSoal() {
                this.form.isSubmitting = true

                let form = this.form.data
                const id_to = this.form.update.old.id
                let id = this.latihans.findIndex(function(to) {
                    return to.id == id_to
                })

                let data = {
                    id: id_to,
                    nama: form.nama,
                    durasi: form.durasi,
                    start: this.timeStamp(form.start),
                    end: this.timeStamp(form.end),
                    kelas_id: form.kelas,
                    paket_id: form.paket
                }

                await axios
                    .put(tryout_url, data)
                    .then((response) => {
                        const to = response.data.data

                        let dt = {
                            id: to.id,
                            kode: to.kode,
                            nama: to.nama,
                            durasi: to.durasi,
                            kelas_id: to.kelas_id,
                            paket_id: to.paket_id,
                            start: to.start * 1000,
                            end: to.end * 1000,
                            kelas: to.kelas,
                            paket: to.paket,
                            kelas_nama: to.kelas.nama,
                            kelas_kode: to.kelas.kode,
                            paket_nama: to.paket.nama,
                            paket_kode: to.paket.kode,
                            jumlah_soal: to.paket.jumlah_soal,
                        }
                        Vue.set(this.latihans, id, dt)

                        this.showToast(
                            `Berhasil update`, 'info'
                        )

                        this.form.isSubmitting = false
                        this.closeModalTambah()

                    }, (error) => {
                        this.showToast('Gagal update data', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false
                    })
            },
            cancelUpdate() {
                this.resetFormTambah()
                this.showToast('Batal edit data latihans', 'default')

            },
            confirmDelete(row) {
                this.form.delete.data = row
                this.form.delete.confirm = true
            },
            closeConfirmDelete() {
                this.form.delete.data = {}
                this.form.delete.confirm = false
                this.form.delete.isDeleting = false
            },
            async hapusSoal() {
                this.form.delete.isDeleting = true

                let item = this.form.delete.data
                let id = this.latihans.indexOf(item)

                await axios
                    .delete(tryout_url, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.latihans.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data`, 'info'
                        )

                        this.closeConfirmDelete()

                    }, (error) => {
                        this.showToast('Gagal menghapus data', 'error')

                        this.closeConfirmDelete()
                    })

            },
            async getKelas() {
                await axios
                    .get(kelas_url)
                    .then((response) => {
                        this.form.kelas = response.data.data
                    })
            },
            async getPakets() {
                await axios
                    .get(paket_url)
                    .then((response) => {
                        this.form.pakets = response.data.data
                    })
            },
            async initialLoad() {
                await axios
                    .get(tryout_url)
                    .then((response) => {

                        let data = []

                        response.data.data.forEach(to => {
                            this.latihans.push({
                                id: to.id,
                                kode: to.kode,
                                nama: to.nama,
                                durasi: to.durasi,
                                kelas_id: to.kelas_id,
                                paket_id: to.paket_id,
                                start: to.start * 1000,
                                end: to.end * 1000,
                                kelas_nama: to.kelas.nama,
                                kelas_kode: to.kelas.kode,
                                paket_nama: to.paket.nama,
                                paket_kode: to.paket.kode,
                                kelas: to.kelas,
                                paket: to.paket,
                                jumlah_soal: to.paket.jumlah_soal,
                            })
                        });

                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            cekFormTambah() {
                let tambah = this.form.data

                return (tambah.nama && tambah.durasi && tambah.start && tambah.end && tambah.kelas && tambah.paket)
            },
            numberPages() {
                return Math.ceil(this.latihans.length / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.latihans.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.latihans.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()

        },
        updated() {

            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
@endsection
