<?php $__env->startSection('title'); ?>
Dashboard - Riwayat Latihan
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/css/element-ui/index.css')); ?>" type="text/css">
<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;

    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true"
                v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari Data User" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex"
                @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''"
                    class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
    
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    {{(riwayat.nama)?riwayat.nama.toUpperCase() + ' ('+riwayat.kelas.nama.toUpperCase()+')':''}}
</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="ni ni-ungroup"></i>
</li>
<li class="breadcrumb-item text-white">Riwayat</li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(1))); ?></li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(2))); ?></li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed"
        :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List User</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage"
                            :current-page.sync="table.pagination.current"
                            @current-page-change="handleCurrentPageChange" :filters="table.filters"
                            :table-props="table.props" :data="users" :pagination-props="table.pagination">

                            <el-table-column label="User" min-width="200%" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    <div class="table-user d-flex justify-content-start align-items-center">
                                        <div>
                                            <img v-if="scope . row . avatar" :src="scope . row . avatar"
                                                class="avatar avatar-sm rounded-circle mr-2">

                                            <div v-else
                                                class="align-middle mr-2 avatar avatar-sm bg-primary rounded-circle">
                                                {{ getInitialName(scope . row . nama) }}
                                            </div>
                                        </div>

                                        <div class="h5 text-primary">{{ scope . row . nama . toUpperCase() }}</div>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Email" min-width="200%" prop="email" sortable="true">
                                <template slot-scope="scope">
                                    <span>{{ scope . row . email }}</span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Gender" min-width="100%" prop="nama" sortable="gender">
                                <template slot-scope="scope">
                                    <span class="h3">
                                        <span v-if="scope.row.gender" class="badge badge-pill"
                                            :class="(scope . row . gender == 'laki-laki')?'badge-primary':(scope . row . gender == 'perempuan')?'badge-danger':''">
                                            <i class="fas"
                                                :class="(scope . row . gender == 'laki-laki')?'fa-mars':(scope . row . gender == 'perempuan')?'fa-venus':''"></i>
                                            <span>{{ scope . row . gender . toUpperCase() }}</span>

                                        </span>
                                        <span v-else class="badge badge-pill badge-secondary">
                                            <i class="fas fa-genderless"></i>
                                            <span>Not Set</span>
                                        </span>
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Actions" min-width="100%">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Lihat Riwayat" placement="top">
                                        <?php
                                        $url_riwayat = url('soal/latihan/'.Request::segment(3));
                                        ?>
                                        <a :href="'<?php echo e($url_riwayat); ?>' + '/' + scope.row.id+'/riwayat'">
                                            <button type="button" class="btn btn-outline-primary btn-sm btn-icon-only">
                                                <span class="btn-inner--icon"><i class="fas fa-history"></i></span>
                                            </button></a>
                                    </el-tooltip>
                                </template>
                            </el-table-column>

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm"
                                id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    {{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: {{ users . length }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3"
                                :click-handler="clickCallback" :prev-text="''" :next-text="''"
                                :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'"
                                :page-link-class="'page-link btn-sm'" :prev-class="'page-item'"
                                :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'"
                                :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false"
                                :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current"
                                id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

        </div>
    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>

<script>
    let base_url = "<?php echo e(url('/api/soal/latihan')); ?>"
    let kode = "<?php echo e(Request::segment(3)); ?>"
    let url = base_url + '/' + kode + '/users'

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(DataTables.DataTables)

    Vue.component('paginate', VuejsPaginate)

    var app = new Vue({
        el: '#panel',
        data: {
            table: {
                filters: [{
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            isFailed: false,
            isLoaded: false,
            riwayat: []
        },
        methods: {
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            getInitialName(fullName) {
                    let name = fullName.split(' ')
                    if (name.length > 1) {
                        return `${name[0].charAt(0).toUpperCase()}${name[1].charAt(0).toUpperCase()}`
                    } else {
                        return `${name[0].charAt(0).toUpperCase()}${name[0].charAt(1).toUpperCase()}`
                    }
                },
            async initialLoad() {
                await axios
                    .get(url)
                    .then((response) => {
                        Vue.set(this, 'riwayat', response.data.data)
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            numberPages() {
                return Math.ceil(this.users.length / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.users.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.users.length
                ]
            },
            users(){
                const users = this.riwayat.kelas.users.map(
                    (e, i) =>{
                        return {
                            id:e.id,
                            nama:e.nama,
                            avatar:e.avatar,
                            email:e.email,
                            gender:e.gender
                        }
                    }
                )

                return users
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()

        },
        updated() {

            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/pppk/dashboard/resources/views/dashboard/riwayat/users/latihan.blade.php ENDPATH**/ ?>