<?php $__env->startSection('title'); ?>
Dashboard - Paket Soal Latihan
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/css/element-ui/index.css')); ?>" type="text/css">

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true"
                v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari paket soal" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex"
                @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''"
                    class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    Paket Soal <?php echo e(ucfirst(Request::segment(3))); ?>

</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-paper-plane"></i>
</li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(1))); ?></li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(2))); ?></li>
<li class="breadcrumb-item text-white">
    <?php echo e(ucfirst(Request::segment(3))); ?>

</li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>

<div class="mt-3 d-sm-none"></div>

<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end">

    <download-excel :data="excel.format" :name="'Template Paket Soal'">
        <button class="m-1 btn btn-sm btn-neutral">Download Template</button>
    </download-excel>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed"
        :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-md-8 col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List Paket Soal</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" :page-size.sync="table.pagination.perPage"
                            :current-page.sync="table.pagination.current"
                            @current-page-change="handleCurrentPageChange" :filters="table.filters"
                            :table-props="table.props" :data="pakets" :pagination-props="table.pagination">

                            <el-table-column label="Kode Paket" min-width="100px" prop="kode" sortable="true">
                                <template slot-scope="scope">
                                    {{ scope . row . kode.toUpperCase() }}
                                </template>
                            </el-table-column>

                            <el-table-column label="Nama" min-width="100px" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    {{ scope . row . nama .toUpperCase()  }}
                                </template>
                            </el-table-column>


                            <el-table-column label="Jumlah Soal" min-width="100px" prop="soals_count" sortable="true">
                                <template slot-scope="scope">
                                    {{ scope . row . soals_count }}
                                </template>
                            </el-table-column>

                            <el-table-column label="Pembahasan" min-width="100px">
                                <template slot-scope="scope">
                                    <div v-if="!scope.row.video_pembahasan && !scope.row.doc_pembahasan">
                                        <h4>
                                            <span class="badge badge-pill badge-default">
                                                Tidak tersedia
                                            </span>
                                        </h4>
                                    </div>

                                    <div v-else>

                                        <el-tooltip v-if="scope.row.video_pembahasan" class="item" effect="dark"
                                            content="Video Pembahasan" placement="top">
                                            <button @click="showVideo(scope.row)" type="button"
                                                class="btn btn-outline-danger btn-sm btn-icon-only m-0 mt-1">
                                                <span class="btn-inner--icon"><i class="fab fa-youtube"></i></span>
                                            </button>
                                        </el-tooltip>

                                        <el-tooltip v-if="scope.row.doc_pembahasan" class="item" effect="dark"
                                            content="Pembahasan PDF" placement="top">
                                            <a :href="'https://drive.google.com/file/d/'+scope.row.doc_pembahasan+'/view?usp=sharing'"
                                                target="_blank">
                                                <button type="button"
                                                    class="btn btn-outline-primary btn-sm btn-icon-only m-0 mt-1">
                                                    <span class="btn-inner--icon"><i class="fas fa-file-pdf"></i></span>
                                                </button>
                                            </a>
                                        </el-tooltip>
                                    </div>

                                </template>
                            </el-table-column>

                            <el-table-column label="Actions" min-width="100px">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Hapus Paket Soal" placement="top">
                                        <button @click="confirmDelete(scope.row)" type="button"
                                            class="btn btn-outline-danger btn-sm btn-icon-only m-0 mt-1">
                                            <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Edit Paket Soal" placement="top">
                                        <button @click="editPaket(scope.row)" type="button"
                                            class="btn btn-outline-primary btn-sm btn-icon-only  m-0 mt-1">
                                            <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Lihat Soal" placement="top">
                                        <a :href="'/master/paket/<?php echo e(strtolower(Request::segment(3))); ?>/'+scope.row.kode">
                                            <button type="button"
                                                class="btn btn-outline-success btn-sm btn-icon-only  m-0 mt-1">
                                                <span class="btn-inner--icon"><i class="fas fa-eye"></i></span>
                                            </button>
                                        </a>
                                    </el-tooltip>


                                </template>
                            </el-table-column>

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm"
                                id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    {{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: {{ pakets . length }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3"
                                :click-handler="clickCallback" :prev-text="''" :next-text="''"
                                :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'"
                                :page-link-class="'page-link btn-sm'" :prev-class="'page-item'"
                                :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'"
                                :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false"
                                :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current"
                                id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

            <div class="col-md-4 col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">
                            {{ form . editing ? 'Edit Paket Soal' : 'Tambah Paket Soal' }}
                        </h3>
                    </div>
                    <div class="card-body pb-0">

                        <div v-if="!form.is_submitting">
                            <div class="form-group">
                                <label class="form-control-label" for="nama-paket">Nama Paket</label>
                                <input v-model.trim="form.nama" type="text" class="form-control" id="nama-paket"
                                    placeholder="Masukan nama paket" required>
                            </div>

                            <div class="form-group">
                                <label class="form-control-label" for="youtube-id">YouTube Video ID pembahasan</label>
                                <input v-model.trim="form.video_pembahasan" type="text" class="form-control"
                                    id="youtube-id" placeholder="Masukan YouTube Video ID" required>
                            </div>

                            <div class="form-group">
                                <label class="form-control-label" for="drive-id">GDrive File ID pembahasan</label>
                                <input v-model.trim="form.doc_pembahasan" type="text" class="form-control" id="drive-id"
                                    placeholder="Masukan GDrive File ID" required>
                            </div>

                            <div v-if="!form . editing">
                                <div v-if="form.nama">
                                    <div @click="openFile" class="d-flex justify-content-center div-hover p-3"
                                        style="cursor: pointer;">

                                        <input @change="onFileChange" accept=".xls, .xlsx" type="file" ref="file"
                                            class="d-none">
                                        <span>
                                            <div class="d-flex flex-column">
                                                <div class="d-flex justify-content-center">
                                                    <i v-if="excel . name"
                                                        class="text-primary fas fa-file-excel fa-4x"></i>

                                                    <i v-if="!excel . name" style="color: #ced4da ;"
                                                        class="fas fa-file-medical fa-4x"></i>

                                                </div>
                                                <div class="flex justify-content-around">
                                                    <small class="h5 mt-2">
                                                        {{ !excel . name ? 'Klik disini untuk memilih file' : excel . name }}
                                                    </small>
                                                </div>
                                            </div>
                                        </span>
                                    </div>
                                </div>

                            </div>
                        </div>

                        <div class="d-none" :class="{'d-block':form.is_submitting}" v-if="form.is_submitting">
                            <div class="card-body text-center pt-0">
                                <div class="spinner my-2">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h4 class="mt-4 text-primary">
                                    Sedang menyimpan data..
                                </h4>
                            </div>
                        </div>
                    </div>

                    <div class="card-footer" v-if="!form.is_submitting">
                        <div class="row" v-if="!form.editing">
                            <div class="col">
                                <button type="button" class="btn btn-secondary btn-block" :disabled="!form.nama"
                                    @click="resetFormTambah">Reset</button>
                            </div>

                            <div class="col">
                                <button type="button" class="btn btn-primary btn-block" @click="createPaket"
                                    :disabled="!form.nama || !excel.name">Upload</button>
                            </div>

                        </div>

                        <div class="row" v-if="form.editing">
                            <div class="col pt-4">
                                <button type="button" class="btn btn-secondary btn-block"
                                    @click="cancelUpdate">Batal</button>
                            </div>

                            <div class="col pt-4">
                                <button type="button" class="btn btn-secondary btn-block"
                                    @click="resetFormUpdate">Reset</button>
                            </div>

                            <div class="col pt-4">
                                <button type="button" class="btn btn-primary btn-block"
                                    @click="updatePaket">Update</button>
                            </div>

                        </div>

                    </div>
                </div>
            </div>
        </div>

        <modal-video v-if="modal.video.show" :judul="(modal.video.data.kode+' - '+modal.video.data.nama).toUpperCase()"
            :youtube_id="modal.video.data.video_pembahasan" v-on:close="closeVideo">
        </modal-video>

        <confirm-delete v-if="form.delete.confirm" :show-modal="form.delete.confirm"
            :is-deleting="form.delete.isDeleting" @onclose="closeConfirmDelete" @onconfirm="destroyPaket">
        </confirm-delete>

    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-json-excel.umd.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/xlsx.core.min.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/jszip.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue/confirm-delete.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue/modal-video.js')); ?>"></script>


<script>
    let base_url = "<?php echo e(url('/api/paket')); ?>/<?php echo e(strtolower(Request::segment(3))); ?>"

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);
    Vue.use(DataTables.DataTables)
    Vue.use(XLSX)

    Vue.component('paginate', VuejsPaginate)
    Vue.component('download-excel', JsonExcel)

    var app = new Vue({
        el: '#panel',
        data: {
            modal: {
                video: {
                    show: false,
                    data: {}
                }
            },
            table: {
                filters: [{
                    prop: ['nama', 'soals_count', 'kode'],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            form: {
                nama: '',
                video_pembahasan: '',
                doc_pembahasan: '',
                is_submitting: false,
                editing: false,
                update: {},
                delete: {
                    confirm: false,
                    isDeleting: false,
                    data: {}
                }
            },
            excel: {
                name: '',
                data: [],
                isUploading: false,
                format: [{
                    soal: 'Masukan soal disini, jika terdapat karakter spesial gunakan HTML entities.',
                    a: 'Pilihan A',
                    b: 'Pilihan B',
                    c: 'Pilihan C',
                    d: 'Pilihan D',
                    e: 'Pilihan E',
                    jawaban: `Masukkan jawaban yang benar. Contoh jika jawaban A benar maka masukkan A.`,
                    pembahasan: "Masukan jawaban disini, jika terdapat karakter spesial gunakan HTML entities.",
                    kategori: "Pilih salah satu km, kt, ksk, tbs"
                }]
            },
            isFailed: false,
            isLoaded: false,
            pakets: [{
                nama: "sadasd",
                kode: "asdas",
                video_pembahasan: "sadasd",
                doc_pembahasan: "sd"
            }]

        },
        methods: {
            showVideo(data) {
                let modal = this.modal.video
                modal.data = data
                modal.show = true
            },
            closeVideo() {
                let modal = this.modal.video
                modal.data = {}
                modal.show = false
            },
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            openFile() {
                this.$refs.file.click()
            },
            onFileChange(e) {

                var files = e.target.files || e.dataTransfer.files;
                if (!files.length)
                    return;

                this.excel.tempName = files[0].name

                this.readExcel(files[0]);
            },
            readExcel(file) {
                let reader = new FileReader();

                reader.onload = function(e) {

                    this.excelToJson(e.target.result)

                }.bind(this);

                reader.readAsBinaryString(file);
            },
            excelToJson(file) {
                this.excel.name = this.excel.tempName;

                let workbook = XLSX.read(file, {
                    type: 'binary'
                });

                let firstSheet = workbook.SheetNames[0];

                let excelRows = XLSX.utils.sheet_to_row_object_array(workbook.Sheets[firstSheet]);

                if (!excelRows || excelRows.length == 0) {
                    this.resetExcel()
                    this.showToast('File excel tidak boleh kosong!', 'error')

                } else if (Object.keys(excelRows[0])[0] != 'soal' && Object.keys(excelRows[0])[1] != 'a' && Object.keys(excelRows[0])[2] != 'b' && Object.keys(excelRows[0])[3] != 'c' && Object.keys(excelRows[0])[4] != 'd' && Object.keys(excelRows[0])[5] != 'e' && Object.keys(excelRows[0])[6] != 'jawaban' && Object.keys(excelRows[0])[7] != 'pembahasan' && Object.keys(excelRows[0])[8] != 'kategori') {
                    this.resetExcel()
                    this.showToast('Format template salah!', 'error')
                } else {
                    this.excel.data = excelRows
                    this.showToast('File excel siap di-upload!', 'info')
                }

            },
            exportName() {
                return `Data Kelas Export (${new Date().toLocaleString().replace(/\//g, '-')})`
            },
            resetExcel() {
                this.excel.data = []
                this.excel.name = ''
                this.tempName = ''
            },
            resetFormTambah() {
                this.form.nama = ''
                this.form.video_pembahasan = ''
                this.form.doc_pembahasan = ''
                this.form.is_submitting = false
                this.form.editing = false
                this.form.update = {}
                this.resetExcel()
            },
            resetFormUpdate() {
                this.form.nama = this.form.update.nama
                this.form.video_pembahasan = this.form.update.video_pembahasan
                this.form.doc_pembahasan = this.form.update.doc_pembahasan
                this.form.is_submitting = false
                this.form.editing = true

                this.showToast('Form edit telah direset', 'default')

            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            }

            ,
            async createPaket() {
                this.form.is_submitting = true

                await axios
                    .post(base_url, {
                        paket: {
                            nama: this.form.nama,
                            video_pembahasan: this.form.video_pembahasan,
                            doc_pembahasan: this.form.doc_pembahasan,
                        },
                        soals: this.excel.data

                    })
                    .then((response) => {
                        this.pakets.push(response.data.data)

                        this.showToast(
                            `Berhasil menambah paket.<br>Nama paket: ${response.data.data.nama}`, 'info'
                        )
                        this.resetFormTambah()

                    }, (error) => {
                        this.showToast('Gagal menambah paket', 'error')
                        this.resetFormTambah()
                    })

            },
            editPaket(row) {
                this.form.update = row
                this.form.editing = true
                this.form.nama = row.nama
                this.form.video_pembahasan = row.video_pembahasan
                this.form.doc_pembahasan = row.doc_pembahasan

                this.showToast('Edit data paket soal', 'default')

            },
            async updatePaket() {
                this.form.is_submitting = true
                let id = this.pakets.indexOf(this.form.update)
                await axios
                    .put(base_url, {
                        id: this.form.update.id,
                        nama: this.form.nama,
                        video_pembahasan: this.form.video_pembahasan,
                        doc_pembahasan: this.form.doc_pembahasan,
                    })
                    .then((response) => {
                        Vue.set(this.pakets, id, response.data.data)

                        this.showToast(
                            `Berhasil update paket.`, 'info'
                        )
                        this.resetFormTambah()

                    }, (error) => {
                        this.showToast('Gagal update paket', 'error')
                        this.resetFormTambah()
                    })

            },
            cancelUpdate() {
                this.resetFormTambah()
                this.showToast('Batal edit paket', 'default')

            },
            confirmDelete(row) {
                this.form.delete.data = row
                this.form.delete.confirm = true
            },
            closeConfirmDelete() {
                this.form.delete.data = {}
                this.form.delete.confirm = false
                this.form.delete.isDeleting = false
            },
            async destroyPaket() {
                this.form.delete.isDeleting = true

                let item = this.form.delete.data
                let id = this.pakets.indexOf(item)

                await axios
                    .delete(base_url, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.pakets.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data.`, 'info'
                        )

                        this.closeConfirmDelete()

                    }, (error) => {
                        this.showToast('Gagal menghapus data', 'error')

                        this.closeConfirmDelete()
                    })

            },
            async initialLoad() {
                await axios
                    .get(base_url)
                    .then((response) => {
                        this.pakets = response.data.data
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            numberPages() {
                return Math.ceil(this.pakets.length / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.pakets.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.pakets.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            }
        },
        created() {
            this.initialLoad()
        },
        updated() {
            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/pppk/dashboard/resources/views/dashboard/paket/latihan/index.blade.php ENDPATH**/ ?>