<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="Start your development with a Dashboard for Bootstrap 4.">
    <meta name="author" content="Creative Tim">
    <title>Bimbel DnD - Login</title>
    <!-- Favicon -->
    <link rel="icon" href="../../assets/img/brand/favicon.png" type="image/png">
    <!-- Fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700">
    <!-- Icons -->
    <link rel="stylesheet" href="../../assets/vendor/nucleo/css/nucleo.css" type="text/css">
    
    <!-- Argon CSS -->
    <link rel="stylesheet" href="../../assets/css/argon.min.css?v=1.1.0" type="text/css">

    <style>
        .main-content {
            min-height: 100vh;
        }

        .footer {
            position: absolute;
            width: 95%;
            bottom: 10px;
            height: 0;
        }
    </style>

</head>

<body class="bg-default">

    <div class="main-content">
        <!-- Header -->
        <div class="header bg-gradient-primary py-5 py-lg-6 pt-lg-9">
            <div class="container">
                <div class="header-body text-center mb-6">
                    <div class="row justify-content-center">
                        <div class="col-xl-5 col-lg-6 col-md-8 px-5">
                            <h1 class="text-white">Selamat Datang!</h1>
                            <p class="text-lead text-white">Wujudkan mimpimu lulus seleksi PPPK.</p>
                        </div>
                    </div>
                </div>
            </div>
            <div class="separator separator-bottom separator-skew zindex-100">
                <svg x="0" y="0" viewBox="0 0 2560 100" preserveAspectRatio="none" version="1.1"
                    xmlns="http://www.w3.org/2000/svg">
                    <polygon class="fill-default" points="2560 0 2560 100 0 100"></polygon>
                </svg>
            </div>
        </div>
        <!-- Page content -->
        <div class="container mt--8 pb-5">

            <div class="row justify-content-center">
                <div class="col-lg-5 col-md-7">
                    <div>
                        <?php $__currentLoopData = $errors->all(); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $error): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <span class="alert-icon"><i class="fas fa-times"></i></span>
                            <span class="alert-text">
                                <?php echo e($error); ?>

                            </span>
                        </div>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </div>
                    <div class="card bg-secondary border-0 mb-0">

                        <div class="card-body px-lg-3 py-lg-3">

                            <form role="form" method="POST" action="<?php echo e(route('login')); ?>">
                                <?php echo csrf_field(); ?>
                                <div class="form-group mb-3">
                                    <div class="input-group input-group-merge input-group-alternative">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text"><i class="ni ni-email-83"></i></span>
                                        </div>
                                        <input class="form-control" placeholder="Email" type="email" name="email">
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="input-group input-group-merge input-group-alternative">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text"><i class="ni ni-lock-circle-open"></i></span>
                                        </div>
                                        <input name="password" class="form-control" placeholder="Password"
                                            type="password">
                                    </div>
                                </div>
                                <div class="custom-control custom-control-alternative custom-checkbox">
                                    <input class="custom-control-input" id="remember_me" type="checkbox"
                                        name="remember_me" value="true">
                                    <label class="custom-control-label" for="remember_me">
                                        <span class="text-muted">Ingat saya</span>
                                    </label>
                                </div>
                                <div class="text-center">
                                    <button type="submit" class="btn btn-primary mt-4">Sign in</button>
                                </div>
                            </form>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-6">
                            <?php if(Route::has('password.request')): ?>
                            <a href="<?php echo e(route('password.request')); ?>" class="text-light"><small>Lupa
                                    Password</small></a>
                            <?php endif; ?>


                        </div>
                        <div class="col-6 text-right">
                            <a href="<?php echo e(route('register')); ?>" class="text-light"><small>Daftar akun baru</small></a>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <!-- Footer -->
    <footer class="py-5" id="footer-main">
        <div class="container">
            <div class="row align-items-center justify-content-xl-between">
                <div class="col-xl-6">
                    <div class="copyright text-center text-xl-left text-muted">
                        &copy; <?php echo e(now()->year); ?>

                        <a href="https://www.dosendeso.com" class="font-weight-bold ml-1" target="_blank">DOSENDESO</a>
                    </div>
                </div>
            </div>
        </div>
    </footer>
</body>

</html>
<?php /**PATH D:\Project\Laravel\pppk-bimbel-dnd\resources\views/login.blade.php ENDPATH**/ ?>