

<?php $__env->startSection('title'); ?>
Dashboard - Sesi Zoom
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/vendor/vue-select/vue-select.css')); ?>" type="text/css">

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':search.value||search.focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="search.focus = false" @click="search.focus=true" v-model.trim="search.value"
                class="form-control" placeholder="Cari materi" type="text">

            <div v-if="search.value" class="input-group-append mr-2 d-none d-md-flex" @click="search.value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="search.value" @click="search.value =  ''" class="input-group-text pr-0 pl-2"><i
                        class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    Sesi Zoom</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-play"></i>
</li>
<li class="breadcrumb-item text-white">
    Materi
</li>
<li class="breadcrumb-item text-white">
    Video
</li>
<li class="breadcrumb-item text-white">
    Zoom
</li>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>
<div v-if="isLoaded && !isFailed" class="d-none" :class="{'d-block':isLoaded && !isFailed}">

    <a href="#" class="m-1 btn btn-sm btn-neutral" @click="modal.tambah.show=true">Tambah</a>

    <a href="#" class="m-1 btn btn-sm btn-neutral" @click="sort.show=true">Urutkan</a>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed"
        :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div id="materi-area" class="card mb-0">
            <div class="card-body px-3 pb-0 pt-3">
                <div v-if="!pagePaginated.total" class="row">
                    <div class="col align-self-center">
                        <div v-if="search.value"
                            class="h2 text-danger text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="far fa-sad-tear fa-4x mb-2"></i></span>
                            <p class="display-1 w-900 mb-0"></i> 404 - Not Found</p>

                            <span class="h3 text-default mb-4">Materi yang Anda cari tidak ditemukan</span>

                            <button @click="search.value=''" class="btn btn-outline-primary">
                                Hapus Pencarian
                            </button>

                        </div>

                        <div v-if="!search.value"
                            class="h2 text-danger text-center d-flex flex-column align-items-center m-4 p-4">
                            <span><i class="far fa-sad-tear fa-4x mb-2"></i></span>
                            <p class="display-1 w-900 mb-0"></i> 404 - Not Found</p>

                            <span class="h3 text-default mb-4">Materi belum tersedia</span>

                        </div>
                    </div>
                </div>

                <div v-else class="row">
                    <modal-video v-if="modal.show" :judul="modal.video.judul.toUpperCase()"
                    :youtube_id="modal.video.youtube_id" v-on:close="closeModal">
                </modal-video>
                    <div class="col-sm-6 col-md-3" v-for="(video, index) in pagePaginated.data" :key="index">
                        <div class="card mb-3">

                            <div class="div-hover" v-on:click="showModal(video)">
                                <div class="img-embed-container overlay-container">
                                    <img class="overlay-image card-img-top img-fluid"
                                        :src="'https://img.youtube.com/vi/'+video.youtube_id+'/sddefault.jpg'"
                                        width="400" height="300">
                                    <div class="overlay-middle">
                                        <button type="button" class="btn btn-youtube btn-icon">
                                            <span class="btn-inner--icon"><i class="fab fa-youtube"></i></span>
                                            <span class="btn-inner--text">Play</span>
                                        </button>
                                    </div>
                                </div>
                                <div class="card-body p-2">
                                    <h6 class="h4 card-title mb-0 text-primary text-truncate">
                                        {{ video . judul . toUpperCase() }}
                                    </h6>
                                    <small class="text-muted h6">Uploaded at
                                        {{ unixToDateTime(video . created_at) }}</small>
                                </div>
                            </div>
                            <!-- set a width on the image otherwise it will expand to full width       -->


                            <footer-materi @delete="showDeleteConfirmation(video)" @edit="showUpdateModal(video)">
                            </footer-materi>


                        </div>
                        <!-- /.card -->
                    </div>
                </div>
            </div>

            <div v-if="sortedMateri.length > pagination.perPage">
                <div id="pagination" class="card-footer">
                    <paginate :value="pagination.current" :page-count="pagination.numPages" :page-range="3"
                        :click-handler="onPageChange" :prev-text="''" :next-text="''"
                        :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'"
                        :page-link-class="'page-link btn-sm'" :prev-class="'page-item'"
                        :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'"
                        :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''"
                        :break-view-link-class="'fas fa-ellipsis-h'">
                    </paginate>
                </div>
            </div>


        </div>

        <div v-if="sort.show" class="d-none" :class="{'d-block':sort.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Urutkan Materi </span>
                            </h5>
                            <button type="button" class="close" @click="sort.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <select v-model="sort.by" class="custom-select mb-3">
                                <option disabled value="">Urutkan Bersarkan</option>
                                <option value="judul">Judul Materi</option>
                                <option value="created_at">Tanggal Upload</option>
                            </select>
                            <div class="custom-control custom-radio custom-control-inline">
                                <input v-model="sort.order" type="radio" id="ascending" name="order"
                                    class="custom-control-input" value="asc">
                                <label class="custom-control-label" for="ascending">Ascending</label>
                            </div>
                            <div class="custom-control custom-radio custom-control-inline">
                                <input v-model="sort.order" type="radio" id="descending" name="order"
                                    class="custom-control-input" value="desc">
                                <label class="custom-control-label" for="descending">Descending</label>
                            </div>
                        </div>
                        <div class="modal-footer p-3">
                            <button @click="resetSort" type="button" class="btn btn-secondary"
                                data-dismiss="modal">Reset</button>
                            <button @click="sort.show=false" type="button" class="btn btn-primary">Tutup</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="modal.tambah.show" class="d-none" :class="{'d-block':modal.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!modal.tambah.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Tambah Materi </span>
                            </h5>
                            <button type="button" class="close" @click="modal.tambah.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <div v-if="modal.tambah.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>

                            <div v-if="!modal.tambah.isSubmitting">
                                <div class="form-group">
                                    <label for="add-materi-judul">Judul</label>
                                    <input v-model.trim="modal.tambah.judul" type="text" class="form-control"
                                        id="add-materi-judul" placeholder="Masukkan judul materi">

                                </div>
                                <div class="form-group">
                                    <label for="add-materi-konten">
                                        Youtube ID
                                    </label>
                                    <input v-model.trim="modal.tambah.youtube_id" type="text" class="form-control"
                                        id="add-materi-konten" placeholder="Masukkan ID">
                                </div>


                                <div class="form-group">
                                    <label for="pilih-kelas">
                                        Pilih Kelas
                                    </label>
                                    <v-select id="pilih-kelas" label="nama" multiple
                                        v-model="modal.tambah.select.selected" :options="modal.tambah.select.kelas" />
                                </div>

                            </div>
                        </div>
                        <div v-if="!modal.tambah.isSubmitting" class="modal-footer p-3">
                            <button @click="resetFormTambah" type="button" class="btn btn-secondary"
                                data-dismiss="modal"
                                :disabled="(!modal.tambah.judul && !modal.tambah.youtube_id) || modal.tambah.isSubmitting">Reset</button>
                            <button @click="submitMateri" type="button" class="btn btn-primary"
                                :disabled="(!modal.tambah.judul || !modal.tambah.youtube_id) || modal.tambah.isSubmitting">Tambah</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <confirm-delete v-if="modal.delete.show" :show-modal="modal.delete.show" :is-deleting="modal.delete.isDeleting"
            @onclose="closeDeleteConfirmation" @onconfirm="deleteMateri">
        </confirm-delete>

        

        <div :class="{'d-none':!modal.edit.show}" v-if="modal.edit.show">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header py-2 px-3 align-items-center" v-if="!modal.edit.isSubmitting">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Edit Materi </span>
                            </h5>
                            <button type="button" class="close" v-on:click="closeEditModal">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0 d-flex flex-column">

                            <div v-if="modal.edit.isSubmitting">
                                <div class="spinner">
                                    <div class="rect1 bg-primary"></div>
                                    <div class="rect2 bg-primary"></div>
                                    <div class="rect3 bg-primary"></div>
                                    <div class="rect4 bg-primary"></div>
                                    <div class="rect5 bg-primary"></div>
                                </div>
                                <h3 class="mt-4 mb-5 text-primary text-center">
                                    Sedang menyimpan data..
                                </h3>
                            </div>

                            <div v-if="!modal.edit.isSubmitting">
                                <div class="form-group">
                                    <label for="edit-materi-judul">Judul</label>
                                    <input ref="judul" v-model.trim="modal.edit.data.judul" type="text"
                                        class="form-control" id="edit-materi-judul" placeholder="Masukkan judul materi">

                                </div>
                                <div class="form-group">
                                    <label for="edit-materi-konten">
                                        {{(modal.edit.data.tipe=='video')?'Youtube ID':'Document ID'}}
                                    </label>
                                    <input ref="youtube_id" v-model.trim="modal.edit.data.youtube_id" type="text"
                                        class="form-control" id="edit-materi-konten" placeholder="Masukkan ID">
                                </div>


                                <div class="form-group" v-if="true">
                                    <label for="pilih-kelas">
                                        Pilih Kelas
                                    </label>
                                    <v-select id="pilih-kelas" label="nama" multiple
                                        v-model="modal.tambah.select.selected" :options="modal.tambah.select.kelas" />
                                </div>
                            </div>

                        </div>
                        <div class="modal-footer p-3" v-if="!modal.edit.isSubmitting">
                            
                            <button @click="updateMateri" type="button" class="btn btn-primary"
                                :disabled="!modal.edit.data.judul || !modal.edit.data.youtube_id">Update</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>

<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue/modal-video.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue/confirm-delete.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue/footer-materi.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue/modal-edit-materi.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>
<script src="<?php echo e(asset('assets/vendor/vue-select/vue-select.js')); ?>"></script>

<script>
    let base_url = "<?php echo e(url('/')); ?>/api/materi/zoom"
    let url_kelas = "<?php echo e(url('/')); ?>/api/kelas"
console.log(base_url)
    Vue.use(VueToast);

    Vue.component('paginate', VuejsPaginate)
    Vue.component('v-select', VueSelect.VueSelect);


    var app = new Vue({
        el: '#panel',
        data: {
            pagination: {
                current: 1,
                total: 0,
                perPage: 8,
                numPages: 0
            },
            search: {
                value: '',
                focus: false
            },
            modal: {
                tambah: {
                    show: false,
                    judul: '',
                    youtube_id: '',
                    isSubmitting: false,
                    select: {
                        kelas: [],
                        selected: []
                    }
                },
                edit: {
                    show: false,
                    data: {},
                    isSubmitting: false
                },
                delete: {
                    show: false,
                    isDeleting: false,
                    data: {}
                },

                show: false,
                video: {}
            },
            sort: {
                show: false,
                by: 'judul',
                order: 'asc'
            },
            isFailed: false,
            isLoaded: false,
            materi: {
                data: []
            }
        },
        methods: {
            async getAllMateri() {
                const resp = await axios.get(base_url)
                return resp.data.data
            },
            onPageChange(page) {
                this.pagination.current = page;
            },
            paginator(items, current_page, per_page_items) {
                let page = current_page || 1,
                    per_page = per_page_items || 10,
                    offset = (page - 1) * per_page,

                    paginatedItems = items.slice(offset).slice(0, per_page_items),
                    total_pages = Math.ceil(items.length / per_page);

                this.pagination.numPages = total_pages
                // this.pagination.data = paginatedItems

                return {
                    total: items.length,
                    data: paginatedItems
                }
            },
            showModal(video) {
                this.modal.show = true
                this.modal.video = video
            },
            closeModal() {
                this.modal.show = false
                this.modal.video = {}
                this.modal.tambah.select.selected = []
                this.modal.tambah.select.kelas = []
            },
            sortMateri(data, properti, order) {
                if (order == 'asc' || order == '') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? 1 : -1)
                }
                if (order == 'desc') {
                    return data.sort((a, b) => (a[properti] > b[properti]) ? -1 : 1)
                }
            },
            resetSort() {
                this.sort.by = 'judul'
                this.sort.order = 'asc'
            },
            resetFormTambah() {
                this.modal.tambah.judul = ''
                this.modal.tambah.youtube_id = ''

            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            },
            async submitMateri() {
                this.modal.tambah.isSubmitting = true

                await axios
                    .post(base_url, {
                        judul: this.modal.tambah.judul,
                        youtube_id: this.modal.tambah.youtube_id,
                        kelas: this.modal.tambah.select.selected
                    })
                    .then((response) => {
                        // this.materi.data = response.data.data
                        this.materi.data.push(response.data.data)
                        this.showToast(
                            `Berhasil menambah materi.<br>Judul: ${response.data.data.judul}`, 'info'
                        )
                        this.modal.tambah.select.selected = []
                        this.resetFormTambah()
                        this.modal.tambah.isSubmitting = false

                    }, (error) => {
                        this.showToast('Gagal menambah materi', 'error')
                        this.resetFormTambah()
                        this.modal.tambah.isSubmitting = false
                    })



            },
            showUpdateModal(item) {
                Vue.set(this.modal.edit, "data", item)
                this.modal.edit.show = true
            },
            closeEditModal() {
                this.modal.edit.show = false
                this.modal.edit.isSubmitting = false
                this.modal.edit.data = {}
                this.modal.tambah.select.selected = []
                this.modal.tambah.select.kelas = []
                this.resetFormTambah()
            },
            resetUpdateModal: function() {
                this.$refs.judul.value = this.materi.judul
                this.$refs.youtube_id.value = this.materi.youtube_id
            },
            async updateMateri() {
                let materi = this.modal.edit.data
                this.modal.edit.isSubmitting = true
                let id_materi = this.materi.data.indexOf(materi.data)

                await axios
                    .put(base_url, {
                        id: materi.id,
                        judul: materi.judul,
                        youtube_id: materi.youtube_id,
                        kelas: this.modal.tambah.select.selected
                    })
                    .then((response) => {

                        Vue.set(this.materi.data, id_materi, response.data.data)

                        this.showToast(
                            `Berhasil update materi.<br>Judul: ${response.data.data.judul}`, 'info'
                        )

                        this.closeEditModal()

                    }, (error) => {
                        this.showToast('Gagal update materi', 'error')

                        this.closeEditModal()
                    })

            },
            showDeleteConfirmation(item) {
                this.modal.delete.show = true
                this.modal.delete.data = item
            },
            closeDeleteConfirmation() {
                this.modal.delete.show = false
                this.modal.delete.isDeleting = false
                this.modal.delete.data = {}
            },
            async deleteMateri() {
                this.modal.delete.isDeleting = true

                let item = this.modal.delete.data
                let id_materi = this.materi.data.indexOf(item)

                await axios
                    .delete(base_url, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.materi.data.splice(id_materi, 1)

                        this.showToast(
                            `Berhasil menghapus materi.<br>Judul: ${response.data.data.judul}`, 'info'
                        )

                        this.pagination.total = this.materi.data.length

                        this.closeDeleteConfirmation()

                    }, (error) => {
                        this.showToast('Gagal menghapus materi', 'error')

                        this.closeDeleteConfirmation()
                    })


            },
            async getKelas() {
                let data = []

                await axios
                    .get(url_kelas)
                    .then((response) => {

                        response.data.data.forEach(e => {
                            data.push({
                                id: e.id,
                                nama: e.nama,
                                kode: e.kode
                            })
                        });

                        this.modal.tambah.select.kelas = data
                    }, (error) => {

                    })
            },
            async getKelasOfMateri() {
                let data = []
                await axios
                    .get(`<?php echo e(url('/')); ?>/api/materi/zoom/${this.modal.edit.data.id}/kelas`)
                    .then((response) => {
                        response.data.data.forEach(e => {
                            data.push({
                                id: e.id,
                                nama: e.nama,
                                kode: e.kode
                            })
                        });
                        this.modal.tambah.select.selected = data
                    }, (error) => {

                    })
            },
            async initialLoad() {
                await axios
                    .get(base_url)
                    .then((response) => {
                        this.materi.data = response.data.data
                        this.pagination.total = response.data.data.length
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            },
            unixToDateTime(epoch) {
                let unix = epoch * 1000
                let dt = new Date(unix)

                return dt.toLocaleString('id-ID', {
                    dateStyle: 'short',
                    timeStyle: 'short'
                })

            }
        },
        computed: {
            sortedMateri() {
                let data = [...this.filteredMateri]
                let sorted = [...this.filteredMateri]

                if (this.sort.by) {
                    let data = this.sortMateri(sorted, this.sort.by, this.sort.order)
                    this.pagination.total = data.length

                    return data
                }
                return data
            },
            filteredMateri() {
                let search = this.search.value.toLowerCase().trim()
                let filtered = [...this.materi.data]

                if (!search) return this.materi.data

                return filtered.filter(c => c.judul.toLowerCase().indexOf(search) > -1);
            },
            pagePaginated() {
                let paginated = this.paginator(this.sortedMateri, this.pagination.current, this.pagination
                    .perPage)

                return paginated
            }
        },
        watch: {
            'pagination.numPages'(newVal) {
                if (this.pagination.current > newVal) {
                    this.pagination.current = newVal
                }
            },
            'modal.tambah.show'(newVal) {
                if (newVal) {
                    this.getKelas()
                }
            },
            'modal.edit.show'(newVal) {
                if (newVal) {
                    this.getKelasOfMateri()
                    this.getKelas()
                }
            }
        },
        mounted() {
            this.initialLoad()
        }
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/pppk/dashboard/resources/views/dashboard/materi/admin/zoom.blade.php ENDPATH**/ ?>