<?php $__env->startSection('title'); ?>
Dashboard - Review Hasil Latihan
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">

<style>
    img {
        max-width: 100%;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">
    {{ (review.latihan)?review.latihan.nama.toUpperCase():'' }}
</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-eye"></i>
</li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(1))); ?></li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(2))); ?></li>
<li class="breadcrumb-item text-white">Review</li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>
<div class="mt-3 d-sm-none"></div>
<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end">
    <?php
    $url=url('/soal/latihan').'/'.Request::segment(3);
    $start=url('/ujian/latihan').'/'.Request::segment(3);
    ?>

    <a href="<?php echo e($url.'/riwayat'); ?>">
        <button class="m-1 btn btn-sm btn-neutral">Hasil dan Nilai</button>
    </a>
    <a href="<?php echo e($start.'/start'); ?>">
        <button class="m-1 btn btn-sm btn-neutral">Kerjakan Lagi</button>
    </a>
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div id="app">

    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded">
        <div id="navigasi-soal-fixed" class="d-sm-none">
            <div id="next-prev-fixed" class="fixed-bottom">
                <div class="card card-stats mb-0 text-center">
                    <div class="card-body py-2">
                        <div class="row">
                            <div class="col-6 col-xs-12">
                                <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block" :disabled="currentIndex==0" v-on:click="prevQuestion">
                                    <span class="btn-inner--icon"><i class="fas fa-chevron-left"></i></span>
                                    <span class="btn-inner--text">Prev</span>
                                </button>
                            </div>
                            <div class="col-6 col-xs-12">
                                <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block" :disabled="currentIndex == review.paket.jumlah_soal-1" v-on:click="nextQuestion">
                                    <span class="btn-inner--text">Next</span>
                                    <span class="btn-inner--icon"><i class="fas fa-chevron-right"></i></span>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>

        <div class="row">
            <div class="col-md-9">
                <div class="card">
                    <div class="d-flex justify-content-between align-items-center div-hover card-header bg-secondary" v-on:click="togglePanel('soal')">
                        <div class="d-flex flex-column">
                            <span class="h4 text-primary ">Kategori :
                                {{getKategori(review.paket.soal[currentIndex].kategori)}}</span>
                            <span class="h4 text-primary">
                                <i class="fas fa-stopwatch mr-1">
                                </i>{{convertMenit(review.paket.soal[currentIndex].time)}}

                            </span>
                        </div>

                        <i class="fas text-primary" :class="(control.soal)?'fa-minus-circle':'fa-plus-circle'"></i>
                    </div>

                    <div id="quiz-section" class="card-body collapse" :class="{'show':!control.soal}">
                        <div id="pertanyaan" class="mb-4">
                            <h3>
                                <div class="d-flex flex-row">
                                    <p class="mr-2">
                                        {{ currentIndex + 1 }}.
                                    </p>
                                    <p class="text-justify" v-html="review.paket . soal[currentIndex] . pertanyaan">
                                    </p>
                                </div>
                            </h3>

                            <div id="pilihan">

                                <div v-for="(value, name, index) in review.paket.soal[currentIndex].pilihan" :key="index">

                                    <div class="my-1 p-2 d-flex flex-row align-items-center div-hover" :class="cekJawaban(currentIndex, name).row">
                                        <div class="p-2">{{name.toUpperCase()}}</div>
                                        <div class="p-2">
                                            {{ review.paket.soal[currentIndex] . pilihan[name] . text }}
                                        </div>

                                        <div class="p-2 ml-auto d-flex flex-column align-items-center">
                                            <i class="mb-2" :class="cekJawaban(currentIndex, name).icon"></i>
                                            <span class="h6 my-0">
                                                POIN:
                                            </span>
                                            <span class="h3 my-0">
                                                {{ review.paket.soal[currentIndex] . pilihan[name] . poin }}
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div id="pembahasan-section" class="card">
                    <div class="d-flex justify-content-between align-items-center div-hover card-header bg-secondary" v-on:click="togglePanel('pembahasan')">
                        <h3 class="text-primary">
                            Pembahasan
                        </h3>
                        <i class="fas text-primary" :class="(control.pembahasan)?'fa-minus-circle':'fa-plus-circle'"></i>
                    </div>

                    <div class="card-body collapse" :class="{'show':!control.pembahasan}">
                        <table>
                            <tbody>
                                <tr>
                                    <td>
                                        <h4>Jawaban Anda</h4>
                                    </td>
                                    <td>
                                        <h4>: {{ (review.paket.soal[currentIndex] . jawaban)?review.paket.soal[currentIndex] . jawaban:'Tidak dijawab' }}</h4>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <h4>Kunci Jawaban</h4>
                                    </td>
                                    <td>
                                        <h4>: {{ review.paket.soal[currentIndex] . kunci }}</h4>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

                        <p class="mb-0" v-html="review.paket.soal[currentIndex] .pembahasan">
                        </p>


                    </div>
                </div>
            </div>

            <div id="right-sidebar" class="col-md-3">
                <div id="nomor-soal" class="card">
                    <div class="card-header bg-transparent">
                        <div class="row align-items-center">
                            <div class="col">
                                <h3 class="h3 mb-0">Nomor Soal</h3>
                            </div>
                        </div>
                    </div>
                    <div class="card-body ">
                        <div class="mb-3 d-none d-sm-block">
                            <div class="row">
                                <div class="col-6 col-xs-12">
                                    <button type="button" class="px-1 btn btn-primary btn-md btn-icon btn-block" :disabled="currentIndex==0" v-on:click="prevQuestion">
                                        <span class="btn-inner--icon">
                                            <i class="fas fa-chevron-left"></i>
                                        </span>
                                        <span class="btn-inner--text">
                                            Prev
                                        </span>
                                    </button>
                                </div>
                                <div class="col-6 col-xs-12">
                                    <button type="button" class="px-1 btn btn-primary btn-md  btn-icon  btn-block" :disabled="currentIndex == review.paket.jumlah_soal-1" v-on:click="nextQuestion">
                                        <span class="btn-inner--text">
                                            Next</span>
                                        <span class="btn-inner--icon">
                                            <i class="fas fa-chevron-right"></i>
                                        </span>
                                    </button>
                                </div>
                            </div>
                        </div>

                        <div class="overflow-auto">
                            <div class="d-flex flex-wrap justify-content-center" style="max-height: 11.2rem">
                                <span v-for="index in review.paket.jumlah_soal" :key="index" style="margin-right: 0.15rem !important; margin-left: 0.15rem !important">

                                    <div class="d-sm-none">
                                        <button type="button" class="btn btn-lg  btn-icon-only mb-1" :class="cekJawabanNavigasi(index-1)" @click="toQuestion(index-1)">
                                            <span class="btn-inner--icon">{{ index }}</span>
                                        </button>
                                    </div>

                                    <div class="d-none d-sm-block">
                                        <button @click="toQuestion(index-1)" type="button" class="btn btn-sm  btn-icon-only mb-1" :class="cekJawabanNavigasi(index-1)">
                                            <span class="btn-inner--icon">{{ index }}</span>
                                        </button>

                                    </div>
                                </span>
                            </div>
                        </div>
                    </div>
                </div>

                <div id="info-navigasi" class="card">
                    <div class="d-flex justify-content-between align-items-center div-hover card-header bg-secondary" v-on:click="togglePanel('ket')">
                        <h3>
                            Keterangan
                        </h3>
                        <i class="fas text-primary" :class="(control.ket)?'fa-minus-circle':'fa-plus-circle'"></i>
                    </div>
                    <div class="card-body pb-1 collapse" :class="{'show':!control.ket}">
                        <div class="mb-3">
                            <div class="d-flex  align-items-center">
                                <button type="button" class="btn btn-sm  btn-icon-only mb-1 btn-primary">
                                    <span class="btn-inner--icon">x</span>
                                </button>

                                <h4>
                                    Nomor Sekarang
                                </h4>
                            </div>

                            <div class="d-flex  align-items-center">
                                <button type="button" class="btn btn-sm  btn-icon-only mb-1 btn-success">
                                    <span class="btn-inner--icon">x</span>
                                </button>

                                <h4>Jawaban Benar</h4>
                            </div>

                            <div class="d-flex  align-items-center">
                                <button type="button" class="btn btn-sm  btn-icon-only mb-1 btn-danger">
                                    <span class="btn-inner--icon">x</span>
                                </button>

                                <h4>Jawaban Salah</h4>
                            </div>

                            <div class="d-flex  align-items-center">
                                <button type="button" class="btn btn-sm  btn-icon-only mb-1 btn-outline-primary">
                                    <span class="btn-inner--icon">x</span>
                                </button>

                                <h4>Jawaban Kosong</h4>
                            </div>

                        </div>
                    </div>
                </div>
            </div>

        </div>

    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>

<script>
    let base_url = "<?php echo e(url('/')); ?>/api/paket/<?php echo e(strtolower(Request::segment(3))); ?>/<?php echo e(strtolower(Request::segment(4))); ?>"
    const base = "<?php echo e(url('/api/ujian/latihan')); ?>"
    const kode = "/<?php echo e(Request::segment(3)); ?>"
    const sesi = "/<?php echo e(Request::segment(4)); ?>"

    const review = base + kode + sesi + "/review"

    var app = new Vue({
        el: '#panel',
        data: {
            control: {
                pembahasan: false,
                soal: false,
                ket: false,
                tiu: false,
                twk: false,
                tkp: false,
                waktu: false,
            },
            currentIndex: 0,
            isFailed: false,
            isLoaded: false,
            review: {}
        },
        methods: {
            convertMenit(centisecond) {
                const secs = Math.floor(centisecond / 100)
                const csc = centisecond - (secs * 100)
                const min = Math.floor(secs / 60)
                const sec = secs - (min * 60)

                const str_min = min.toString()
                const str_sec = sec.toString()
                const str_csc = csc.toString()

                const menit = (str_min.length == 1) ? "0" + str_min : str_min
                const detik = (str_sec.length == 1) ? "0" + str_sec : str_sec
                const centidetik = (str_csc.length == 1) ? "0" + str_csc : str_csc

                return menit + ':' + detik + ':' +centidetik
            },
            getKategori(kategori) {
                // let kategori = this.ujian.paket.soal[this.currentIndex].kategori
                if (kategori === 'tiu') {
                    return "Tes Intelegensi Umum (TIU)"
                }

                if (kategori === 'tkp') {
                    return "Tes Karakteristik Pribadi (TKP)"
                }

                if (kategori === 'twk') {
                    return "Tes Wawasan Kebangsaan (TWK)"
                }
            },
            nextQuestion: function() {
                if (this.currentIndex + 1 < this.review.paket.soal.length) {
                    this.currentIndex++
                }
            },
            prevQuestion: function() {
                if (this.currentIndex > 0) {
                    this.currentIndex--
                }
            },
            toQuestion: function(index) {
                this.currentIndex = index
                // console.log(index)
            },
            togglePanel(name) {
                const val = !this.control[name]
                Vue.set(this.control, name, val)
            },
            cekJawaban: function(index, pilihan) {
                let jawaban = this.review.paket.soal[index]

                let jawabanCorrect =
                    jawaban.kunci.charAt(0) == jawaban.jawaban && jawaban.kunci.charAt(0) == pilihan.toUpperCase()

                let currentRowCorrect =
                    jawaban.kunci.charAt(0) == pilihan.toUpperCase()

                let currentRowAnswer =
                    jawaban.jawaban == pilihan.toUpperCase()

                let answerIsCorrect = jawabanCorrect || currentRowCorrect
                let answerIsWrong = !jawabanCorrect && currentRowAnswer

                return {
                    row: {
                        'table-primary': answerIsCorrect,
                        'table-danger': answerIsWrong
                    },
                    icon: {
                        'fas fa-check text-primary': answerIsCorrect,
                        'fas fa-times text-danger': answerIsWrong
                    }
                }
            },
            cekJawabanNavigasi(index) {
                let pilihan = this.review.paket.soal[index]
                let kunci = pilihan.kunci.charAt(0)
                let jawaban = pilihan.jawaban

                let jawabanIsBlank = !jawaban
                let jawabanIsCorrect = jawaban && jawaban === kunci
                let currentPilihan = index === this.currentIndex

                return {
                    'btn-primary': currentPilihan,
                    'btn-success': !currentPilihan && jawabanIsCorrect,
                    'btn-danger': !currentPilihan && !jawabanIsCorrect,
                    'btn-outline-primary': !currentPilihan && jawabanIsBlank
                }

            },
            async initialLoad() {
                await axios
                    .get(review)
                    .then((response) => {

                        Vue.set(this, "review", response.data.data)

                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            },
        },
        computed: {
            getTimeStatus() {
                let review = this.review
                const max = review.latihan.durasi * 60 / review.paket.jumlah_soal
                let time = review.paket.soal[this.currentIndex].time

                return {
                    'text-primary': time <= max && time >= 0,
                    'text-danger': time > max || time == 0
                }
            },
        },
        created: function() {
            this.initialLoad()

        }
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/dosp7473/public_html/pppk/dashboard/resources/views/dashboard/review/latihan.blade.php ENDPATH**/ ?>