<?php $__env->startSection('title'); ?>
Dashboard - Manajemen User
<?php $__env->stopSection(); ?>

<?php $__env->startSection('style'); ?>
<link rel="stylesheet" href="<?php echo e(asset('assets/css/theme-sugar.css')); ?>" type="text/css">
<link rel="stylesheet" href="<?php echo e(asset('assets/css/element-ui/index.css')); ?>" type="text/css">
<style>
    .page-item .page-link {
        width: 2rem;
        height: 2rem;

        font-size: 0.75rem;

    }

    .overlay-container {
        position: relative;
    }

    .overlay-image {
        opacity: 1;
        display: block;

        transition: .5s ease;
        backface-visibility: hidden;
    }

    .overlay-middle {
        transition: .5s ease;
        opacity: 0;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        -ms-transform: translate(-50%, -50%);
        text-align: center;
    }

    .overlay-container:hover .overlay-image {
        opacity: 0.3;
    }

    .overlay-container:hover .overlay-middle {
        opacity: 1;
    }

    .overlay-text {
        background-color: #4CAF50;
        color: white;
        font-size: 16px;
        padding: 16px 32px;
    }
</style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('search-box'); ?>
<div class="navbar-search navbar-search-light form-inline mr-sm-3" id="navbar-search-main">
    <div class="form-group mb-0" :class="{'focused':table.filters[0].value||table.filters[0].focus}">
        <div class="input-group input-group-alternative input-group-merge">
            <div class="input-group-prepend">
                <span class="input-group-text"><i class="fas fa-search"></i></span>
            </div>
            <input @blur.self="table.filters[0].focus = false" @click="table.filters[0].focus=true" v-model.trim="table.filters[0].value" class="form-control" placeholder="Cari Data User" type="text">

            <div v-if="table.filters[0].value" class="input-group-append mr-2 d-none d-md-flex" @click="table.filters[0].value =  ''">
                <button class="input-group-text"><i class="fas fa-backspace"></i></button>
            </div>

            <div class="input-group-append d-md-none d-flex">
                <button v-if="table.filters[0].value" @click="table.filters[0].value =  ''" class="input-group-text pr-0 pl-2"><i class="fas fa-backspace"></i></button>

                <button data-action="search-close" class="mr-2 input-group-text"><i class="fas fa-times"></i></button>
            </div>
        </div>
    </div>
    
</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('mobile-search'); ?>
<?php echo $__env->make('dashboard.components.mobile-search', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-title'); ?>
<h6 class="h2 text-white d-inline-block mb-0">User Manajemen</h6>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('breadcrumb'); ?>
<li class="breadcrumb-item text-white">
    <i class="fas fa-users"></i>
</li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(1))); ?></li>
<li class="breadcrumb-item text-white"><?php echo e(ucfirst(Request::segment(2))); ?></li>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('action-bar'); ?>

<div class="mt-3 d-sm-none"></div>

<div v-if="isLoaded && !isFailed" class="d-flex justify-content-end d-none" :class="{'d-block':isLoaded && !isFailed}">

    <button @click="form.tambah.show = true" class="m-1 btn btn-sm btn-neutral">Tambah</button>

    <div class="dropdown">
        <button class="m-1 btn btn-sm btn-neutral dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Export
        </button>

        <div class="dropdown-menu" style="min-width: 10rem" aria-labelledby="dropdownMenuButton">

            <download-excel :fetch="getUsers" :name="'Export Data User '+new Date().toLocaleString().replace(/\//g, '-')">
                <a class="dropdown-item" href="#">Semua Data</a>
            </download-excel>

            <download-excel :data="excel.format" :name="'Template Data User'">
                <a class="dropdown-item" href="#">Template</a>
            </download-excel>
        </div>
    </div>

    <button @click="excel.modal = true" class="m-1 btn btn-sm btn-neutral">Import</button>

</div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
<div class="mb-4">
    <div class="d-flex justify-content-center" v-if="!isLoaded && !isFailed" :class="{'d-none' : isLoaded && !isFailed}">
        <div class="col-12 card">
            <div class="card-body text-center">
                <div class="spinner">
                    <div class="rect1 bg-primary"></div>
                    <div class="rect2 bg-primary"></div>
                    <div class="rect3 bg-primary"></div>
                    <div class="rect4 bg-primary"></div>
                    <div class="rect5 bg-primary"></div>
                </div>
                <h4 class="mt-4 text-primary">
                    Sedang memuat data..
                </h4>
            </div>
        </div>
    </div>

    <div class="d-flex justify-content-center d-none" :class="{'d-block':isFailed}" v-if="isFailed">
        <div class="col-12 card">
            <div class="card-body text-center text-warning">
                <i class="mt-4 fas fa-exclamation-triangle fa-5x"></i>
                <h4 class="mt-4 text-warning">
                    Gagal memuat data. Silahkan refresh halaman.
                </h4>
            </div>
        </div>
    </div>

    <div v-if="isLoaded" class="d-none" :class="{'d-block':isLoaded}">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="text-primary">List User</h3>
                    </div>
                    <div class="card-body">
                        <data-tables ref="dt" style="width: 100%" :page-size.sync="table.pagination.perPage" :current-page.sync="table.pagination.current" @current-page-change="handleCurrentPageChange" :filters="table.filters" :table-props="table.props" :data="users" :pagination-props="table.pagination">

                            <el-table-column label="User" min-width="200%" prop="nama" sortable="true">
                                <template slot-scope="scope">
                                    <div class="table-user d-flex justify-content-start align-items-center">
                                        <div>
                                            <img v-if="scope . row . avatar" :src="scope . row . avatar" class="avatar avatar-sm rounded-circle mr-2">

                                            <div v-else class="align-middle mr-2 avatar avatar-sm bg-primary rounded-circle">
                                                {{ getInitialName(scope . row . nama) }}
                                            </div>
                                        </div>

                                        <div class="h5 text-primary">{{ scope . row . nama . toUpperCase() }}</div>
                                    </div>
                                </template>
                            </el-table-column>

                            <el-table-column label="Email" min-width="200%" prop="email" sortable="true">
                                <template slot-scope="scope">
                                    <span>{{ scope . row . email }}</span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Gender" min-width="100%" prop="nama" sortable="gender">
                                <template slot-scope="scope">
                                    <span class="h3">
                                        <span v-if="scope.row.gender" class="badge badge-pill" :class="(scope . row . gender == 'laki-laki')?'badge-primary':(scope . row . gender == 'perempuan')?'badge-danger':''">
                                            <i class="fas" :class="(scope . row . gender == 'laki-laki')?'fa-mars':(scope . row . gender == 'perempuan')?'fa-venus':''"></i>
                                            <span>{{ scope . row . gender . toUpperCase() }}</span>

                                        </span>
                                        <span v-else class="badge badge-pill badge-secondary">
                                            <i class="fas fa-genderless"></i>
                                            <span>Not Set</span>
                                        </span>
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Akses" min-width="100%" prop="role" sortable="role">
                                <template slot-scope="scope">
                                    <span class="h3">
                                        <span class="badge badge-pill" :class="(scope . row . role == 'admin')?'badge-primary':(scope . row . role == 'user')?'badge-warning':''">
                                            {{ scope . row . role . toUpperCase() }}
                                        </span>
                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Status" min-width="100%" prop="verified" sortable="verified">
                                <template slot-scope="scope">
                                    <span class="h3">
                                        <span class="badge badge-pill" :class="(scope . row . verified)?'badge-primary':'badge-danger'">
                                            <i class="fas" :class="(scope . row . verified)?'fa-user-check':'fa-user-times'"></i>
                                            <span>{{ scope . row . verified?'VERIFIED':'NOT VERIFIED' }}</span>

                                        </span>

                                    </span>
                                </template>
                            </el-table-column>

                            <el-table-column label="Active" min-width="80%" prop="active" sortable="true">
                                <template slot-scope="scope">
                                    <label class="custom-toggle d-flex align-item-center">
                                        <input type="checkbox" @change="toggleActive(scope.row)" v-model="scope . row . active">
                                        <span class="custom-toggle-slider rounded-circle" data-label-off="No" data-label-on="Yes"></span>
                                    </label>
                                </template>
                            </el-table-column>

                            <el-table-column label="Actions" min-width="100%">
                                <template slot-scope="scope">
                                    <el-tooltip class="item" effect="dark" content="Hapus akun" placement="top">
                                        <button @click="confirmDelete(scope.row)" type="button" class="mr-0 btn btn-outline-danger btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-trash"></i></span>
                                        </button>
                                    </el-tooltip>

                                    <el-tooltip class="item" effect="dark" content="Edit Akun" placement="top">
                                        <button @click="editUser(scope.row)" type="button" class="btn btn-outline-primary btn-sm btn-icon-only">
                                            <span class="btn-inner--icon"><i class="fas fa-pencil-alt"></i></span>
                                        </button>
                                    </el-tooltip>
                                </template>
                            </el-table-column>

                        </data-tables>
                    </div>

                    <div class="card-footer d-flex  justify-content-around align-items-end pt-2">

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="perpage">Item/Halaman</label>

                            <select id="perpage" v-model="table.pagination.perPage" class="form-control form-control-sm" id="inlineFormCustomSelect">
                                <option v-for="item in pageSizes.length" :key="item" :value="pageSizes[item-1]">
                                    {{ pageSizes[item - 1] + '/page' }}</option>
                            </select>
                        </div>

                        <div class="col-md-8 col-sm-12 d-flex flex-column justify-content-center text-center">
                            <h5>Jumlah data: {{ users . length }}</h5>
                            <paginate :value="table.pagination.current" :page-count="numberPages" :page-range="3" :click-handler="clickCallback" :prev-text="''" :next-text="''" :container-class="'pagination justify-content-center mb-0'" :page-class="'page-item'" :page-link-class="'page-link btn-sm'" :prev-class="'page-item'" :prev-link-class="'fas fa-angle-left page-link'" :next-class="'page-item'" :next-link-class="'fas fa-angle-right page-link'" :hide-prev-next="false" :break-view-text="''" :break-view-link-class="'fas fa-ellipsis-h'">
                            </paginate>
                        </div>

                        <div class="col-md-2 col-sm-6 px-2 d-flex flex-column">
                            <label class="h5" for="to-page">Ke Halaman</label>
                            <input type="number" min="1" max="numberPage" v-model.number="table.pagination.current" id="to-page" class="form-control form-control-sm">
                        </div>

                    </div>
                </div>
            </div>

        </div>

        <confirm-delete v-if="form.delete.confirm" :show-modal="form.delete.confirm" :is-deleting="form.delete.isDeleting" @onclose="closeConfirmDelete" @onconfirm="destroyUser">
        </confirm-delete>

        <div v-if="form.tambah.show" class="d-none" :class="{'d-block':form.tambah.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!form.tambah.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Tambah User </span>
                            </h5>
                            <button type="button" class="close" @click="form.tambah.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <form @submit.prevent="createUser">
                            <div class="modal-body px-3 pt-3 pb-0">
                                <div v-if="form.isSubmitting">
                                    <div class="spinner">
                                        <div class="rect1 bg-primary"></div>
                                        <div class="rect2 bg-primary"></div>
                                        <div class="rect3 bg-primary"></div>
                                        <div class="rect4 bg-primary"></div>
                                        <div class="rect5 bg-primary"></div>
                                    </div>
                                    <h3 class="mt-4 mb-5 text-primary text-center">
                                        Sedang menyimpan data..
                                    </h3>
                                </div>
                                <div v-if="!form.isSubmitting">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text"><i class="fas fa-user"></i></span>
                                                    </div>
                                                    <input v-model.trim="form.tambah.nama" class="form-control" placeholder="Nama lengkap" type="text" required>
                                                </div>
                                            </div>
                                        </div>

                                    </div>
                                    <div class="row">
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">
                                                            <i class="fas fa-envelope"></i>
                                                        </span>
                                                    </div>
                                                    <input v-model="form.tambah.email" class="form-control" placeholder="Alamat Email" type="email" required autocomplete="off">
                                                </div>

                                                <small v-if="form.emailTaken" class="form-text text-danger">Email sudah
                                                    digunakan</small>

                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <input minlength="8" v-model.trim="form.tambah.password" class="form-control" placeholder="Password" :type="form.showPassword?'text':'password'" required autocomplete="off">
                                                    <div class="input-group-append" @click="form.showPassword = !form.showPassword ">
                                                        <span class="input-group-text"><i class="fas" :class="(form.showPassword)?'fa-eye':'fa-eye-slash'"></i></span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row align-items-center">
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">
                                                            <i class="fas fa-user-tag"></i>
                                                        </span>
                                                    </div>

                                                    <select class="custom-select mr-sm-2" v-model="form.tambah.role">
                                                        <option selected disabled>Hak Akses</option>
                                                        <option value="admin">Admin</option>
                                                        <option value="user">User</option>
                                                    </select>


                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group d-flex ">
                                                <span class="text-gray mr-4" style="font-size: 0.9rem;">Atifkan
                                                    user</span>
                                                <span>
                                                    <label class="custom-toggle">
                                                        <input v-model="form.tambah.active" type="checkbox">
                                                        <span class="custom-toggle-slider rounded-circle" data-label-off="No" data-label-on="Yes"></span>
                                                    </label>
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div v-if="!form.isSubmitting" class="modal-footer p-3">
                                <button @click="resetFormTambah" class="btn btn-secondary" :disabled="false">Reset</button>
                                <button type="submit" class="btn btn-primary" :disabled="!cekFormTambah">Tambah</button>
                            </div>
                        </form>

                    </div>
                </div>
            </div>
        </div>

        <div v-if="form.update.show" class="d-none" :class="{'d-block':form.update.show}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!form.tambah.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle"> Edit User </span>
                            </h5>
                            <button type="button" class="close" @click="form.update.show=false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>

                        <form @submit.prevent="updateUser">
                            <div class="modal-body px-3 pt-3 pb-0">
                                <div v-if="form.isSubmitting">
                                    <div class="spinner">
                                        <div class="rect1 bg-primary"></div>
                                        <div class="rect2 bg-primary"></div>
                                        <div class="rect3 bg-primary"></div>
                                        <div class="rect4 bg-primary"></div>
                                        <div class="rect5 bg-primary"></div>
                                    </div>
                                    <h3 class="mt-4 mb-5 text-primary text-center">
                                        Sedang menyimpan data..
                                    </h3>
                                </div>
                                <div v-if="!form.isSubmitting">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text"><i class="fas fa-user"></i></span>
                                                    </div>
                                                    <input v-model.trim="form.update.new.nama" class="form-control" placeholder="Nama lengkap" type="text" required>
                                                </div>
                                            </div>
                                        </div>

                                    </div>
                                    <div class="row">
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">
                                                            <i class="fas fa-envelope"></i>
                                                        </span>
                                                    </div>
                                                    <input v-model="form.update.new.email" class="form-control" placeholder="Alamat Email" type="email" required autocomplete="off">
                                                </div>

                                                <small v-if="form.emailTaken" class="form-text text-danger">Email sudah
                                                    digunakan</small>

                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <input v-model.trim="form.update.new.password" class="form-control" placeholder="Password" :type="form.showPassword?'text':'password'" autocomplete="off">
                                                    <div class="input-group-append" @click="form.showPassword = !form.showPassword ">
                                                        <span class="input-group-text"><i class="fas" :class="(form.showPassword)?'fa-eye':'fa-eye-slash'"></i></span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <!-- Input groups with icon -->
                                    <div class="row align-items-center">
                                        <div class="col-md-6">
                                            <div class="form-group">
                                                <div class="input-group input-group-merge">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">
                                                            <i class="fas fa-user-tag"></i>
                                                        </span>
                                                    </div>

                                                    <select class="custom-select mr-sm-2" v-model="form.update.new.role">
                                                        <option selected disabled>Hak Akses</option>
                                                        <option value="admin">Admin</option>
                                                        <option value="user">User</option>
                                                    </select>

                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-group d-flex ">
                                                <span class="text-gray mr-4" style="font-size: 0.9rem;">Atifkan
                                                    user</span>
                                                <span>
                                                    <label class="custom-toggle">
                                                        <input v-model="form.update.new.active" type="checkbox">
                                                        <span class="custom-toggle-slider rounded-circle" data-label-off="No" data-label-on="Yes"></span>
                                                    </label>
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div v-if="!form.isSubmitting" class="modal-footer p-3">
                                <button @click="resetFormUpdate" class="btn btn-secondary" :disabled="false">Reset</button>
                                <button type="submit" class="btn btn-primary">Update</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="excel.modal" class="d-none" :class="{'d-block':excel.modal}">
            <div class="modal fade show modal-active" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-sm modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div v-if="!form.isSubmitting" class="modal-header py-2 px-3 align-items-center">
                            <h5 class="modal-title">
                                <span class="text-primary align-middle">Import </span>
                            </h5>
                            <button type="button" class="close" @click="excel.modal = false">
                                <i class="fas fa-times-circle text-primary"></i>
                            </button>
                        </div>
                        <div class="modal-body px-3 pt-3 pb-0">
                            <div v-if="!excel.isUploading">

                                <div @click="openFile" class="d-flex justify-content-center div-hover p-3" style="cursor: pointer;">

                                    <input @change="onFileChange" accept=".xls, .xlsx" type="file" ref="file" class="d-none">
                                    <span>
                                        <div class="d-flex flex-column">
                                            <div class="d-flex justify-content-center">
                                                <i v-if="excel . name" class="text-primary fas fa-file-excel fa-4x"></i>

                                                <i v-if="!excel . name" style="color: #ced4da ;" class="fas fa-file-medical fa-4x"></i>

                                            </div>
                                            <div class="flex justify-content-around">
                                                <small class="h5 mt-2">
                                                    {{ !excel . name ? 'Klik disini untuk memilih file' : excel . name }}
                                                </small>
                                            </div>
                                        </div>
                                    </span>
                                </div>

                            </div>

                            <div class="d-none" :class="{'d-block':excel.isUploading}" v-if="excel.isUploading">
                                <div class="card-body text-center pt-0">
                                    <div class="spinner my-2">
                                        <div class="rect1 bg-primary"></div>
                                        <div class="rect2 bg-primary"></div>
                                        <div class="rect3 bg-primary"></div>
                                        <div class="rect4 bg-primary"></div>
                                        <div class="rect5 bg-primary"></div>
                                    </div>
                                    <h4 class="mt-4 text-primary">
                                        Sedang menyimpan data..
                                    </h4>
                                </div>
                            </div>

                        </div>
                        <div v-if="!excel.isUploading" class="modal-footer p-3">
                            <button @click="resetExcel" type="button" class="btn btn-secondary" data-dismiss="modal" :disabled="(!excel.name && excel.data) || excel.isUploading">Reset</button>
                            <button @click="uploadExcel" type="button" class="btn btn-primary" :disabled="(!excel.name || !excel.data) || excel.isUploading">Upload</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>
</div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('script'); ?>
<script src="<?php echo e(asset('assets/js/element-ui/index.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/locales/en.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/element-ui/data-tables.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-json-excel.umd.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/xlsx.core.min.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/jszip.js')); ?>"></script>

<script src="<?php echo e(asset('assets/js/vue-paginate.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue-toast-notification.js')); ?>"></script>
<script src="<?php echo e(asset('assets/js/vue/confirm-delete.js')); ?>"></script>

<script>
    let base_url = "<?php echo e(url('/')); ?>/api/user"

    ELEMENT.locale(ELEMENT.lang.en)
    Vue.use(VueToast);
    Vue.use(DataTables.DataTables)
    Vue.use(XLSX)

    Vue.component('paginate', VuejsPaginate)
    Vue.component('download-excel', JsonExcel)

    var app = new Vue({
        el: '#panel',
        data: {
            table: {
                header: [],
                props: {

                },
                filters: [{
                    prop: ['nama', 'email', 'gender', 'role', 'active'],
                    value: '',
                    focus: false
                }],
                pagination: {
                    pageSizes: [10, 30, 50],
                    current: 1,
                    perPage: 10
                }
            },
            form: {
                emailTaken: false,
                tambah: {
                    show: false,
                    nama: '',
                    role: '',
                    email: '',
                    password: '',
                    role: 'user',
                    active: false
                },
                showPassword: false,
                isSubmitting: false,
                update: {
                    show: false,
                    index: '',
                    old: {},
                    new: {}
                },
                delete: {
                    confirm: false,
                    isDeleting: false,
                    data: {}
                }
            },
            excel: {
                modal: false,
                name: '',
                data: [],
                isUploading: false,
                format: [{
                    nama: 'Masukkan nama lengkap',
                    email: 'Alamat email',
                    password: 'Password',
                    role: 'Pilih salah satu [admin, user]',
                    active: 'Pilih 1 untuk status active, 0 untuk non active'
                }]
            },
            isFailed: false,
            isLoaded: false,
            users: []
        },
        methods: {
            clickCallback(page) {
                this.table.pagination.current = page
            },
            handleCurrentPageChange(page) {
                this.table.pagination.current = page
            },
            openFile() {
                this.$refs.file.click()
            },
            onFileChange(e) {

                var files = e.target.files || e.dataTransfer.files;
                if (!files.length)
                    return;

                this.excel.tempName = files[0].name

                this.readExcel(files[0]);
            },
            readExcel(file) {
                let reader = new FileReader();

                reader.onload = function(e) {

                    this.excelToJson(e.target.result)

                }.bind(this);

                reader.readAsBinaryString(file);
            },
            excelToJson(file) {
                this.excel.name = this.excel.tempName;

                let workbook = XLSX.read(file, {
                    type: 'binary'
                });

                let firstSheet = workbook.SheetNames[0];

                let excelRows = XLSX.utils.sheet_to_row_object_array(workbook.Sheets[firstSheet]);

                if (!excelRows || excelRows.length == 0) {
                    this.resetExcel()
                    this.showToast('File excel tidak boleh kosong!', 'error')

                } else if (Object.keys(excelRows[0])[0] != 'nama' && Object.keys(excelRows[0])[1] != 'email' &&
                    Object.keys(excelRows[0])[2] != 'password' && Object.keys(excelRows[0])[3] != 'role' &&
                    Object.keys(excelRows[0])[4] != 'active') {
                    this.resetExcel()
                    this.showToast('Format template salah!', 'error')
                } else {
                    this.excel.data = excelRows
                    this.showToast('File excel siap di-upload!', 'info')
                }

            },
            resetExcel() {
                this.excel.data = []
                this.excel.name = ''
                this.tempName = ''
            },
            async getUsers() {
                const resp = await axios.get(base_url)
                return resp.data.data
            },
            resetFormTambah() {
                let tambah = this.form.tambah

                tambah.nama = ''
                tambah.email = ''
                tambah.password = ''
                tambah.role = 'user'
                tambah.active = false
                this.form.isSubmitting = false
            },
            resetFormUpdate() {
                const update = this.form.update
                update.new = Object.assign({}, update.old)

                this.showToast("Form update direset", 'default')
            },
            showToast(msg, type) {
                Vue.$toast.open({
                    message: msg,
                    type: type,
                    // all of other options may go here
                });
            },
            async uploadExcel() {
                this.excel.isUploading = true

                let excel = this.excel.data

                await axios
                    .post(base_url + "/array", {
                        data: excel
                    })
                    .then((response) => {
                        let data = this.users.concat(response.data.data)

                        this.users = data

                        this.showToast(
                            `Berhasil menambah ${response.data.data.length} data users`,
                            'info'
                        )
                        this.excel.isUploading = false
                        this.resetExcel()

                    }, (error) => {

                        this.showToast('Gagal menambah data users', 'error')

                        this.resetExcel()
                        this.excel.isUploading = false
                    })
            },
            createUser() {
                this.form.isSubmitting = true
                setTimeout(() => {
                    axios
                        .post(base_url, this.form.tambah)
                        .then((response) => {
                            this.users.push(response.data.data)

                            this.showToast(
                                `Berhasil menambah users.<br>Nama User: ${response.data.data.nama}`,
                                'info'
                            )
                            this.resetFormTambah()

                        }, (error) => {
                            this.showToast('Gagal menambah data user', 'error')
                            this.resetFormTambah()
                        })
                }, 1000)
            },
            editUser(row) {
                const update = this.form.update
                let index = this.users.indexOf(row)

                update.index = index
                update.old = Object.assign({}, this.users[index])
                update.new = Object.assign({}, this.users[index])
                update.show = true

                this.showToast(`Edit data user <br> Nama: ${row.nama}<br> Email: ${row.email}`, 'default')
            },
            async updateUser() {
                const up = this.form.update
                this.form.isSubmitting = true

                await axios
                    .put(base_url, this.form.update.new)
                    .then((response) => {
                        const resp = response.data.data

                        this.users[up.index].active = resp.active
                        this.users[up.index].alamat = resp.alamat
                        this.users[up.index].avatar = resp.avatar
                        this.users[up.index].email = resp.email
                        this.users[up.index].gender = resp.gender
                        this.users[up.index].nama = resp.nama
                        this.users[up.index].no_wa = resp.no_wa
                        this.users[up.index].role = resp.role
                        this.users[up.index].tgl_lahir = resp.tgl_lahir
                        this.users[up.index].updated_at = resp.updated_at

                        this.showToast(
                            `Berhasil update users.<br>Nama User: ${resp.nama}`,
                            'info'
                        )

                        this.form.isSubmitting = false
                        this.form.update.show = false
                        up.index = ''
                        this.form.update.old = {}
                        this.form.update.new = {}

                    }, (error) => {
                        this.showToast('Gagal update data users', 'error')
                        this.form.isSubmitting = false
                        this.form.update.show = false

                        up.index = ''
                        this.form.update.old = {}
                        this.form.update.new = {}
                    })

            },
            cancelUpdate() {
                this.resetFormTambah()
                this.showToast('Batal edit data users', 'default')

            },
            confirmDelete(row) {
                this.form.delete.data = row
                this.form.delete.confirm = true
            },
            closeConfirmDelete() {
                this.form.delete.data = {}
                this.form.delete.confirm = false
                this.form.delete.isDeleting = false
            },
            async destroyUser() {
                this.form.delete.isDeleting = true

                let item = this.form.delete.data
                let id = this.users.indexOf(item)

                await axios
                    .delete(base_url, {
                        data: {
                            id: item.id
                        }
                    })
                    .then((response) => {
                        this.users.splice(id, 1)

                        this.showToast(
                            `Berhasil menghapus Data.<br>User: ${response.data.data.nama}`,
                            'info'
                        )

                        this.closeConfirmDelete()

                    }, (error) => {
                        this.showToast('Gagal menghapus data users', 'error')

                        this.closeConfirmDelete()
                    })
            },
            async toggleActive(row) {
                const index = this.users.indexOf(row)
                await axios
                    .put(`${base_url}/toogle-active`, {
                        id: this.users[index].id,
                        active: !this.users[index].active
                    })
                    .then((response) => {

                        Vue.set(this.users, index, response.data.data)

                        this.showToast('Berhasil ubah status user', 'info')
                    }, (error) => {
                        this.showToast('Gagal ubah status user', 'error')
                    })

            },
            getInitialName(fullName) {
                let name = fullName.split(' ')
                if (name.length > 1) {
                    return `${name[0].charAt(0).toUpperCase()}${name[1].charAt(0).toUpperCase()}`
                } else {
                    return `${name[0].charAt(0).toUpperCase()}${name[0].charAt(1).toUpperCase()}`
                }
            },
            async cekEmail(email) {
                const data = await axios.get(base_url + '/email', {
                    params: {
                        email: email
                    }
                }).then((resp) => resp.data.data)

                if (data) {
                    return true
                } else {
                    return false
                }
            },
            async initialLoad() {
                await axios
                    .get(base_url)
                    .then((response) => {
                        this.users = response.data.data
                        this.isLoaded = true

                    }, (error) => {
                        this.isLoaded = false
                        this.isFailed = true
                    })
            }
        },
        computed: {
            cekFormTambah() {
                let tambah = this.form.tambah
                return (tambah.nama && tambah.email && tambah.password && !this.form.emailTaken) ? true : false
            },
            kodeKelas() {

                if (!this.form.nama) {
                    return ''
                }

                return `${this.form.tahun}-${this.form.nama.replace(/\s+/g, '-').toLowerCase()}`
            },
            exportName() {
                return `Data Kelas Export (${new Date().toLocaleString().replace(/\//g, '-')})`
            },
            numberPages() {
                return Math.ceil(this.users.length / this.table.pagination.perPage)
            },
            pageSizes() {
                if (this.users.length > 100) {
                    return [
                        5, 10, 30, 50, 100
                    ]
                }

                return [
                    5, 10, 30, 50, this.users.length
                ]
            }
        },
        watch: {
            'table.pagination.current'(newVal) {
                if (!newVal || newVal == 0) {
                    this.table.pagination.current = 1
                }
                if (newVal > this.numberPages) {
                    this.table.pagination.current = this.numberPages
                }
            },
            async 'form.tambah.email'(newVal) {
                let taken = await this.cekEmail(newVal)

                this.form.emailTaken = taken
            }
        },
        created() {

            this.initialLoad()
            this.form.tahun = new Date().getFullYear()

        },
        updated() {

            if (this.$refs.dt.$refs.elPagination) {
                this.$refs.dt.$refs.elPagination.$el.className = 'd-none'
            }
        },
    })
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('dashboard.components.layout', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH D:\Project\Laravel\pppk-bimbel-dnd\resources\views/dashboard/akun/index.blade.php ENDPATH**/ ?>